from __future__ import annotations
import typing
import typing_extensions
__all__ = ['AccelerometerRange', 'AddressableLEDColorOrder', 'AddressableLEDData', 'AllianceStationID', 'AnalogTriggerType', 'CANDeviceType', 'CANManufacturer', 'CANStreamMessage', 'CAN_CloseStreamSession', 'CAN_GetCANStatus', 'CAN_OpenStreamSession', 'CAN_ReceiveMessage', 'CAN_SendMessage', 'ControlWord', 'CounterMode', 'EncoderEncodingType', 'EncoderIndexingType', 'HAL_GetRadioLEDState', 'HAL_RadioLEDState', 'HAL_SetRadioLEDState', 'HandleEnum', 'I2CPort', 'JoystickAxes', 'JoystickButtons', 'JoystickDescriptor', 'JoystickPOVs', 'MatchInfo', 'MatchType', 'PowerDistributionFaults', 'PowerDistributionStickyFaults', 'PowerDistributionType', 'PowerDistributionVersion', 'REVPHCompressorConfig', 'REVPHCompressorConfigType', 'REVPHFaults', 'REVPHStickyFaults', 'REVPHVersion', 'RuntimeType', 'SPIMode', 'SPIPort', 'SerialPort', 'SimBoolean', 'SimDevice', 'SimDouble', 'SimEnum', 'SimInt', 'SimLong', 'SimValue', 'SimValueDirection', 'Type', 'Value', 'allocateDigitalPWM', 'calibrateAnalogGyro', 'cancelNotifierAlarm', 'checkAnalogInputChannel', 'checkAnalogModule', 'checkAnalogOutputChannel', 'checkCTREPCMSolenoidChannel', 'checkDIOChannel', 'checkPWMChannel', 'checkPowerDistributionChannel', 'checkPowerDistributionModule', 'checkREVPHModuleNumber', 'checkREVPHSolenoidChannel', 'checkRelayChannel', 'cleanAnalogTrigger', 'cleanCAN', 'cleanInterrupts', 'cleanNotifier', 'cleanPowerDistribution', 'clearAllCTREPCMStickyFaults', 'clearCounterDownSource', 'clearCounterUpSource', 'clearPowerDistributionStickyFaults', 'clearREVPHStickyFaults', 'clearSerial', 'closeI2C', 'closeSPI', 'closeSerial', 'configureSPIAutoStall', 'createHandle', 'createPortHandle', 'createPortHandleForSPI', 'disableSerialTermination', 'enableSerialTermination', 'exitMain', 'expandFPGATime', 'fireCTREPCMOneShot', 'fireREVPHOneShot', 'flushSerial', 'forceSPIAutoRead', 'format_as', 'freeAddressableLED', 'freeAnalogGyro', 'freeAnalogInputPort', 'freeAnalogOutputPort', 'freeCTREPCM', 'freeCounter', 'freeDIOPort', 'freeDigitalPWM', 'freeDutyCycle', 'freeEncoder', 'freePWMPort', 'freeREVPH', 'freeRelayPort', 'freeSPIAuto', 'getAccelerometerX', 'getAccelerometerY', 'getAccelerometerZ', 'getAccumulatorCount', 'getAccumulatorOutput', 'getAccumulatorValue', 'getAllJoystickData', 'getAllianceStation', 'getAnalogAverageBits', 'getAnalogAverageValue', 'getAnalogAverageVoltage', 'getAnalogGyroAngle', 'getAnalogGyroCenter', 'getAnalogGyroOffset', 'getAnalogGyroRate', 'getAnalogLSBWeight', 'getAnalogOffset', 'getAnalogOutput', 'getAnalogOversampleBits', 'getAnalogSampleRate', 'getAnalogTriggerFPGAIndex', 'getAnalogTriggerInWindow', 'getAnalogTriggerOutput', 'getAnalogTriggerTriggerState', 'getAnalogValue', 'getAnalogValueToVolts', 'getAnalogVoltage', 'getAnalogVoltsToValue', 'getBrownedOut', 'getBrownoutVoltage', 'getCANPacketBaseTime', 'getCPUTemp', 'getCTREPCMClosedLoopControl', 'getCTREPCMCompressor', 'getCTREPCMCompressorCurrent', 'getCTREPCMCompressorCurrentTooHighFault', 'getCTREPCMCompressorCurrentTooHighStickyFault', 'getCTREPCMCompressorNotConnectedFault', 'getCTREPCMCompressorNotConnectedStickyFault', 'getCTREPCMCompressorShortedFault', 'getCTREPCMCompressorShortedStickyFault', 'getCTREPCMPressureSwitch', 'getCTREPCMSolenoidDisabledList', 'getCTREPCMSolenoidVoltageFault', 'getCTREPCMSolenoidVoltageStickyFault', 'getCTREPCMSolenoids', 'getComments', 'getCommsDisableCount', 'getControlWord', 'getCounter', 'getCounterDirection', 'getCounterPeriod', 'getCounterSamplesToAverage', 'getCounterStopped', 'getCurrentThreadPriority', 'getDIO', 'getDIODirection', 'getDutyCycleFPGAIndex', 'getDutyCycleFrequency', 'getDutyCycleHighTime', 'getDutyCycleOutput', 'getDutyCycleOutputScaleFactor', 'getEncoder', 'getEncoderDecodingScaleFactor', 'getEncoderDirection', 'getEncoderDistance', 'getEncoderDistancePerPulse', 'getEncoderEncodingScale', 'getEncoderEncodingType', 'getEncoderFPGAIndex', 'getEncoderPeriod', 'getEncoderRate', 'getEncoderRaw', 'getEncoderSamplesToAverage', 'getEncoderStopped', 'getErrorMessage', 'getFPGAButton', 'getFPGARevision', 'getFPGATime', 'getFPGAVersion', 'getFilterPeriod', 'getFilterSelect', 'getHandleIndex', 'getHandleType', 'getHandleTypedIndex', 'getJoystickAxes', 'getJoystickAxisType', 'getJoystickButtons', 'getJoystickDescriptor', 'getJoystickIsXbox', 'getJoystickName', 'getJoystickPOVs', 'getJoystickType', 'getLastError', 'getMatchInfo', 'getMatchTime', 'getNumAccumulators', 'getNumAddressableLEDs', 'getNumAnalogInputs', 'getNumAnalogOutputs', 'getNumAnalogTriggers', 'getNumCTREPCMModules', 'getNumCTREPDPChannels', 'getNumCTREPDPModules', 'getNumCTRESolenoidChannels', 'getNumCounters', 'getNumDigitalChannels', 'getNumDigitalHeaders', 'getNumDigitalPWMOutputs', 'getNumDutyCycles', 'getNumEncoders', 'getNumInterrupts', 'getNumPWMChannels', 'getNumPWMHeaders', 'getNumREVPDHChannels', 'getNumREVPDHModules', 'getNumREVPHChannels', 'getNumREVPHModules', 'getNumRelayChannels', 'getNumRelayHeaders', 'getOutputsEnabled', 'getPWMConfigMicroseconds', 'getPWMCycleStartTime', 'getPWMEliminateDeadband', 'getPWMLoopTiming', 'getPWMPosition', 'getPWMPulseTimeMicroseconds', 'getPWMSpeed', 'getPort', 'getPortHandleChannel', 'getPortHandleModule', 'getPortHandleSPIEnable', 'getPortWithModule', 'getPowerDistributionAllChannelCurrents', 'getPowerDistributionChannelCurrent', 'getPowerDistributionFaults', 'getPowerDistributionModuleNumber', 'getPowerDistributionNumChannels', 'getPowerDistributionStickyFaults', 'getPowerDistributionSwitchableChannel', 'getPowerDistributionTemperature', 'getPowerDistributionTotalCurrent', 'getPowerDistributionTotalEnergy', 'getPowerDistributionTotalPower', 'getPowerDistributionType', 'getPowerDistributionVersion', 'getPowerDistributionVoltage', 'getREVPH5VVoltage', 'getREVPHAnalogVoltage', 'getREVPHCompressor', 'getREVPHCompressorConfig', 'getREVPHCompressorCurrent', 'getREVPHFaults', 'getREVPHPressureSwitch', 'getREVPHSolenoidCurrent', 'getREVPHSolenoidDisabledList', 'getREVPHSolenoidVoltage', 'getREVPHSolenoids', 'getREVPHStickyFaults', 'getREVPHVersion', 'getREVPHVoltage', 'getRSLState', 'getRelay', 'getRuntimeType', 'getSPIAutoDroppedCount', 'getSPIHandle', 'getSPIMode', 'getSerialBytesReceived', 'getSerialFD', 'getSerialNumber', 'getSystemActive', 'getSystemClockTicksPerMicrosecond', 'getSystemTimeValid', 'getTeamNumber', 'getUserActive3V3', 'getUserActive5V', 'getUserActive6V', 'getUserCurrent3V3', 'getUserCurrent5V', 'getUserCurrent6V', 'getUserCurrentFaults3V3', 'getUserCurrentFaults5V', 'getUserCurrentFaults6V', 'getUserVoltage3V3', 'getUserVoltage5V', 'getUserVoltage6V', 'getVinCurrent', 'getVinVoltage', 'hasMain', 'initAccumulator', 'initSPIAuto', 'initialize', 'initializeAddressableLED', 'initializeAnalogGyro', 'initializeAnalogInputPort', 'initializeAnalogOutputPort', 'initializeAnalogTrigger', 'initializeAnalogTriggerDutyCycle', 'initializeCAN', 'initializeCTREPCM', 'initializeCounter', 'initializeDIOPort', 'initializeDutyCycle', 'initializeEncoder', 'initializeI2C', 'initializeInterrupts', 'initializeNotifier', 'initializePWMPort', 'initializePowerDistribution', 'initializeREVPH', 'initializeRelayPort', 'initializeSPI', 'initializeSerialPort', 'initializeSerialPortDirect', 'isAccumulatorChannel', 'isAnyPulsing', 'isHandleCorrectVersion', 'isHandleType', 'isPulsing', 'latchPWMZero', 'loadExtensions', 'loadOneExtension', 'observeUserProgramAutonomous', 'observeUserProgramDisabled', 'observeUserProgramStarting', 'observeUserProgramTeleop', 'observeUserProgramTest', 'provideNewDataEventHandle', 'pulse', 'pulseMultiple', 'readCANPacketLatest', 'readCANPacketNew', 'readCANPacketTimeout', 'readI2C', 'readInterruptFallingTimestamp', 'readInterruptRisingTimestamp', 'readSPI', 'readSPIAutoReceivedData', 'readSerial', 'refreshDSData', 'releaseWaitingInterrupt', 'removeNewDataEventHandle', 'report', 'requestInterrupts', 'resetAccumulator', 'resetAnalogGyro', 'resetCounter', 'resetEncoder', 'resetPowerDistributionTotalEnergy', 'resetUserCurrentFaults', 'runMain', 'sendConsoleLine', 'sendError', 'setAccelerometerActive', 'setAccelerometerRange', 'setAccumulatorCenter', 'setAccumulatorDeadband', 'setAddressableLEDBitTiming', 'setAddressableLEDColorOrder', 'setAddressableLEDLength', 'setAddressableLEDOutputPort', 'setAddressableLEDSyncTime', 'setAnalogAverageBits', 'setAnalogGyroDeadband', 'setAnalogGyroParameters', 'setAnalogGyroVoltsPerDegreePerSecond', 'setAnalogInputSimDevice', 'setAnalogOutput', 'setAnalogOversampleBits', 'setAnalogSampleRate', 'setAnalogTriggerAveraged', 'setAnalogTriggerFiltered', 'setAnalogTriggerLimitsDutyCycle', 'setAnalogTriggerLimitsRaw', 'setAnalogTriggerLimitsVoltage', 'setBrownoutVoltage', 'setCTREPCMClosedLoopControl', 'setCTREPCMOneShotDuration', 'setCTREPCMSolenoids', 'setCounterAverageSize', 'setCounterDownSource', 'setCounterDownSourceEdge', 'setCounterExternalDirectionMode', 'setCounterMaxPeriod', 'setCounterPulseLengthMode', 'setCounterReverseDirection', 'setCounterSamplesToAverage', 'setCounterSemiPeriodMode', 'setCounterUpDownMode', 'setCounterUpSource', 'setCounterUpSourceEdge', 'setCounterUpdateWhenEmpty', 'setCurrentThreadPriority', 'setDIO', 'setDIODirection', 'setDIOSimDevice', 'setDigitalPWMDutyCycle', 'setDigitalPWMOutputChannel', 'setDigitalPWMPPS', 'setDigitalPWMRate', 'setDutyCycleSimDevice', 'setEncoderDistancePerPulse', 'setEncoderIndexSource', 'setEncoderMaxPeriod', 'setEncoderMinRate', 'setEncoderReverseDirection', 'setEncoderSamplesToAverage', 'setEncoderSimDevice', 'setFilterPeriod', 'setFilterSelect', 'setInterruptUpSourceEdge', 'setJoystickOutputs', 'setNotifierName', 'setNotifierThreadPriority', 'setPWMAlwaysHighMode', 'setPWMConfigMicroseconds', 'setPWMDisabled', 'setPWMEliminateDeadband', 'setPWMPeriodScale', 'setPWMPosition', 'setPWMPulseTimeMicroseconds', 'setPWMSpeed', 'setPowerDistributionSwitchableChannel', 'setREVPHClosedLoopControlAnalog', 'setREVPHClosedLoopControlDigital', 'setREVPHClosedLoopControlDisabled', 'setREVPHClosedLoopControlHybrid', 'setREVPHCompressorConfig', 'setREVPHSolenoids', 'setRelay', 'setSPIAutoTransmitData', 'setSPIChipSelectActiveHigh', 'setSPIChipSelectActiveLow', 'setSPIHandle', 'setSPIMode', 'setSPISpeed', 'setSerialBaudRate', 'setSerialDataBits', 'setSerialFlowControl', 'setSerialParity', 'setSerialReadBufferSize', 'setSerialStopBits', 'setSerialTimeout', 'setSerialWriteBufferSize', 'setSerialWriteMode', 'setShowExtensionsNotFoundMessages', 'setUserRailEnabled3V3', 'setUserRailEnabled5V', 'setUserRailEnabled6V', 'setupAnalogGyro', 'shutdown', 'simPeriodicAfter', 'simPeriodicBefore', 'startAddressableLEDOutput', 'startSPIAutoRate', 'startSPIAutoTrigger', 'stopAddressableLEDOutput', 'stopCANPacketRepeating', 'stopNotifier', 'stopSPIAuto', 'tInstances', 'tResourceType', 'transactionI2C', 'transactionSPI', 'updateNotifierAlarm', 'waitForInterrupt', 'waitForMultipleInterrupts', 'waitForNotifierAlarm', 'writeAddressableLEDData', 'writeCANPacket', 'writeCANPacketRepeating', 'writeCANRTRFrame', 'writeI2C', 'writeSPI', 'writeSerial']
class AccelerometerRange:
    """
    The acceptable accelerometer ranges.
    
    Members:
    
      k2G
    
      k4G
    
      k8G
    """
    __members__: typing.ClassVar[dict[str, AccelerometerRange]]  # value = {'k2G': <AccelerometerRange.k2G: 0>, 'k4G': <AccelerometerRange.k4G: 1>, 'k8G': <AccelerometerRange.k8G: 2>}
    k2G: typing.ClassVar[AccelerometerRange]  # value = <AccelerometerRange.k2G: 0>
    k4G: typing.ClassVar[AccelerometerRange]  # value = <AccelerometerRange.k4G: 1>
    k8G: typing.ClassVar[AccelerometerRange]  # value = <AccelerometerRange.k8G: 2>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class AddressableLEDColorOrder:
    """
    Order that color data is sent over the wire.
    
    Members:
    
      HAL_ALED_RGB
    
      HAL_ALED_RBG
    
      HAL_ALED_BGR
    
      HAL_ALED_BRG
    
      HAL_ALED_GBR
    
      HAL_ALED_GRB
    """
    HAL_ALED_BGR: typing.ClassVar[AddressableLEDColorOrder]  # value = <AddressableLEDColorOrder.HAL_ALED_BGR: 2>
    HAL_ALED_BRG: typing.ClassVar[AddressableLEDColorOrder]  # value = <AddressableLEDColorOrder.HAL_ALED_BRG: 3>
    HAL_ALED_GBR: typing.ClassVar[AddressableLEDColorOrder]  # value = <AddressableLEDColorOrder.HAL_ALED_GBR: 4>
    HAL_ALED_GRB: typing.ClassVar[AddressableLEDColorOrder]  # value = <AddressableLEDColorOrder.HAL_ALED_GRB: 5>
    HAL_ALED_RBG: typing.ClassVar[AddressableLEDColorOrder]  # value = <AddressableLEDColorOrder.HAL_ALED_RBG: 1>
    HAL_ALED_RGB: typing.ClassVar[AddressableLEDColorOrder]  # value = <AddressableLEDColorOrder.HAL_ALED_RGB: 0>
    __members__: typing.ClassVar[dict[str, AddressableLEDColorOrder]]  # value = {'HAL_ALED_RGB': <AddressableLEDColorOrder.HAL_ALED_RGB: 0>, 'HAL_ALED_RBG': <AddressableLEDColorOrder.HAL_ALED_RBG: 1>, 'HAL_ALED_BGR': <AddressableLEDColorOrder.HAL_ALED_BGR: 2>, 'HAL_ALED_BRG': <AddressableLEDColorOrder.HAL_ALED_BRG: 3>, 'HAL_ALED_GBR': <AddressableLEDColorOrder.HAL_ALED_GBR: 4>, 'HAL_ALED_GRB': <AddressableLEDColorOrder.HAL_ALED_GRB: 5>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class AddressableLEDData:
    """
    structure for holding one LED's color data.
    """
    def __init__(self) -> None:
        ...
    @property
    def b(self) -> int:
        """
        ///< blue value
        """
    @b.setter
    def b(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def g(self) -> int:
        """
        ///< green value
        """
    @g.setter
    def g(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def r(self) -> int:
        """
        ///< red value
        """
    @r.setter
    def r(self, arg0: typing.SupportsInt) -> None:
        ...
class AllianceStationID:
    """
    Members:
    
      kUnknown : Unknown Alliance Station
    
      kRed1 : Red Alliance Station 1
    
      kRed2 : Red Alliance Station 2
    
      kRed3 : Red Alliance Station 3
    
      kBlue1 : Blue Alliance Station 1
    
      kBlue2 : Blue Alliance Station 2
    
      kBlue3 : Blue Alliance Station 3
    """
    __members__: typing.ClassVar[dict[str, AllianceStationID]]  # value = {'kUnknown': <AllianceStationID.kUnknown: 0>, 'kRed1': <AllianceStationID.kRed1: 1>, 'kRed2': <AllianceStationID.kRed2: 2>, 'kRed3': <AllianceStationID.kRed3: 3>, 'kBlue1': <AllianceStationID.kBlue1: 4>, 'kBlue2': <AllianceStationID.kBlue2: 5>, 'kBlue3': <AllianceStationID.kBlue3: 6>}
    kBlue1: typing.ClassVar[AllianceStationID]  # value = <AllianceStationID.kBlue1: 4>
    kBlue2: typing.ClassVar[AllianceStationID]  # value = <AllianceStationID.kBlue2: 5>
    kBlue3: typing.ClassVar[AllianceStationID]  # value = <AllianceStationID.kBlue3: 6>
    kRed1: typing.ClassVar[AllianceStationID]  # value = <AllianceStationID.kRed1: 1>
    kRed2: typing.ClassVar[AllianceStationID]  # value = <AllianceStationID.kRed2: 2>
    kRed3: typing.ClassVar[AllianceStationID]  # value = <AllianceStationID.kRed3: 3>
    kUnknown: typing.ClassVar[AllianceStationID]  # value = <AllianceStationID.kUnknown: 0>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class AnalogTriggerType:
    """
    The type of analog trigger to trigger on.
    
    Members:
    
      kInWindow
    
      kState
    
      kRisingPulse
    
      kFallingPulse
    """
    __members__: typing.ClassVar[dict[str, AnalogTriggerType]]  # value = {'kInWindow': <AnalogTriggerType.kInWindow: 0>, 'kState': <AnalogTriggerType.kState: 1>, 'kRisingPulse': <AnalogTriggerType.kRisingPulse: 2>, 'kFallingPulse': <AnalogTriggerType.kFallingPulse: 3>}
    kFallingPulse: typing.ClassVar[AnalogTriggerType]  # value = <AnalogTriggerType.kFallingPulse: 3>
    kInWindow: typing.ClassVar[AnalogTriggerType]  # value = <AnalogTriggerType.kInWindow: 0>
    kRisingPulse: typing.ClassVar[AnalogTriggerType]  # value = <AnalogTriggerType.kRisingPulse: 2>
    kState: typing.ClassVar[AnalogTriggerType]  # value = <AnalogTriggerType.kState: 1>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class CANDeviceType:
    """
    The CAN device type.
    
    Teams should use HAL_CAN_Dev_kMiscellaneous
    
    Members:
    
      kBroadcast : Broadcast.
    
      kRobotController : Robot controller.
    
      kMotorController : Motor controller.
    
      kRelayController : Relay controller.
    
      kGyroSensor : Gyro sensor.
    
      kAccelerometer : Accelerometer.
    
      kUltrasonicSensor : Ultrasonic sensor.
    
      kGearToothSensor : Gear tooth sensor.
    
      kPowerDistribution : Power distribution.
    
      kPneumatics : Pneumatics.
    
      kMiscellaneous : Miscellaneous.
    
      kIOBreakout : IO breakout.
    
      kServoController
    
      kFirmwareUpdate : Firmware update.
    """
    __members__: typing.ClassVar[dict[str, CANDeviceType]]  # value = {'kBroadcast': <CANDeviceType.kBroadcast: 0>, 'kRobotController': <CANDeviceType.kRobotController: 1>, 'kMotorController': <CANDeviceType.kMotorController: 2>, 'kRelayController': <CANDeviceType.kRelayController: 3>, 'kGyroSensor': <CANDeviceType.kGyroSensor: 4>, 'kAccelerometer': <CANDeviceType.kAccelerometer: 5>, 'kUltrasonicSensor': <CANDeviceType.kUltrasonicSensor: 6>, 'kGearToothSensor': <CANDeviceType.kGearToothSensor: 7>, 'kPowerDistribution': <CANDeviceType.kPowerDistribution: 8>, 'kPneumatics': <CANDeviceType.kPneumatics: 9>, 'kMiscellaneous': <CANDeviceType.kMiscellaneous: 10>, 'kIOBreakout': <CANDeviceType.kIOBreakout: 11>, 'kServoController': <CANDeviceType.kServoController: 12>, 'kFirmwareUpdate': <CANDeviceType.kFirmwareUpdate: 31>}
    kAccelerometer: typing.ClassVar[CANDeviceType]  # value = <CANDeviceType.kAccelerometer: 5>
    kBroadcast: typing.ClassVar[CANDeviceType]  # value = <CANDeviceType.kBroadcast: 0>
    kFirmwareUpdate: typing.ClassVar[CANDeviceType]  # value = <CANDeviceType.kFirmwareUpdate: 31>
    kGearToothSensor: typing.ClassVar[CANDeviceType]  # value = <CANDeviceType.kGearToothSensor: 7>
    kGyroSensor: typing.ClassVar[CANDeviceType]  # value = <CANDeviceType.kGyroSensor: 4>
    kIOBreakout: typing.ClassVar[CANDeviceType]  # value = <CANDeviceType.kIOBreakout: 11>
    kMiscellaneous: typing.ClassVar[CANDeviceType]  # value = <CANDeviceType.kMiscellaneous: 10>
    kMotorController: typing.ClassVar[CANDeviceType]  # value = <CANDeviceType.kMotorController: 2>
    kPneumatics: typing.ClassVar[CANDeviceType]  # value = <CANDeviceType.kPneumatics: 9>
    kPowerDistribution: typing.ClassVar[CANDeviceType]  # value = <CANDeviceType.kPowerDistribution: 8>
    kRelayController: typing.ClassVar[CANDeviceType]  # value = <CANDeviceType.kRelayController: 3>
    kRobotController: typing.ClassVar[CANDeviceType]  # value = <CANDeviceType.kRobotController: 1>
    kServoController: typing.ClassVar[CANDeviceType]  # value = <CANDeviceType.kServoController: 12>
    kUltrasonicSensor: typing.ClassVar[CANDeviceType]  # value = <CANDeviceType.kUltrasonicSensor: 6>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class CANManufacturer:
    """
    The CAN manufacturer ID.
    
    Teams should use HAL_CAN_Man_kTeamUse.
    
    Members:
    
      kBroadcast : Broadcast.
    
      kNI : National Instruments.
    
      kLM : Luminary Micro.
    
      kDEKA : DEKA Research and Development Corp.
    
      kCTRE : Cross the Road Electronics.
    
      kREV : REV robotics.
    
      kGrapple : Grapple.
    
      kMS : MindSensors.
    
      kTeamUse : Team use.
    
      kKauaiLabs : Kauai Labs.
    
      kCopperforge : Copperforge.
    
      kPWF : Playing With Fusion.
    
      kStudica : Studica.
    
      kTheThriftyBot : TheThriftyBot.
    
      kReduxRobotics : Redux Robotics.
    
      kAndyMark : AndyMark.
    
      kVividHosting : Vivid-Hosting.
    """
    __members__: typing.ClassVar[dict[str, CANManufacturer]]  # value = {'kBroadcast': <CANManufacturer.kBroadcast: 0>, 'kNI': <CANManufacturer.kNI: 1>, 'kLM': <CANManufacturer.kLM: 2>, 'kDEKA': <CANManufacturer.kDEKA: 3>, 'kCTRE': <CANManufacturer.kCTRE: 4>, 'kREV': <CANManufacturer.kREV: 5>, 'kGrapple': <CANManufacturer.kGrapple: 6>, 'kMS': <CANManufacturer.kMS: 7>, 'kTeamUse': <CANManufacturer.kTeamUse: 8>, 'kKauaiLabs': <CANManufacturer.kKauaiLabs: 9>, 'kCopperforge': <CANManufacturer.kCopperforge: 10>, 'kPWF': <CANManufacturer.kPWF: 11>, 'kStudica': <CANManufacturer.kStudica: 12>, 'kTheThriftyBot': <CANManufacturer.kTheThriftyBot: 13>, 'kReduxRobotics': <CANManufacturer.kReduxRobotics: 14>, 'kAndyMark': <CANManufacturer.kAndyMark: 15>, 'kVividHosting': <CANManufacturer.kVividHosting: 16>}
    kAndyMark: typing.ClassVar[CANManufacturer]  # value = <CANManufacturer.kAndyMark: 15>
    kBroadcast: typing.ClassVar[CANManufacturer]  # value = <CANManufacturer.kBroadcast: 0>
    kCTRE: typing.ClassVar[CANManufacturer]  # value = <CANManufacturer.kCTRE: 4>
    kCopperforge: typing.ClassVar[CANManufacturer]  # value = <CANManufacturer.kCopperforge: 10>
    kDEKA: typing.ClassVar[CANManufacturer]  # value = <CANManufacturer.kDEKA: 3>
    kGrapple: typing.ClassVar[CANManufacturer]  # value = <CANManufacturer.kGrapple: 6>
    kKauaiLabs: typing.ClassVar[CANManufacturer]  # value = <CANManufacturer.kKauaiLabs: 9>
    kLM: typing.ClassVar[CANManufacturer]  # value = <CANManufacturer.kLM: 2>
    kMS: typing.ClassVar[CANManufacturer]  # value = <CANManufacturer.kMS: 7>
    kNI: typing.ClassVar[CANManufacturer]  # value = <CANManufacturer.kNI: 1>
    kPWF: typing.ClassVar[CANManufacturer]  # value = <CANManufacturer.kPWF: 11>
    kREV: typing.ClassVar[CANManufacturer]  # value = <CANManufacturer.kREV: 5>
    kReduxRobotics: typing.ClassVar[CANManufacturer]  # value = <CANManufacturer.kReduxRobotics: 14>
    kStudica: typing.ClassVar[CANManufacturer]  # value = <CANManufacturer.kStudica: 12>
    kTeamUse: typing.ClassVar[CANManufacturer]  # value = <CANManufacturer.kTeamUse: 8>
    kTheThriftyBot: typing.ClassVar[CANManufacturer]  # value = <CANManufacturer.kTheThriftyBot: 13>
    kVividHosting: typing.ClassVar[CANManufacturer]  # value = <CANManufacturer.kVividHosting: 16>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class CANStreamMessage:
    """
    Storage for CAN Stream Messages.
    """
    def __init__(self) -> None:
        ...
    @property
    def data(self) -> memoryview:
        """
        The message data
        """
    @property
    def dataSize(self) -> int:
        """
        The size of the data received (0-8 bytes)
        """
    @dataSize.setter
    def dataSize(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def messageID(self) -> int:
        """
        The message ID
        """
    @messageID.setter
    def messageID(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def timeStamp(self) -> int:
        """
        The packet received timestamp (based off of CLOCK_MONOTONIC)
        """
    @timeStamp.setter
    def timeStamp(self, arg0: typing.SupportsInt) -> None:
        ...
class ControlWord:
    def __init__(self) -> None:
        ...
    @property
    def autonomous(self) -> int:
        ...
    @autonomous.setter
    def autonomous(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def control_reserved(self) -> int:
        ...
    @control_reserved.setter
    def control_reserved(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def dsAttached(self) -> int:
        ...
    @dsAttached.setter
    def dsAttached(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def eStop(self) -> int:
        ...
    @eStop.setter
    def eStop(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def enabled(self) -> int:
        ...
    @enabled.setter
    def enabled(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def fmsAttached(self) -> int:
        ...
    @fmsAttached.setter
    def fmsAttached(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def test(self) -> int:
        ...
    @test.setter
    def test(self, arg1: typing.SupportsInt) -> None:
        ...
class CounterMode:
    """
    The counter mode.
    
    Members:
    
      kTwoPulse : Two pulse mode.
    
      kSemiperiod : Semi-period mode.
    
      kPulseLength : Pulse length mode.
    
      kExternalDirection : External direction mode.
    """
    __members__: typing.ClassVar[dict[str, CounterMode]]  # value = {'kTwoPulse': <CounterMode.kTwoPulse: 0>, 'kSemiperiod': <CounterMode.kSemiperiod: 1>, 'kPulseLength': <CounterMode.kPulseLength: 2>, 'kExternalDirection': <CounterMode.kExternalDirection: 3>}
    kExternalDirection: typing.ClassVar[CounterMode]  # value = <CounterMode.kExternalDirection: 3>
    kPulseLength: typing.ClassVar[CounterMode]  # value = <CounterMode.kPulseLength: 2>
    kSemiperiod: typing.ClassVar[CounterMode]  # value = <CounterMode.kSemiperiod: 1>
    kTwoPulse: typing.ClassVar[CounterMode]  # value = <CounterMode.kTwoPulse: 0>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class EncoderEncodingType:
    """
    The encoding scaling of the encoder.
    
    Members:
    
      Encoder_k1X
    
      Encoder_k2X
    
      Encoder_k4X
    """
    Encoder_k1X: typing.ClassVar[EncoderEncodingType]  # value = <EncoderEncodingType.Encoder_k1X: 0>
    Encoder_k2X: typing.ClassVar[EncoderEncodingType]  # value = <EncoderEncodingType.Encoder_k2X: 1>
    Encoder_k4X: typing.ClassVar[EncoderEncodingType]  # value = <EncoderEncodingType.Encoder_k4X: 2>
    __members__: typing.ClassVar[dict[str, EncoderEncodingType]]  # value = {'Encoder_k1X': <EncoderEncodingType.Encoder_k1X: 0>, 'Encoder_k2X': <EncoderEncodingType.Encoder_k2X: 1>, 'Encoder_k4X': <EncoderEncodingType.Encoder_k4X: 2>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class EncoderIndexingType:
    """
    The type of index pulse for the encoder.
    
    Members:
    
      kResetWhileHigh
    
      kResetWhileLow
    
      kResetOnFallingEdge
    
      kResetOnRisingEdge
    """
    __members__: typing.ClassVar[dict[str, EncoderIndexingType]]  # value = {'kResetWhileHigh': <EncoderIndexingType.kResetWhileHigh: 0>, 'kResetWhileLow': <EncoderIndexingType.kResetWhileLow: 1>, 'kResetOnFallingEdge': <EncoderIndexingType.kResetOnFallingEdge: 2>, 'kResetOnRisingEdge': <EncoderIndexingType.kResetOnRisingEdge: 3>}
    kResetOnFallingEdge: typing.ClassVar[EncoderIndexingType]  # value = <EncoderIndexingType.kResetOnFallingEdge: 2>
    kResetOnRisingEdge: typing.ClassVar[EncoderIndexingType]  # value = <EncoderIndexingType.kResetOnRisingEdge: 3>
    kResetWhileHigh: typing.ClassVar[EncoderIndexingType]  # value = <EncoderIndexingType.kResetWhileHigh: 0>
    kResetWhileLow: typing.ClassVar[EncoderIndexingType]  # value = <EncoderIndexingType.kResetWhileLow: 1>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class HAL_RadioLEDState:
    """
    Members:
    
      HAL_RadioLED_kOff
    
      HAL_RadioLED_kGreen
    
      HAL_RadioLED_kRed
    
      HAL_RadioLED_kOrange
    """
    HAL_RadioLED_kGreen: typing.ClassVar[HAL_RadioLEDState]  # value = <HAL_RadioLEDState.HAL_RadioLED_kGreen: 1>
    HAL_RadioLED_kOff: typing.ClassVar[HAL_RadioLEDState]  # value = <HAL_RadioLEDState.HAL_RadioLED_kOff: 0>
    HAL_RadioLED_kOrange: typing.ClassVar[HAL_RadioLEDState]  # value = <HAL_RadioLEDState.HAL_RadioLED_kOrange: 3>
    HAL_RadioLED_kRed: typing.ClassVar[HAL_RadioLEDState]  # value = <HAL_RadioLEDState.HAL_RadioLED_kRed: 2>
    __members__: typing.ClassVar[dict[str, HAL_RadioLEDState]]  # value = {'HAL_RadioLED_kOff': <HAL_RadioLEDState.HAL_RadioLED_kOff: 0>, 'HAL_RadioLED_kGreen': <HAL_RadioLEDState.HAL_RadioLED_kGreen: 1>, 'HAL_RadioLED_kRed': <HAL_RadioLEDState.HAL_RadioLED_kRed: 2>, 'HAL_RadioLED_kOrange': <HAL_RadioLEDState.HAL_RadioLED_kOrange: 3>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class HandleEnum:
    """
    Enum of HAL handle types. Vendors/Teams should use Vendor (17).
    
    Members:
    
      Undefined
    
      DIO
    
      Port
    
      Notifier
    
      Interrupt
    
      AnalogOutput
    
      AnalogInput
    
      AnalogTrigger
    
      Relay
    
      PWM
    
      DigitalPWM
    
      Counter
    
      FPGAEncoder
    
      Encoder
    
      Compressor
    
      Solenoid
    
      AnalogGyro
    
      Vendor
    
      SimulationJni
    
      CAN
    
      SerialPort
    
      DutyCycle
    
      DMA
    
      AddressableLED
    
      CTREPCM
    
      CTREPDP
    
      REVPDH
    
      REVPH
    """
    AddressableLED: typing.ClassVar[HandleEnum]  # value = <HandleEnum.AddressableLED: 23>
    AnalogGyro: typing.ClassVar[HandleEnum]  # value = <HandleEnum.AnalogGyro: 16>
    AnalogInput: typing.ClassVar[HandleEnum]  # value = <HandleEnum.AnalogInput: 6>
    AnalogOutput: typing.ClassVar[HandleEnum]  # value = <HandleEnum.AnalogOutput: 5>
    AnalogTrigger: typing.ClassVar[HandleEnum]  # value = <HandleEnum.AnalogTrigger: 7>
    CAN: typing.ClassVar[HandleEnum]  # value = <HandleEnum.CAN: 19>
    CTREPCM: typing.ClassVar[HandleEnum]  # value = <HandleEnum.CTREPCM: 24>
    CTREPDP: typing.ClassVar[HandleEnum]  # value = <HandleEnum.CTREPDP: 25>
    Compressor: typing.ClassVar[HandleEnum]  # value = <HandleEnum.Compressor: 14>
    Counter: typing.ClassVar[HandleEnum]  # value = <HandleEnum.Counter: 11>
    DIO: typing.ClassVar[HandleEnum]  # value = <HandleEnum.DIO: 48>
    DMA: typing.ClassVar[HandleEnum]  # value = <HandleEnum.DMA: 22>
    DigitalPWM: typing.ClassVar[HandleEnum]  # value = <HandleEnum.DigitalPWM: 10>
    DutyCycle: typing.ClassVar[HandleEnum]  # value = <HandleEnum.DutyCycle: 21>
    Encoder: typing.ClassVar[HandleEnum]  # value = <HandleEnum.Encoder: 13>
    FPGAEncoder: typing.ClassVar[HandleEnum]  # value = <HandleEnum.FPGAEncoder: 12>
    Interrupt: typing.ClassVar[HandleEnum]  # value = <HandleEnum.Interrupt: 4>
    Notifier: typing.ClassVar[HandleEnum]  # value = <HandleEnum.Notifier: 3>
    PWM: typing.ClassVar[HandleEnum]  # value = <HandleEnum.PWM: 9>
    Port: typing.ClassVar[HandleEnum]  # value = <HandleEnum.Port: 2>
    REVPDH: typing.ClassVar[HandleEnum]  # value = <HandleEnum.REVPDH: 26>
    REVPH: typing.ClassVar[HandleEnum]  # value = <HandleEnum.REVPH: 27>
    Relay: typing.ClassVar[HandleEnum]  # value = <HandleEnum.Relay: 8>
    SerialPort: typing.ClassVar[HandleEnum]  # value = <HandleEnum.SerialPort: 20>
    SimulationJni: typing.ClassVar[HandleEnum]  # value = <HandleEnum.SimulationJni: 18>
    Solenoid: typing.ClassVar[HandleEnum]  # value = <HandleEnum.Solenoid: 15>
    Undefined: typing.ClassVar[HandleEnum]  # value = <HandleEnum.Undefined: 0>
    Vendor: typing.ClassVar[HandleEnum]  # value = <HandleEnum.Vendor: 17>
    __members__: typing.ClassVar[dict[str, HandleEnum]]  # value = {'Undefined': <HandleEnum.Undefined: 0>, 'DIO': <HandleEnum.DIO: 48>, 'Port': <HandleEnum.Port: 2>, 'Notifier': <HandleEnum.Notifier: 3>, 'Interrupt': <HandleEnum.Interrupt: 4>, 'AnalogOutput': <HandleEnum.AnalogOutput: 5>, 'AnalogInput': <HandleEnum.AnalogInput: 6>, 'AnalogTrigger': <HandleEnum.AnalogTrigger: 7>, 'Relay': <HandleEnum.Relay: 8>, 'PWM': <HandleEnum.PWM: 9>, 'DigitalPWM': <HandleEnum.DigitalPWM: 10>, 'Counter': <HandleEnum.Counter: 11>, 'FPGAEncoder': <HandleEnum.FPGAEncoder: 12>, 'Encoder': <HandleEnum.Encoder: 13>, 'Compressor': <HandleEnum.Compressor: 14>, 'Solenoid': <HandleEnum.Solenoid: 15>, 'AnalogGyro': <HandleEnum.AnalogGyro: 16>, 'Vendor': <HandleEnum.Vendor: 17>, 'SimulationJni': <HandleEnum.SimulationJni: 18>, 'CAN': <HandleEnum.CAN: 19>, 'SerialPort': <HandleEnum.SerialPort: 20>, 'DutyCycle': <HandleEnum.DutyCycle: 21>, 'DMA': <HandleEnum.DMA: 22>, 'AddressableLED': <HandleEnum.AddressableLED: 23>, 'CTREPCM': <HandleEnum.CTREPCM: 24>, 'CTREPDP': <HandleEnum.CTREPDP: 25>, 'REVPDH': <HandleEnum.REVPDH: 26>, 'REVPH': <HandleEnum.REVPH: 27>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class I2CPort:
    """
    Members:
    
      kInvalid
    
      kOnboard
    
      kMXP
    """
    __members__: typing.ClassVar[dict[str, I2CPort]]  # value = {'kInvalid': <I2CPort.kInvalid: -1>, 'kOnboard': <I2CPort.kOnboard: 0>, 'kMXP': <I2CPort.kMXP: 1>}
    kInvalid: typing.ClassVar[I2CPort]  # value = <I2CPort.kInvalid: -1>
    kMXP: typing.ClassVar[I2CPort]  # value = <I2CPort.kMXP: 1>
    kOnboard: typing.ClassVar[I2CPort]  # value = <I2CPort.kOnboard: 0>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class JoystickAxes:
    def __init__(self) -> None:
        ...
    @property
    def axes(self) -> memoryview:
        ...
    @property
    def count(self) -> int:
        ...
    @count.setter
    def count(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def raw(self) -> memoryview:
        ...
class JoystickButtons:
    def __init__(self) -> None:
        ...
    @property
    def buttons(self) -> int:
        ...
    @buttons.setter
    def buttons(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def count(self) -> int:
        ...
    @count.setter
    def count(self, arg0: typing.SupportsInt) -> None:
        ...
class JoystickDescriptor:
    def __init__(self) -> None:
        ...
    @property
    def axisCount(self) -> int:
        ...
    @axisCount.setter
    def axisCount(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def axisTypes(self) -> memoryview:
        ...
    @property
    def buttonCount(self) -> int:
        ...
    @buttonCount.setter
    def buttonCount(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def isXbox(self) -> int:
        ...
    @isXbox.setter
    def isXbox(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def name(self) -> memoryview:
        ...
    @property
    def povCount(self) -> int:
        ...
    @povCount.setter
    def povCount(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def type(self) -> int:
        ...
    @type.setter
    def type(self, arg0: typing.SupportsInt) -> None:
        ...
class JoystickPOVs:
    def __init__(self) -> None:
        ...
    @property
    def count(self) -> int:
        ...
    @count.setter
    def count(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def povs(self) -> memoryview:
        ...
class MatchInfo:
    matchType: MatchType
    def __init__(self) -> None:
        ...
    @property
    def eventName(self) -> memoryview:
        ...
    @property
    def gameSpecificMessage(self) -> memoryview:
        ...
    @property
    def gameSpecificMessageSize(self) -> int:
        ...
    @gameSpecificMessageSize.setter
    def gameSpecificMessageSize(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def matchNumber(self) -> int:
        ...
    @matchNumber.setter
    def matchNumber(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def replayNumber(self) -> int:
        ...
    @replayNumber.setter
    def replayNumber(self, arg0: typing.SupportsInt) -> None:
        ...
class MatchType:
    """
    Members:
    
      none
    
      practice
    
      qualification
    
      elimination
    """
    __members__: typing.ClassVar[dict[str, MatchType]]  # value = {'none': <MatchType.none: 0>, 'practice': <MatchType.practice: 1>, 'qualification': <MatchType.qualification: 2>, 'elimination': <MatchType.elimination: 3>}
    elimination: typing.ClassVar[MatchType]  # value = <MatchType.elimination: 3>
    none: typing.ClassVar[MatchType]  # value = <MatchType.none: 0>
    practice: typing.ClassVar[MatchType]  # value = <MatchType.practice: 1>
    qualification: typing.ClassVar[MatchType]  # value = <MatchType.qualification: 2>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class PowerDistributionFaults:
    def __init__(self) -> None:
        ...
    @property
    def brownout(self) -> int:
        """
        The input voltage is below the minimum voltage.
        """
    @brownout.setter
    def brownout(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def canWarning(self) -> int:
        """
        A warning was raised by the device's CAN controller.
        """
    @canWarning.setter
    def canWarning(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel0BreakerFault(self) -> int:
        """
        Breaker fault on channel 0.
        """
    @channel0BreakerFault.setter
    def channel0BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel10BreakerFault(self) -> int:
        """
        Breaker fault on channel 10.
        """
    @channel10BreakerFault.setter
    def channel10BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel11BreakerFault(self) -> int:
        """
        Breaker fault on channel 12.
        """
    @channel11BreakerFault.setter
    def channel11BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel12BreakerFault(self) -> int:
        """
        Breaker fault on channel 13.
        """
    @channel12BreakerFault.setter
    def channel12BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel13BreakerFault(self) -> int:
        """
        Breaker fault on channel 14.
        """
    @channel13BreakerFault.setter
    def channel13BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel14BreakerFault(self) -> int:
        """
        Breaker fault on channel 15.
        """
    @channel14BreakerFault.setter
    def channel14BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel15BreakerFault(self) -> int:
        """
        Breaker fault on channel 16.
        """
    @channel15BreakerFault.setter
    def channel15BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel16BreakerFault(self) -> int:
        """
        Breaker fault on channel 17.
        """
    @channel16BreakerFault.setter
    def channel16BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel17BreakerFault(self) -> int:
        """
        Breaker fault on channel 18.
        """
    @channel17BreakerFault.setter
    def channel17BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel18BreakerFault(self) -> int:
        """
        Breaker fault on channel 19.
        """
    @channel18BreakerFault.setter
    def channel18BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel19BreakerFault(self) -> int:
        """
        Breaker fault on channel 20.
        """
    @channel19BreakerFault.setter
    def channel19BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel1BreakerFault(self) -> int:
        """
        Breaker fault on channel 1.
        """
    @channel1BreakerFault.setter
    def channel1BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel20BreakerFault(self) -> int:
        """
        Breaker fault on channel 21.
        """
    @channel20BreakerFault.setter
    def channel20BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel21BreakerFault(self) -> int:
        """
        Breaker fault on channel 22.
        """
    @channel21BreakerFault.setter
    def channel21BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel22BreakerFault(self) -> int:
        """
        Breaker fault on channel 23.
        """
    @channel22BreakerFault.setter
    def channel22BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel23BreakerFault(self) -> int:
        """
        Breaker fault on channel 24.
        """
    @channel23BreakerFault.setter
    def channel23BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel2BreakerFault(self) -> int:
        """
        Breaker fault on channel 2.
        """
    @channel2BreakerFault.setter
    def channel2BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel3BreakerFault(self) -> int:
        """
        Breaker fault on channel 3.
        """
    @channel3BreakerFault.setter
    def channel3BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel4BreakerFault(self) -> int:
        """
        Breaker fault on channel 4.
        """
    @channel4BreakerFault.setter
    def channel4BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel5BreakerFault(self) -> int:
        """
        Breaker fault on channel 5.
        """
    @channel5BreakerFault.setter
    def channel5BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel6BreakerFault(self) -> int:
        """
        Breaker fault on channel 6.
        """
    @channel6BreakerFault.setter
    def channel6BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel7BreakerFault(self) -> int:
        """
        Breaker fault on channel 7.
        """
    @channel7BreakerFault.setter
    def channel7BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel8BreakerFault(self) -> int:
        """
        Breaker fault on channel 8.
        """
    @channel8BreakerFault.setter
    def channel8BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel9BreakerFault(self) -> int:
        """
        Breaker fault on channel 9.
        """
    @channel9BreakerFault.setter
    def channel9BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def hardwareFault(self) -> int:
        """
        The hardware on the device has malfunctioned.
        """
    @hardwareFault.setter
    def hardwareFault(self, arg1: typing.SupportsInt) -> None:
        ...
class PowerDistributionStickyFaults:
    """
    Storage for REV PDH Sticky Faults
    """
    def __init__(self) -> None:
        ...
    @property
    def brownout(self) -> int:
        """
        The input voltage is below the minimum voltage.
        """
    @brownout.setter
    def brownout(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def canBusOff(self) -> int:
        """
        The device's CAN controller experienced a "Bus Off" event.
        """
    @canBusOff.setter
    def canBusOff(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def canWarning(self) -> int:
        """
        A warning was raised by the device's CAN controller.
        """
    @canWarning.setter
    def canWarning(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel0BreakerFault(self) -> int:
        """
        Breaker fault on channel 0.
        """
    @channel0BreakerFault.setter
    def channel0BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel10BreakerFault(self) -> int:
        """
        Breaker fault on channel 10.
        """
    @channel10BreakerFault.setter
    def channel10BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel11BreakerFault(self) -> int:
        """
        Breaker fault on channel 12.
        """
    @channel11BreakerFault.setter
    def channel11BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel12BreakerFault(self) -> int:
        """
        Breaker fault on channel 13.
        """
    @channel12BreakerFault.setter
    def channel12BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel13BreakerFault(self) -> int:
        """
        Breaker fault on channel 14.
        """
    @channel13BreakerFault.setter
    def channel13BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel14BreakerFault(self) -> int:
        """
        Breaker fault on channel 15.
        """
    @channel14BreakerFault.setter
    def channel14BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel15BreakerFault(self) -> int:
        """
        Breaker fault on channel 16.
        """
    @channel15BreakerFault.setter
    def channel15BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel16BreakerFault(self) -> int:
        """
        Breaker fault on channel 17.
        """
    @channel16BreakerFault.setter
    def channel16BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel17BreakerFault(self) -> int:
        """
        Breaker fault on channel 18.
        """
    @channel17BreakerFault.setter
    def channel17BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel18BreakerFault(self) -> int:
        """
        Breaker fault on channel 19.
        """
    @channel18BreakerFault.setter
    def channel18BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel19BreakerFault(self) -> int:
        """
        Breaker fault on channel 20.
        """
    @channel19BreakerFault.setter
    def channel19BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel1BreakerFault(self) -> int:
        """
        Breaker fault on channel 1.
        """
    @channel1BreakerFault.setter
    def channel1BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel20BreakerFault(self) -> int:
        """
        Breaker fault on channel 21.
        """
    @channel20BreakerFault.setter
    def channel20BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel21BreakerFault(self) -> int:
        """
        Breaker fault on channel 22.
        """
    @channel21BreakerFault.setter
    def channel21BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel22BreakerFault(self) -> int:
        """
        Breaker fault on channel 23.
        """
    @channel22BreakerFault.setter
    def channel22BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel23BreakerFault(self) -> int:
        """
        Breaker fault on channel 24.
        """
    @channel23BreakerFault.setter
    def channel23BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel2BreakerFault(self) -> int:
        """
        Breaker fault on channel 2.
        """
    @channel2BreakerFault.setter
    def channel2BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel3BreakerFault(self) -> int:
        """
        Breaker fault on channel 3.
        """
    @channel3BreakerFault.setter
    def channel3BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel4BreakerFault(self) -> int:
        """
        Breaker fault on channel 4.
        """
    @channel4BreakerFault.setter
    def channel4BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel5BreakerFault(self) -> int:
        """
        Breaker fault on channel 5.
        """
    @channel5BreakerFault.setter
    def channel5BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel6BreakerFault(self) -> int:
        """
        Breaker fault on channel 6.
        """
    @channel6BreakerFault.setter
    def channel6BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel7BreakerFault(self) -> int:
        """
        Breaker fault on channel 7.
        """
    @channel7BreakerFault.setter
    def channel7BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel8BreakerFault(self) -> int:
        """
        Breaker fault on channel 8.
        """
    @channel8BreakerFault.setter
    def channel8BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel9BreakerFault(self) -> int:
        """
        Breaker fault on channel 9.
        """
    @channel9BreakerFault.setter
    def channel9BreakerFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def firmwareFault(self) -> int:
        """
        The firmware on the device has malfunctioned.
        """
    @firmwareFault.setter
    def firmwareFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def hardwareFault(self) -> int:
        """
        The hardware on the device has malfunctioned.
        """
    @hardwareFault.setter
    def hardwareFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def hasReset(self) -> int:
        """
        The device has rebooted.
        """
    @hasReset.setter
    def hasReset(self, arg1: typing.SupportsInt) -> None:
        ...
class PowerDistributionType:
    """
    The types of power distribution devices.
    
    Members:
    
      kAutomatic : Automatically determines the module type
    
      kCTRE : CTRE (Cross The Road Electronics) Power Distribution Panel (PDP).
    
      kRev : REV Power Distribution Hub (PDH).
    """
    __members__: typing.ClassVar[dict[str, PowerDistributionType]]  # value = {'kAutomatic': <PowerDistributionType.kAutomatic: 0>, 'kCTRE': <PowerDistributionType.kCTRE: 1>, 'kRev': <PowerDistributionType.kRev: 2>}
    kAutomatic: typing.ClassVar[PowerDistributionType]  # value = <PowerDistributionType.kAutomatic: 0>
    kCTRE: typing.ClassVar[PowerDistributionType]  # value = <PowerDistributionType.kCTRE: 1>
    kRev: typing.ClassVar[PowerDistributionType]  # value = <PowerDistributionType.kRev: 2>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class PowerDistributionVersion:
    """
    Power distribution version.
    """
    def __init__(self) -> None:
        ...
    @property
    def firmwareFix(self) -> int:
        """
        Firmware fix version number.
        """
    @firmwareFix.setter
    def firmwareFix(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def firmwareMajor(self) -> int:
        """
        Firmware major version number.
        """
    @firmwareMajor.setter
    def firmwareMajor(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def firmwareMinor(self) -> int:
        """
        Firmware minor version number.
        """
    @firmwareMinor.setter
    def firmwareMinor(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def hardwareMajor(self) -> int:
        """
        Hardware major version number.
        """
    @hardwareMajor.setter
    def hardwareMajor(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def hardwareMinor(self) -> int:
        """
        Hardware minor version number.
        """
    @hardwareMinor.setter
    def hardwareMinor(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def uniqueId(self) -> int:
        """
        Unique ID.
        """
    @uniqueId.setter
    def uniqueId(self, arg0: typing.SupportsInt) -> None:
        ...
class REVPHCompressorConfig:
    """
    Storage for compressor config
    """
    def __init__(self) -> None:
        ...
    @property
    def forceDisable(self) -> int:
        ...
    @forceDisable.setter
    def forceDisable(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def maxAnalogVoltage(self) -> float:
        ...
    @maxAnalogVoltage.setter
    def maxAnalogVoltage(self, arg0: typing.SupportsFloat) -> None:
        ...
    @property
    def minAnalogVoltage(self) -> float:
        ...
    @minAnalogVoltage.setter
    def minAnalogVoltage(self, arg0: typing.SupportsFloat) -> None:
        ...
    @property
    def useDigital(self) -> int:
        ...
    @useDigital.setter
    def useDigital(self, arg0: typing.SupportsInt) -> None:
        ...
class REVPHCompressorConfigType:
    """
    The compressor configuration type
    
    Members:
    
      kDisabled : Disabled.
    
      kDigital : Digital.
    
      kAnalog : Analog.
    
      kHybrid : Hybrid.
    """
    __members__: typing.ClassVar[dict[str, REVPHCompressorConfigType]]  # value = {'kDisabled': <REVPHCompressorConfigType.kDisabled: 0>, 'kDigital': <REVPHCompressorConfigType.kDigital: 1>, 'kAnalog': <REVPHCompressorConfigType.kAnalog: 2>, 'kHybrid': <REVPHCompressorConfigType.kHybrid: 3>}
    kAnalog: typing.ClassVar[REVPHCompressorConfigType]  # value = <REVPHCompressorConfigType.kAnalog: 2>
    kDigital: typing.ClassVar[REVPHCompressorConfigType]  # value = <REVPHCompressorConfigType.kDigital: 1>
    kDisabled: typing.ClassVar[REVPHCompressorConfigType]  # value = <REVPHCompressorConfigType.kDisabled: 0>
    kHybrid: typing.ClassVar[REVPHCompressorConfigType]  # value = <REVPHCompressorConfigType.kHybrid: 3>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class REVPHFaults:
    """
    Storage for REV PH Faults
    """
    def __init__(self) -> None:
        ...
    @property
    def brownout(self) -> int:
        """
        The input voltage is below the minimum voltage.
        """
    @brownout.setter
    def brownout(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def canWarning(self) -> int:
        """
        A warning was raised by the device's CAN controller.
        """
    @canWarning.setter
    def canWarning(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel0Fault(self) -> int:
        """
        Fault on channel 0.
        """
    @channel0Fault.setter
    def channel0Fault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel10Fault(self) -> int:
        """
        Fault on channel 10.
        """
    @channel10Fault.setter
    def channel10Fault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel11Fault(self) -> int:
        """
        Fault on channel 11.
        """
    @channel11Fault.setter
    def channel11Fault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel12Fault(self) -> int:
        """
        Fault on channel 12.
        """
    @channel12Fault.setter
    def channel12Fault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel13Fault(self) -> int:
        """
        Fault on channel 13.
        """
    @channel13Fault.setter
    def channel13Fault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel14Fault(self) -> int:
        """
        Fault on channel 14.
        """
    @channel14Fault.setter
    def channel14Fault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel15Fault(self) -> int:
        """
        Fault on channel 15.
        """
    @channel15Fault.setter
    def channel15Fault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel1Fault(self) -> int:
        """
        Fault on channel 1.
        """
    @channel1Fault.setter
    def channel1Fault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel2Fault(self) -> int:
        """
        Fault on channel 2.
        """
    @channel2Fault.setter
    def channel2Fault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel3Fault(self) -> int:
        """
        Fault on channel 3.
        """
    @channel3Fault.setter
    def channel3Fault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel4Fault(self) -> int:
        """
        Fault on channel 4.
        """
    @channel4Fault.setter
    def channel4Fault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel5Fault(self) -> int:
        """
        Fault on channel 5.
        """
    @channel5Fault.setter
    def channel5Fault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel6Fault(self) -> int:
        """
        Fault on channel 6.
        """
    @channel6Fault.setter
    def channel6Fault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel7Fault(self) -> int:
        """
        Fault on channel 7.
        """
    @channel7Fault.setter
    def channel7Fault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel8Fault(self) -> int:
        """
        Fault on channel 8.
        """
    @channel8Fault.setter
    def channel8Fault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def channel9Fault(self) -> int:
        """
        Fault on channel 9.
        """
    @channel9Fault.setter
    def channel9Fault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def compressorOpen(self) -> int:
        """
        The compressor output has an open circuit.
        """
    @compressorOpen.setter
    def compressorOpen(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def compressorOverCurrent(self) -> int:
        """
        An overcurrent event occurred on the compressor output.
        """
    @compressorOverCurrent.setter
    def compressorOverCurrent(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def hardwareFault(self) -> int:
        """
        The hardware on the device has malfunctioned.
        """
    @hardwareFault.setter
    def hardwareFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def solenoidOverCurrent(self) -> int:
        """
        An overcurrent event occurred on a solenoid output.
        """
    @solenoidOverCurrent.setter
    def solenoidOverCurrent(self, arg1: typing.SupportsInt) -> None:
        ...
class REVPHStickyFaults:
    """
    Storage for REV PH Sticky Faults
    """
    def __init__(self) -> None:
        ...
    @property
    def brownout(self) -> int:
        """
        The input voltage is below the minimum voltage.
        """
    @brownout.setter
    def brownout(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def canBusOff(self) -> int:
        """
        The device's CAN controller experienced a "Bus Off" event.
        """
    @canBusOff.setter
    def canBusOff(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def canWarning(self) -> int:
        """
        A warning was raised by the device's CAN controller.
        """
    @canWarning.setter
    def canWarning(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def compressorOpen(self) -> int:
        """
        The compressor output has an open circuit.
        """
    @compressorOpen.setter
    def compressorOpen(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def compressorOverCurrent(self) -> int:
        """
        An overcurrent event occurred on the compressor output.
        """
    @compressorOverCurrent.setter
    def compressorOverCurrent(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def firmwareFault(self) -> int:
        """
        The firmware on the device has malfunctioned.
        """
    @firmwareFault.setter
    def firmwareFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def hardwareFault(self) -> int:
        """
        The hardware on the device has malfunctioned.
        """
    @hardwareFault.setter
    def hardwareFault(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def hasReset(self) -> int:
        """
        The device has rebooted.
        """
    @hasReset.setter
    def hasReset(self, arg1: typing.SupportsInt) -> None:
        ...
    @property
    def solenoidOverCurrent(self) -> int:
        """
        An overcurrent event occurred on a solenoid output.
        """
    @solenoidOverCurrent.setter
    def solenoidOverCurrent(self, arg1: typing.SupportsInt) -> None:
        ...
class REVPHVersion:
    """
    Storage for REV PH Version
    """
    def __init__(self) -> None:
        ...
    @property
    def firmwareFix(self) -> int:
        """
        The firmware fix version.
        """
    @firmwareFix.setter
    def firmwareFix(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def firmwareMajor(self) -> int:
        """
        The firmware major version.
        """
    @firmwareMajor.setter
    def firmwareMajor(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def firmwareMinor(self) -> int:
        """
        The firmware minor version.
        """
    @firmwareMinor.setter
    def firmwareMinor(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def hardwareMajor(self) -> int:
        """
        The hardware major version.
        """
    @hardwareMajor.setter
    def hardwareMajor(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def hardwareMinor(self) -> int:
        """
        The hardware minor version.
        """
    @hardwareMinor.setter
    def hardwareMinor(self, arg0: typing.SupportsInt) -> None:
        ...
    @property
    def uniqueId(self) -> int:
        """
        The device's unique ID.
        """
    @uniqueId.setter
    def uniqueId(self, arg0: typing.SupportsInt) -> None:
        ...
class RuntimeType:
    """
    Runtime type.
    
    Members:
    
      HAL_Runtime_RoboRIO : roboRIO 1.0
    
      HAL_Runtime_RoboRIO2 : roboRIO 2.0
    
      HAL_Runtime_Simulation : Simulation runtime
    """
    HAL_Runtime_RoboRIO: typing.ClassVar[RuntimeType]  # value = <RuntimeType.HAL_Runtime_RoboRIO: 0>
    HAL_Runtime_RoboRIO2: typing.ClassVar[RuntimeType]  # value = <RuntimeType.HAL_Runtime_RoboRIO2: 1>
    HAL_Runtime_Simulation: typing.ClassVar[RuntimeType]  # value = <RuntimeType.HAL_Runtime_Simulation: 2>
    __members__: typing.ClassVar[dict[str, RuntimeType]]  # value = {'HAL_Runtime_RoboRIO': <RuntimeType.HAL_Runtime_RoboRIO: 0>, 'HAL_Runtime_RoboRIO2': <RuntimeType.HAL_Runtime_RoboRIO2: 1>, 'HAL_Runtime_Simulation': <RuntimeType.HAL_Runtime_Simulation: 2>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class SPIMode:
    """
    SPI mode.
    
    Members:
    
      kMode0 : Clock idle low, data sampled on rising edge.
    
      kMode1 : Clock idle low, data sampled on falling edge.
    
      kMode2 : Clock idle high, data sampled on falling edge.
    
      kMode3 : Clock idle high, data sampled on rising edge.
    """
    __members__: typing.ClassVar[dict[str, SPIMode]]  # value = {'kMode0': <SPIMode.kMode0: 0>, 'kMode1': <SPIMode.kMode1: 1>, 'kMode2': <SPIMode.kMode2: 2>, 'kMode3': <SPIMode.kMode3: 3>}
    kMode0: typing.ClassVar[SPIMode]  # value = <SPIMode.kMode0: 0>
    kMode1: typing.ClassVar[SPIMode]  # value = <SPIMode.kMode1: 1>
    kMode2: typing.ClassVar[SPIMode]  # value = <SPIMode.kMode2: 2>
    kMode3: typing.ClassVar[SPIMode]  # value = <SPIMode.kMode3: 3>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class SPIPort:
    """
    SPI port.
    
    Members:
    
      kInvalid : Invalid port number.
    
      kOnboardCS0 : Onboard SPI bus port CS0.
    
      kOnboardCS1 : Onboard SPI bus port CS1.
    
      kOnboardCS2 : Onboard SPI bus port CS2.
    
      kOnboardCS3 : Onboard SPI bus port CS3.
    
      kMXP : MXP (roboRIO MXP) SPI bus port.
    """
    __members__: typing.ClassVar[dict[str, SPIPort]]  # value = {'kInvalid': <SPIPort.kInvalid: -1>, 'kOnboardCS0': <SPIPort.kOnboardCS0: 0>, 'kOnboardCS1': <SPIPort.kOnboardCS1: 1>, 'kOnboardCS2': <SPIPort.kOnboardCS2: 2>, 'kOnboardCS3': <SPIPort.kOnboardCS3: 3>, 'kMXP': <SPIPort.kMXP: 4>}
    kInvalid: typing.ClassVar[SPIPort]  # value = <SPIPort.kInvalid: -1>
    kMXP: typing.ClassVar[SPIPort]  # value = <SPIPort.kMXP: 4>
    kOnboardCS0: typing.ClassVar[SPIPort]  # value = <SPIPort.kOnboardCS0: 0>
    kOnboardCS1: typing.ClassVar[SPIPort]  # value = <SPIPort.kOnboardCS1: 1>
    kOnboardCS2: typing.ClassVar[SPIPort]  # value = <SPIPort.kOnboardCS2: 2>
    kOnboardCS3: typing.ClassVar[SPIPort]  # value = <SPIPort.kOnboardCS3: 3>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class SerialPort:
    """
    Members:
    
      Onboard
    
      MXP
    
      USB1
    
      USB2
    """
    MXP: typing.ClassVar[SerialPort]  # value = <SerialPort.MXP: 1>
    Onboard: typing.ClassVar[SerialPort]  # value = <SerialPort.Onboard: 0>
    USB1: typing.ClassVar[SerialPort]  # value = <SerialPort.USB1: 2>
    USB2: typing.ClassVar[SerialPort]  # value = <SerialPort.USB2: 3>
    __members__: typing.ClassVar[dict[str, SerialPort]]  # value = {'Onboard': <SerialPort.Onboard: 0>, 'MXP': <SerialPort.MXP: 1>, 'USB1': <SerialPort.USB1: 2>, 'USB2': <SerialPort.USB2: 3>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class SimBoolean(SimValue):
    """
    Wrapper around a HAL simulator boolean value.
    
    It is not useful to construct these directly -- they are returned from
    :meth:`.SimDeviceSim.getBoolean` or :meth:`.SimDevice.createBoolean`.
    """
    value: bool
    def __init__(self, handle: typing.SupportsInt) -> None:
        """
        Wraps a simulated value handle as returned by HAL_CreateSimValueBoolean().
        
        :param handle: simulated value handle
        """
    def __repr__(self) -> str:
        ...
    def get(self) -> bool:
        """
        Gets the simulated value.
        
        :returns: The current value
        """
    def set(self, value: bool) -> None:
        """
        Sets the simulated value.
        
        :param value: the value to set
        """
class SimDevice:
    """
    Wrapper around a HAL simulation 'device'
    
    This creates a simulated 'device' object that can be interacted with
    from user SimDeviceSim objects or via the Simulation GUI.
    
    .. note:: To interact with an existing device use
              :class:`hal.simulation.SimDeviceSim` instead.
    """
    class Direction:
        """
        Direction of a simulated value (from the perspective of user code).
        
        Members:
        
          kInput
        
          kOutput
        
          kBidir
        """
        __members__: typing.ClassVar[dict[str, SimDevice.Direction]]  # value = {'kInput': <Direction.kInput: 0>, 'kOutput': <Direction.kOutput: 1>, 'kBidir': <Direction.kBidir: 2>}
        kBidir: typing.ClassVar[SimDevice.Direction]  # value = <Direction.kBidir: 2>
        kInput: typing.ClassVar[SimDevice.Direction]  # value = <Direction.kInput: 0>
        kOutput: typing.ClassVar[SimDevice.Direction]  # value = <Direction.kOutput: 1>
        def __eq__(self, other: typing.Any) -> bool:
            ...
        def __getstate__(self) -> int:
            ...
        def __hash__(self) -> int:
            ...
        def __index__(self) -> int:
            ...
        def __init__(self, value: typing.SupportsInt) -> None:
            ...
        def __int__(self) -> int:
            ...
        def __ne__(self, other: typing.Any) -> bool:
            ...
        def __repr__(self) -> str:
            ...
        def __setstate__(self, state: typing.SupportsInt) -> None:
            ...
        def __str__(self) -> str:
            ...
        @property
        def name(self) -> str:
            ...
        @property
        def value(self) -> int:
            ...
    def __bool__(self) -> bool:
        ...
    @typing.overload
    def __init__(self, name: str) -> None:
        """
        Creates a simulated device.
        
        The device name must be unique.  Returns null if the device name
        already exists.  If multiple instances of the same device are desired,
        recommend appending the instance/unique identifier in brackets to the base
        name, e.g. "device[1]".
        
        Using a device name of the form "Type:Name" will create a WebSockets node
        with a type value of "Type" and a device value of "Name"
        
        If not in simulation, results in an "empty" object that evaluates to false
        in a boolean context.
        
        :param name: device name
        """
    @typing.overload
    def __init__(self, name: str, index: typing.SupportsInt) -> None:
        """
        Creates a simulated device.
        
        The device name must be unique.  Returns null if the device name
        already exists.  This is a convenience method that appends index in
        brackets to the device name, e.g. passing index=1 results in "device[1]"
        for the device name.
        
        Using a device name of the form "Type:Name" will create a WebSockets node
        with a type value of "Type" and a device value of "Name"
        
        If not in simulation, results in an "empty" object that evaluates to false
        in a boolean context.
        
        :param name:  device name
        :param index: device index number to append to name
        """
    @typing.overload
    def __init__(self, name: str, index: typing.SupportsInt, channel: typing.SupportsInt) -> None:
        """
        Creates a simulated device.
        
        The device name must be unique.  Returns null if the device name
        already exists.  This is a convenience method that appends index and
        channel in brackets to the device name, e.g. passing index=1 and channel=2
        results in "device[1,2]" for the device name.
        
        Using a device name of the form "Type:Name" will create a WebSockets node
        with a type value of "Type" and a device value of "Name"
        
        If not in simulation, results in an "empty" object that evaluates to false
        in a boolean context.
        
        :param name:    device name
        :param index:   device index number to append to name
        :param channel: device channel number to append to name
        """
    def __repr__(self) -> str:
        ...
    def createBoolean(self, name: str, direction: typing.SupportsInt, initialValue: bool) -> SimBoolean:
        """
        Creates a boolean value on the simulated device.
        
        If not in simulation, results in an "empty" object that evaluates to false
        in a boolean context.
        
        :param name:         value name
        :param direction:    input/output/bidir (from perspective of user code)
        :param initialValue: initial value
        
        :returns: simulated boolean value object
        """
    def createDouble(self, name: str, direction: typing.SupportsInt, initialValue: typing.SupportsFloat) -> SimDouble:
        """
        Creates a double value on the simulated device.
        
        If not in simulation, results in an "empty" object that evaluates to false
        in a boolean context.
        
        :param name:         value name
        :param direction:    input/output/bidir (from perspective of user code)
        :param initialValue: initial value
        
        :returns: simulated double value object
        """
    def createEnum(self, name: str, direction: typing.SupportsInt, options: list[str], initialValue: typing.SupportsInt) -> SimEnum:
        """
        Creates an enumerated value on the simulated device.
        
        Enumerated values are always in the range 0 to numOptions-1.
        
        If not in simulation, results in an "empty" object that evaluates to false
        in a boolean context.
        
        :param name:         value name
        :param direction:    input/output/bidir (from perspective of user code)
        :param options:      array of option descriptions
        :param initialValue: initial value (selection)
        
        :returns: simulated enum value object
        """
    def createEnumDouble(self, name: str, direction: typing.SupportsInt, options: list[str], optionValues: list[typing.SupportsFloat], initialValue: typing.SupportsInt) -> SimEnum:
        """
        Creates an enumerated value on the simulated device with double values.
        
        Enumerated values are always in the range 0 to numOptions-1.
        
        If not in simulation, results in an "empty" object that evaluates to false
        in a boolean context.
        
        :param name:         value name
        :param direction:    input/output/bidir (from perspective of user code)
        :param options:      array of option descriptions
        :param optionValues: array of option values (must be the same size as
                             options)
        :param initialValue: initial value (selection)
        
        :returns: simulated enum value object
        """
    def createInt(self, name: str, direction: typing.SupportsInt, initialValue: typing.SupportsInt) -> SimInt:
        """
        Creates an int value on the simulated device.
        
        If not in simulation, results in an "empty" object that evaluates to false
        in a boolean context.
        
        :param name:         value name
        :param direction:    input/output/bidir (from perspective of user code)
        :param initialValue: initial value
        
        :returns: simulated double value object
        """
    def createLong(self, name: str, direction: typing.SupportsInt, initialValue: typing.SupportsInt) -> SimLong:
        """
        Creates a long value on the simulated device.
        
        If not in simulation, results in an "empty" object that evaluates to false
        in a boolean context.
        
        :param name:         value name
        :param direction:    input/output/bidir (from perspective of user code)
        :param initialValue: initial value
        
        :returns: simulated double value object
        """
    def getName(self) -> str:
        """
        Get the name of the simulated device.
        
        :returns: name
        """
    @property
    def name(self) -> str:
        ...
class SimDouble(SimValue):
    """
    Wrapper around a HAL simulator double value.
    
    It is not useful to construct these directly -- they are returned from
    :meth:`.SimDeviceSim.getDouble` or :meth:`.SimDevice.createDouble`.
    """
    def __init__(self, handle: typing.SupportsInt) -> None:
        """
        Wraps a simulated value handle as returned by HAL_CreateSimValueDouble().
        
        :param handle: simulated value handle
        """
    def __repr__(self) -> str:
        ...
    def get(self) -> float:
        """
        Gets the simulated value.
        
        :returns: The current value
        """
    def reset(self) -> None:
        """
        Resets the simulated value to 0. Use this instead of Set(0) for resetting
        incremental sensor values like encoder counts or gyro accumulated angle
        to ensure correct behavior in a distributed system (e.g. WebSockets).
        """
    def set(self, value: typing.SupportsFloat) -> None:
        """
        Sets the simulated value.
        
        :param value: the value to set
        """
    @property
    def value(self) -> float:
        ...
    @value.setter
    def value(self, arg1: typing.SupportsFloat) -> None:
        ...
class SimEnum(SimValue):
    """
    Wrapper around a HAL simulator enum value.
    
    It is not useful to construct these directly -- they are returned from
    :meth:`.SimDeviceSim.getEnum` or :meth:`.SimDevice.createEnum`.
    """
    def __init__(self, handle: typing.SupportsInt) -> None:
        """
        Wraps a simulated value handle as returned by HAL_CreateSimValueEnum().
        
        :param handle: simulated value handle
        """
    def __repr__(self) -> str:
        ...
    def get(self) -> int:
        """
        Gets the simulated value.
        
        :returns: The current value
        """
    def set(self, value: typing.SupportsInt) -> None:
        """
        Sets the simulated value.
        
        :param value: the value to set
        """
    @property
    def value(self) -> int:
        ...
    @value.setter
    def value(self, arg1: typing.SupportsInt) -> None:
        ...
class SimInt(SimValue):
    """
    Wrapper around a HAL simulator int value handle.
    
    It is not useful to construct these directly, they are returned
    from various functions.
    """
    def __init__(self, handle: typing.SupportsInt) -> None:
        """
        Wraps a simulated value handle as returned by HAL_CreateSimValueInt().
        
        :param handle: simulated value handle
        """
    def __repr__(self) -> str:
        ...
    def get(self) -> int:
        """
        Gets the simulated value.
        
        :returns: The current value
        """
    def reset(self) -> None:
        """
        Resets the simulated value to 0. Use this instead of Set(0) for resetting
        incremental sensor values like encoder counts or gyro accumulated angle
        to ensure correct behavior in a distributed system (e.g. WebSockets).
        """
    def set(self, value: typing.SupportsInt) -> None:
        """
        Sets the simulated value.
        
        :param value: the value to set
        """
    @property
    def value(self) -> int:
        ...
    @value.setter
    def value(self, arg1: typing.SupportsInt) -> None:
        ...
class SimLong(SimValue):
    """
    Wrapper around a HAL simulator long value handle.
    
    It is not useful to construct these directly, they are returned
    from various functions.
    """
    def __init__(self, handle: typing.SupportsInt) -> None:
        """
        Wraps a simulated value handle as returned by HAL_CreateSimValueLong().
        
        :param handle: simulated value handle
        """
    def __repr__(self) -> str:
        ...
    def get(self) -> int:
        """
        Gets the simulated value.
        
        :returns: The current value
        """
    def reset(self) -> None:
        """
        Resets the simulated value to 0. Use this instead of Set(0) for resetting
        incremental sensor values like encoder counts or gyro accumulated angle
        to ensure correct behavior in a distributed system (e.g. WebSockets).
        """
    def set(self, value: typing.SupportsInt) -> None:
        """
        Sets the simulated value.
        
        :param value: the value to set
        """
    @property
    def value(self) -> int:
        ...
    @value.setter
    def value(self, arg1: typing.SupportsInt) -> None:
        ...
class SimValue:
    """
    Readonly wrapper around a HAL simulator value.
    
    It is not useful to construct these directly -- they are returned from
    :meth:`.SimDeviceSim.getValue` or :meth:`.SimDevice.createValue`.
    """
    def __bool__(self) -> bool:
        ...
    def __init__(self, handle: typing.SupportsInt) -> None:
        """
        Wraps a simulated value handle as returned by HAL_CreateSimValue().
        
        :param handle: simulated value handle
        """
    def __repr__(self) -> str:
        ...
    @property
    def type(self) -> Type:
        ...
    @property
    def value(self) -> typing.Any:
        ...
class SimValueDirection:
    """
    Direction of a simulated value (from the perspective of user code).
    
    Members:
    
      HAL_SimValueInput : input to user code from the simulator
    
      HAL_SimValueOutput : output from user code to the simulator
    
      HAL_SimValueBidir : bidirectional between user code and simulator
    """
    HAL_SimValueBidir: typing.ClassVar[SimValueDirection]  # value = <SimValueDirection.HAL_SimValueBidir: 2>
    HAL_SimValueInput: typing.ClassVar[SimValueDirection]  # value = <SimValueDirection.HAL_SimValueInput: 0>
    HAL_SimValueOutput: typing.ClassVar[SimValueDirection]  # value = <SimValueDirection.HAL_SimValueOutput: 1>
    __members__: typing.ClassVar[dict[str, SimValueDirection]]  # value = {'HAL_SimValueInput': <SimValueDirection.HAL_SimValueInput: 0>, 'HAL_SimValueOutput': <SimValueDirection.HAL_SimValueOutput: 1>, 'HAL_SimValueBidir': <SimValueDirection.HAL_SimValueBidir: 2>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class Type:
    """
    Members:
    
      UNASSIGNED
    
      BOOLEAN
    
      DOUBLE
    
      ENUM
    
      INT
    
      LONG
    """
    BOOLEAN: typing.ClassVar[Type]  # value = <Type.BOOLEAN: 1>
    DOUBLE: typing.ClassVar[Type]  # value = <Type.DOUBLE: 2>
    ENUM: typing.ClassVar[Type]  # value = <Type.ENUM: 4>
    INT: typing.ClassVar[Type]  # value = <Type.INT: 8>
    LONG: typing.ClassVar[Type]  # value = <Type.LONG: 16>
    UNASSIGNED: typing.ClassVar[Type]  # value = <Type.UNASSIGNED: 0>
    __members__: typing.ClassVar[dict[str, Type]]  # value = {'UNASSIGNED': <Type.UNASSIGNED: 0>, 'BOOLEAN': <Type.BOOLEAN: 1>, 'DOUBLE': <Type.DOUBLE: 2>, 'ENUM': <Type.ENUM: 4>, 'INT': <Type.INT: 8>, 'LONG': <Type.LONG: 16>}
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class Value:
    def __repr__(self) -> str:
        ...
    @property
    def type(self) -> Type:
        ...
    @property
    def value(self) -> typing.Any:
        ...
class tInstances:
    """
    Members:
    
      kLanguage_LabVIEW
    
      kLanguage_CPlusPlus
    
      kLanguage_Java
    
      kLanguage_Python
    
      kLanguage_DotNet
    
      kLanguage_Kotlin
    
      kLanguage_Rust
    
      kCANPlugin_BlackJagBridge
    
      kCANPlugin_2CAN
    
      kFramework_Iterative
    
      kFramework_Simple
    
      kFramework_CommandControl
    
      kFramework_Timed
    
      kFramework_ROS
    
      kFramework_RobotBuilder
    
      kFramework_AdvantageKit
    
      kFramework_MagicBot
    
      kFramework_KitBotTraditional
    
      kFramework_KitBotInline
    
      kRobotDrive_ArcadeStandard
    
      kRobotDrive_ArcadeButtonSpin
    
      kRobotDrive_ArcadeRatioCurve
    
      kRobotDrive_Tank
    
      kRobotDrive_MecanumPolar
    
      kRobotDrive_MecanumCartesian
    
      kRobotDrive2_DifferentialArcade
    
      kRobotDrive2_DifferentialTank
    
      kRobotDrive2_DifferentialCurvature
    
      kRobotDrive2_MecanumCartesian
    
      kRobotDrive2_MecanumPolar
    
      kRobotDrive2_KilloughCartesian
    
      kRobotDrive2_KilloughPolar
    
      kRobotDriveSwerve_Other
    
      kRobotDriveSwerve_YAGSL
    
      kRobotDriveSwerve_CTRE
    
      kRobotDriveSwerve_MaxSwerve
    
      kRobotDriveSwerve_AdvantageKit
    
      kDriverStationCIO_Analog
    
      kDriverStationCIO_DigitalIn
    
      kDriverStationCIO_DigitalOut
    
      kDriverStationEIO_Acceleration
    
      kDriverStationEIO_AnalogIn
    
      kDriverStationEIO_AnalogOut
    
      kDriverStationEIO_Button
    
      kDriverStationEIO_LED
    
      kDriverStationEIO_DigitalIn
    
      kDriverStationEIO_DigitalOut
    
      kDriverStationEIO_FixedDigitalOut
    
      kDriverStationEIO_PWM
    
      kDriverStationEIO_Encoder
    
      kDriverStationEIO_TouchSlider
    
      kADXL345_SPI
    
      kADXL345_I2C
    
      kCommand_Scheduler
    
      kCommand2_Scheduler
    
      kSmartDashboard_Instance
    
      kSmartDashboard_LiveWindow
    
      kKinematics_DifferentialDrive
    
      kKinematics_MecanumDrive
    
      kKinematics_SwerveDrive
    
      kOdometry_DifferentialDrive
    
      kOdometry_MecanumDrive
    
      kOdometry_SwerveDrive
    
      kDashboard_Unknown
    
      kDashboard_Glass
    
      kDashboard_SmartDashboard
    
      kDashboard_Shuffleboard
    
      kDashboard_Elastic
    
      kDashboard_LabVIEW
    
      kDashboard_AdvantageScope
    
      kDashboard_QFRCDashboard
    
      kDashboard_FRCWebComponents
    
      kDataLogLocation_Onboard
    
      kDataLogLocation_USB
    
      kLoggingFramework_Other
    
      kLoggingFramework_Epilogue
    
      kLoggingFramework_Monologue
    
      kLoggingFramework_AdvantageKit
    
      kLoggingFramework_DogLog
    
      kPDP_CTRE
    
      kPDP_REV
    
      kPDP_Unknown
    """
    __members__: typing.ClassVar[dict[str, tInstances]]  # value = {'kLanguage_LabVIEW': <tInstances.kLanguage_LabVIEW: 1>, 'kLanguage_CPlusPlus': <tInstances.kLanguage_CPlusPlus: 2>, 'kLanguage_Java': <tInstances.kLanguage_Java: 3>, 'kLanguage_Python': <tInstances.kLanguage_Python: 4>, 'kLanguage_DotNet': <tInstances.kLanguage_DotNet: 5>, 'kLanguage_Kotlin': <tInstances.kLanguage_Kotlin: 6>, 'kLanguage_Rust': <tInstances.kLanguage_Rust: 7>, 'kCANPlugin_BlackJagBridge': <tInstances.kLanguage_LabVIEW: 1>, 'kCANPlugin_2CAN': <tInstances.kLanguage_CPlusPlus: 2>, 'kFramework_Iterative': <tInstances.kLanguage_LabVIEW: 1>, 'kFramework_Simple': <tInstances.kLanguage_CPlusPlus: 2>, 'kFramework_CommandControl': <tInstances.kLanguage_Java: 3>, 'kFramework_Timed': <tInstances.kLanguage_Python: 4>, 'kFramework_ROS': <tInstances.kLanguage_DotNet: 5>, 'kFramework_RobotBuilder': <tInstances.kLanguage_Kotlin: 6>, 'kFramework_AdvantageKit': <tInstances.kLanguage_Rust: 7>, 'kFramework_MagicBot': <tInstances.kFramework_MagicBot: 8>, 'kFramework_KitBotTraditional': <tInstances.kFramework_KitBotTraditional: 9>, 'kFramework_KitBotInline': <tInstances.kFramework_KitBotInline: 10>, 'kRobotDrive_ArcadeStandard': <tInstances.kLanguage_LabVIEW: 1>, 'kRobotDrive_ArcadeButtonSpin': <tInstances.kLanguage_CPlusPlus: 2>, 'kRobotDrive_ArcadeRatioCurve': <tInstances.kLanguage_Java: 3>, 'kRobotDrive_Tank': <tInstances.kLanguage_Python: 4>, 'kRobotDrive_MecanumPolar': <tInstances.kLanguage_DotNet: 5>, 'kRobotDrive_MecanumCartesian': <tInstances.kLanguage_Kotlin: 6>, 'kRobotDrive2_DifferentialArcade': <tInstances.kLanguage_Rust: 7>, 'kRobotDrive2_DifferentialTank': <tInstances.kFramework_MagicBot: 8>, 'kRobotDrive2_DifferentialCurvature': <tInstances.kFramework_KitBotTraditional: 9>, 'kRobotDrive2_MecanumCartesian': <tInstances.kFramework_KitBotInline: 10>, 'kRobotDrive2_MecanumPolar': <tInstances.kRobotDrive2_MecanumPolar: 11>, 'kRobotDrive2_KilloughCartesian': <tInstances.kRobotDrive2_KilloughCartesian: 12>, 'kRobotDrive2_KilloughPolar': <tInstances.kRobotDrive2_KilloughPolar: 13>, 'kRobotDriveSwerve_Other': <tInstances.kRobotDriveSwerve_Other: 14>, 'kRobotDriveSwerve_YAGSL': <tInstances.kRobotDriveSwerve_YAGSL: 15>, 'kRobotDriveSwerve_CTRE': <tInstances.kRobotDriveSwerve_CTRE: 16>, 'kRobotDriveSwerve_MaxSwerve': <tInstances.kRobotDriveSwerve_MaxSwerve: 17>, 'kRobotDriveSwerve_AdvantageKit': <tInstances.kRobotDriveSwerve_AdvantageKit: 18>, 'kDriverStationCIO_Analog': <tInstances.kLanguage_LabVIEW: 1>, 'kDriverStationCIO_DigitalIn': <tInstances.kLanguage_CPlusPlus: 2>, 'kDriverStationCIO_DigitalOut': <tInstances.kLanguage_Java: 3>, 'kDriverStationEIO_Acceleration': <tInstances.kLanguage_LabVIEW: 1>, 'kDriverStationEIO_AnalogIn': <tInstances.kLanguage_CPlusPlus: 2>, 'kDriverStationEIO_AnalogOut': <tInstances.kLanguage_Java: 3>, 'kDriverStationEIO_Button': <tInstances.kLanguage_Python: 4>, 'kDriverStationEIO_LED': <tInstances.kLanguage_DotNet: 5>, 'kDriverStationEIO_DigitalIn': <tInstances.kLanguage_Kotlin: 6>, 'kDriverStationEIO_DigitalOut': <tInstances.kLanguage_Rust: 7>, 'kDriverStationEIO_FixedDigitalOut': <tInstances.kFramework_MagicBot: 8>, 'kDriverStationEIO_PWM': <tInstances.kFramework_KitBotTraditional: 9>, 'kDriverStationEIO_Encoder': <tInstances.kFramework_KitBotInline: 10>, 'kDriverStationEIO_TouchSlider': <tInstances.kRobotDrive2_MecanumPolar: 11>, 'kADXL345_SPI': <tInstances.kLanguage_LabVIEW: 1>, 'kADXL345_I2C': <tInstances.kLanguage_CPlusPlus: 2>, 'kCommand_Scheduler': <tInstances.kLanguage_LabVIEW: 1>, 'kCommand2_Scheduler': <tInstances.kLanguage_CPlusPlus: 2>, 'kSmartDashboard_Instance': <tInstances.kLanguage_LabVIEW: 1>, 'kSmartDashboard_LiveWindow': <tInstances.kLanguage_CPlusPlus: 2>, 'kKinematics_DifferentialDrive': <tInstances.kLanguage_LabVIEW: 1>, 'kKinematics_MecanumDrive': <tInstances.kLanguage_CPlusPlus: 2>, 'kKinematics_SwerveDrive': <tInstances.kLanguage_Java: 3>, 'kOdometry_DifferentialDrive': <tInstances.kLanguage_LabVIEW: 1>, 'kOdometry_MecanumDrive': <tInstances.kLanguage_CPlusPlus: 2>, 'kOdometry_SwerveDrive': <tInstances.kLanguage_Java: 3>, 'kDashboard_Unknown': <tInstances.kLanguage_LabVIEW: 1>, 'kDashboard_Glass': <tInstances.kLanguage_CPlusPlus: 2>, 'kDashboard_SmartDashboard': <tInstances.kLanguage_Java: 3>, 'kDashboard_Shuffleboard': <tInstances.kLanguage_Python: 4>, 'kDashboard_Elastic': <tInstances.kLanguage_DotNet: 5>, 'kDashboard_LabVIEW': <tInstances.kLanguage_Kotlin: 6>, 'kDashboard_AdvantageScope': <tInstances.kLanguage_Rust: 7>, 'kDashboard_QFRCDashboard': <tInstances.kFramework_MagicBot: 8>, 'kDashboard_FRCWebComponents': <tInstances.kFramework_KitBotTraditional: 9>, 'kDataLogLocation_Onboard': <tInstances.kLanguage_LabVIEW: 1>, 'kDataLogLocation_USB': <tInstances.kLanguage_CPlusPlus: 2>, 'kLoggingFramework_Other': <tInstances.kLanguage_LabVIEW: 1>, 'kLoggingFramework_Epilogue': <tInstances.kLanguage_CPlusPlus: 2>, 'kLoggingFramework_Monologue': <tInstances.kLanguage_Java: 3>, 'kLoggingFramework_AdvantageKit': <tInstances.kLanguage_Python: 4>, 'kLoggingFramework_DogLog': <tInstances.kLanguage_DotNet: 5>, 'kPDP_CTRE': <tInstances.kLanguage_LabVIEW: 1>, 'kPDP_REV': <tInstances.kLanguage_CPlusPlus: 2>, 'kPDP_Unknown': <tInstances.kLanguage_Java: 3>}
    kADXL345_I2C: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_CPlusPlus: 2>
    kADXL345_SPI: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_LabVIEW: 1>
    kCANPlugin_2CAN: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_CPlusPlus: 2>
    kCANPlugin_BlackJagBridge: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_LabVIEW: 1>
    kCommand2_Scheduler: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_CPlusPlus: 2>
    kCommand_Scheduler: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_LabVIEW: 1>
    kDashboard_AdvantageScope: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Rust: 7>
    kDashboard_Elastic: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_DotNet: 5>
    kDashboard_FRCWebComponents: typing.ClassVar[tInstances]  # value = <tInstances.kFramework_KitBotTraditional: 9>
    kDashboard_Glass: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_CPlusPlus: 2>
    kDashboard_LabVIEW: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Kotlin: 6>
    kDashboard_QFRCDashboard: typing.ClassVar[tInstances]  # value = <tInstances.kFramework_MagicBot: 8>
    kDashboard_Shuffleboard: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Python: 4>
    kDashboard_SmartDashboard: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Java: 3>
    kDashboard_Unknown: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_LabVIEW: 1>
    kDataLogLocation_Onboard: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_LabVIEW: 1>
    kDataLogLocation_USB: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_CPlusPlus: 2>
    kDriverStationCIO_Analog: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_LabVIEW: 1>
    kDriverStationCIO_DigitalIn: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_CPlusPlus: 2>
    kDriverStationCIO_DigitalOut: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Java: 3>
    kDriverStationEIO_Acceleration: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_LabVIEW: 1>
    kDriverStationEIO_AnalogIn: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_CPlusPlus: 2>
    kDriverStationEIO_AnalogOut: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Java: 3>
    kDriverStationEIO_Button: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Python: 4>
    kDriverStationEIO_DigitalIn: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Kotlin: 6>
    kDriverStationEIO_DigitalOut: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Rust: 7>
    kDriverStationEIO_Encoder: typing.ClassVar[tInstances]  # value = <tInstances.kFramework_KitBotInline: 10>
    kDriverStationEIO_FixedDigitalOut: typing.ClassVar[tInstances]  # value = <tInstances.kFramework_MagicBot: 8>
    kDriverStationEIO_LED: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_DotNet: 5>
    kDriverStationEIO_PWM: typing.ClassVar[tInstances]  # value = <tInstances.kFramework_KitBotTraditional: 9>
    kDriverStationEIO_TouchSlider: typing.ClassVar[tInstances]  # value = <tInstances.kRobotDrive2_MecanumPolar: 11>
    kFramework_AdvantageKit: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Rust: 7>
    kFramework_CommandControl: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Java: 3>
    kFramework_Iterative: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_LabVIEW: 1>
    kFramework_KitBotInline: typing.ClassVar[tInstances]  # value = <tInstances.kFramework_KitBotInline: 10>
    kFramework_KitBotTraditional: typing.ClassVar[tInstances]  # value = <tInstances.kFramework_KitBotTraditional: 9>
    kFramework_MagicBot: typing.ClassVar[tInstances]  # value = <tInstances.kFramework_MagicBot: 8>
    kFramework_ROS: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_DotNet: 5>
    kFramework_RobotBuilder: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Kotlin: 6>
    kFramework_Simple: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_CPlusPlus: 2>
    kFramework_Timed: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Python: 4>
    kKinematics_DifferentialDrive: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_LabVIEW: 1>
    kKinematics_MecanumDrive: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_CPlusPlus: 2>
    kKinematics_SwerveDrive: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Java: 3>
    kLanguage_CPlusPlus: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_CPlusPlus: 2>
    kLanguage_DotNet: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_DotNet: 5>
    kLanguage_Java: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Java: 3>
    kLanguage_Kotlin: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Kotlin: 6>
    kLanguage_LabVIEW: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_LabVIEW: 1>
    kLanguage_Python: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Python: 4>
    kLanguage_Rust: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Rust: 7>
    kLoggingFramework_AdvantageKit: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Python: 4>
    kLoggingFramework_DogLog: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_DotNet: 5>
    kLoggingFramework_Epilogue: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_CPlusPlus: 2>
    kLoggingFramework_Monologue: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Java: 3>
    kLoggingFramework_Other: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_LabVIEW: 1>
    kOdometry_DifferentialDrive: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_LabVIEW: 1>
    kOdometry_MecanumDrive: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_CPlusPlus: 2>
    kOdometry_SwerveDrive: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Java: 3>
    kPDP_CTRE: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_LabVIEW: 1>
    kPDP_REV: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_CPlusPlus: 2>
    kPDP_Unknown: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Java: 3>
    kRobotDrive2_DifferentialArcade: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Rust: 7>
    kRobotDrive2_DifferentialCurvature: typing.ClassVar[tInstances]  # value = <tInstances.kFramework_KitBotTraditional: 9>
    kRobotDrive2_DifferentialTank: typing.ClassVar[tInstances]  # value = <tInstances.kFramework_MagicBot: 8>
    kRobotDrive2_KilloughCartesian: typing.ClassVar[tInstances]  # value = <tInstances.kRobotDrive2_KilloughCartesian: 12>
    kRobotDrive2_KilloughPolar: typing.ClassVar[tInstances]  # value = <tInstances.kRobotDrive2_KilloughPolar: 13>
    kRobotDrive2_MecanumCartesian: typing.ClassVar[tInstances]  # value = <tInstances.kFramework_KitBotInline: 10>
    kRobotDrive2_MecanumPolar: typing.ClassVar[tInstances]  # value = <tInstances.kRobotDrive2_MecanumPolar: 11>
    kRobotDriveSwerve_AdvantageKit: typing.ClassVar[tInstances]  # value = <tInstances.kRobotDriveSwerve_AdvantageKit: 18>
    kRobotDriveSwerve_CTRE: typing.ClassVar[tInstances]  # value = <tInstances.kRobotDriveSwerve_CTRE: 16>
    kRobotDriveSwerve_MaxSwerve: typing.ClassVar[tInstances]  # value = <tInstances.kRobotDriveSwerve_MaxSwerve: 17>
    kRobotDriveSwerve_Other: typing.ClassVar[tInstances]  # value = <tInstances.kRobotDriveSwerve_Other: 14>
    kRobotDriveSwerve_YAGSL: typing.ClassVar[tInstances]  # value = <tInstances.kRobotDriveSwerve_YAGSL: 15>
    kRobotDrive_ArcadeButtonSpin: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_CPlusPlus: 2>
    kRobotDrive_ArcadeRatioCurve: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Java: 3>
    kRobotDrive_ArcadeStandard: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_LabVIEW: 1>
    kRobotDrive_MecanumCartesian: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Kotlin: 6>
    kRobotDrive_MecanumPolar: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_DotNet: 5>
    kRobotDrive_Tank: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_Python: 4>
    kSmartDashboard_Instance: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_LabVIEW: 1>
    kSmartDashboard_LiveWindow: typing.ClassVar[tInstances]  # value = <tInstances.kLanguage_CPlusPlus: 2>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
class tResourceType:
    """
    Members:
    
      kResourceType_Controller
    
      kResourceType_Module
    
      kResourceType_Language
    
      kResourceType_CANPlugin
    
      kResourceType_Accelerometer
    
      kResourceType_ADXL345
    
      kResourceType_AnalogChannel
    
      kResourceType_AnalogTrigger
    
      kResourceType_AnalogTriggerOutput
    
      kResourceType_CANJaguar
    
      kResourceType_Compressor
    
      kResourceType_Counter
    
      kResourceType_Dashboard
    
      kResourceType_DigitalInput
    
      kResourceType_DigitalOutput
    
      kResourceType_DriverStationCIO
    
      kResourceType_DriverStationEIO
    
      kResourceType_DriverStationLCD
    
      kResourceType_Encoder
    
      kResourceType_GearTooth
    
      kResourceType_Gyro
    
      kResourceType_I2C
    
      kResourceType_Framework
    
      kResourceType_Jaguar
    
      kResourceType_Joystick
    
      kResourceType_Kinect
    
      kResourceType_KinectStick
    
      kResourceType_PIDController
    
      kResourceType_Preferences
    
      kResourceType_PWM
    
      kResourceType_Relay
    
      kResourceType_RobotDrive
    
      kResourceType_SerialPort
    
      kResourceType_Servo
    
      kResourceType_Solenoid
    
      kResourceType_SPI
    
      kResourceType_Task
    
      kResourceType_Ultrasonic
    
      kResourceType_Victor
    
      kResourceType_Button
    
      kResourceType_Command
    
      kResourceType_AxisCamera
    
      kResourceType_PCVideoServer
    
      kResourceType_SmartDashboard
    
      kResourceType_Talon
    
      kResourceType_HiTechnicColorSensor
    
      kResourceType_HiTechnicAccel
    
      kResourceType_HiTechnicCompass
    
      kResourceType_SRF08
    
      kResourceType_AnalogOutput
    
      kResourceType_VictorSP
    
      kResourceType_PWMTalonSRX
    
      kResourceType_CANTalonSRX
    
      kResourceType_ADXL362
    
      kResourceType_ADXRS450
    
      kResourceType_RevSPARK
    
      kResourceType_MindsensorsSD540
    
      kResourceType_DigitalGlitchFilter
    
      kResourceType_ADIS16448
    
      kResourceType_PDP
    
      kResourceType_PCM
    
      kResourceType_PigeonIMU
    
      kResourceType_NidecBrushless
    
      kResourceType_CANifier
    
      kResourceType_TalonFX
    
      kResourceType_CTRE_future1
    
      kResourceType_CTRE_future2
    
      kResourceType_CTRE_future3
    
      kResourceType_CTRE_future4
    
      kResourceType_CTRE_future5
    
      kResourceType_CTRE_future6
    
      kResourceType_LinearFilter
    
      kResourceType_XboxController
    
      kResourceType_UsbCamera
    
      kResourceType_NavX
    
      kResourceType_Pixy
    
      kResourceType_Pixy2
    
      kResourceType_ScanseSweep
    
      kResourceType_Shuffleboard
    
      kResourceType_CAN
    
      kResourceType_DigilentDMC60
    
      kResourceType_PWMVictorSPX
    
      kResourceType_RevSparkMaxPWM
    
      kResourceType_RevSparkMaxCAN
    
      kResourceType_ADIS16470
    
      kResourceType_PIDController2
    
      kResourceType_ProfiledPIDController
    
      kResourceType_Kinematics
    
      kResourceType_Odometry
    
      kResourceType_Units
    
      kResourceType_TrapezoidProfile
    
      kResourceType_DutyCycle
    
      kResourceType_AddressableLEDs
    
      kResourceType_FusionVenom
    
      kResourceType_CTRE_future7
    
      kResourceType_CTRE_future8
    
      kResourceType_CTRE_future9
    
      kResourceType_CTRE_future10
    
      kResourceType_CTRE_future11
    
      kResourceType_CTRE_future12
    
      kResourceType_CTRE_future13
    
      kResourceType_CTRE_future14
    
      kResourceType_ExponentialProfile
    
      kResourceType_PS4Controller
    
      kResourceType_PhotonCamera
    
      kResourceType_PhotonPoseEstimator
    
      kResourceType_PathPlannerPath
    
      kResourceType_PathPlannerAuto
    
      kResourceType_PathFindingCommand
    
      kResourceType_Redux_future1
    
      kResourceType_Redux_future2
    
      kResourceType_Redux_future3
    
      kResourceType_Redux_future4
    
      kResourceType_Redux_future5
    
      kResourceType_RevSparkFlexCAN
    
      kResourceType_RevSparkFlexPWM
    
      kResourceType_BangBangController
    
      kResourceType_DataLogManager
    
      kResourceType_LoggingFramework
    
      kResourceType_ChoreoTrajectory
    
      kResourceType_ChoreoTrigger
    
      kResourceType_PathWeaverTrajectory
    
      kResourceType_Koors40
    
      kResourceType_ThriftyNova
    
      kResourceType_RevServoHub
    
      kResourceType_PWFSEN36005
    
      kResourceType_LaserShark
    """
    __members__: typing.ClassVar[dict[str, tResourceType]]  # value = {'kResourceType_Controller': <tResourceType.kResourceType_Controller: 0>, 'kResourceType_Module': <tResourceType.kResourceType_Module: 1>, 'kResourceType_Language': <tResourceType.kResourceType_Language: 2>, 'kResourceType_CANPlugin': <tResourceType.kResourceType_CANPlugin: 3>, 'kResourceType_Accelerometer': <tResourceType.kResourceType_Accelerometer: 4>, 'kResourceType_ADXL345': <tResourceType.kResourceType_ADXL345: 5>, 'kResourceType_AnalogChannel': <tResourceType.kResourceType_AnalogChannel: 6>, 'kResourceType_AnalogTrigger': <tResourceType.kResourceType_AnalogTrigger: 7>, 'kResourceType_AnalogTriggerOutput': <tResourceType.kResourceType_AnalogTriggerOutput: 8>, 'kResourceType_CANJaguar': <tResourceType.kResourceType_CANJaguar: 9>, 'kResourceType_Compressor': <tResourceType.kResourceType_Compressor: 10>, 'kResourceType_Counter': <tResourceType.kResourceType_Counter: 11>, 'kResourceType_Dashboard': <tResourceType.kResourceType_Dashboard: 12>, 'kResourceType_DigitalInput': <tResourceType.kResourceType_DigitalInput: 13>, 'kResourceType_DigitalOutput': <tResourceType.kResourceType_DigitalOutput: 14>, 'kResourceType_DriverStationCIO': <tResourceType.kResourceType_DriverStationCIO: 15>, 'kResourceType_DriverStationEIO': <tResourceType.kResourceType_DriverStationEIO: 16>, 'kResourceType_DriverStationLCD': <tResourceType.kResourceType_DriverStationLCD: 17>, 'kResourceType_Encoder': <tResourceType.kResourceType_Encoder: 18>, 'kResourceType_GearTooth': <tResourceType.kResourceType_GearTooth: 19>, 'kResourceType_Gyro': <tResourceType.kResourceType_Gyro: 20>, 'kResourceType_I2C': <tResourceType.kResourceType_I2C: 21>, 'kResourceType_Framework': <tResourceType.kResourceType_Framework: 22>, 'kResourceType_Jaguar': <tResourceType.kResourceType_Jaguar: 23>, 'kResourceType_Joystick': <tResourceType.kResourceType_Joystick: 24>, 'kResourceType_Kinect': <tResourceType.kResourceType_Kinect: 25>, 'kResourceType_KinectStick': <tResourceType.kResourceType_KinectStick: 26>, 'kResourceType_PIDController': <tResourceType.kResourceType_PIDController: 27>, 'kResourceType_Preferences': <tResourceType.kResourceType_Preferences: 28>, 'kResourceType_PWM': <tResourceType.kResourceType_PWM: 29>, 'kResourceType_Relay': <tResourceType.kResourceType_Relay: 30>, 'kResourceType_RobotDrive': <tResourceType.kResourceType_RobotDrive: 31>, 'kResourceType_SerialPort': <tResourceType.kResourceType_SerialPort: 32>, 'kResourceType_Servo': <tResourceType.kResourceType_Servo: 33>, 'kResourceType_Solenoid': <tResourceType.kResourceType_Solenoid: 34>, 'kResourceType_SPI': <tResourceType.kResourceType_SPI: 35>, 'kResourceType_Task': <tResourceType.kResourceType_Task: 36>, 'kResourceType_Ultrasonic': <tResourceType.kResourceType_Ultrasonic: 37>, 'kResourceType_Victor': <tResourceType.kResourceType_Victor: 38>, 'kResourceType_Button': <tResourceType.kResourceType_Button: 39>, 'kResourceType_Command': <tResourceType.kResourceType_Command: 40>, 'kResourceType_AxisCamera': <tResourceType.kResourceType_AxisCamera: 41>, 'kResourceType_PCVideoServer': <tResourceType.kResourceType_PCVideoServer: 42>, 'kResourceType_SmartDashboard': <tResourceType.kResourceType_SmartDashboard: 43>, 'kResourceType_Talon': <tResourceType.kResourceType_Talon: 44>, 'kResourceType_HiTechnicColorSensor': <tResourceType.kResourceType_HiTechnicColorSensor: 45>, 'kResourceType_HiTechnicAccel': <tResourceType.kResourceType_HiTechnicAccel: 46>, 'kResourceType_HiTechnicCompass': <tResourceType.kResourceType_HiTechnicCompass: 47>, 'kResourceType_SRF08': <tResourceType.kResourceType_SRF08: 48>, 'kResourceType_AnalogOutput': <tResourceType.kResourceType_AnalogOutput: 49>, 'kResourceType_VictorSP': <tResourceType.kResourceType_VictorSP: 50>, 'kResourceType_PWMTalonSRX': <tResourceType.kResourceType_PWMTalonSRX: 51>, 'kResourceType_CANTalonSRX': <tResourceType.kResourceType_CANTalonSRX: 52>, 'kResourceType_ADXL362': <tResourceType.kResourceType_ADXL362: 53>, 'kResourceType_ADXRS450': <tResourceType.kResourceType_ADXRS450: 54>, 'kResourceType_RevSPARK': <tResourceType.kResourceType_RevSPARK: 55>, 'kResourceType_MindsensorsSD540': <tResourceType.kResourceType_MindsensorsSD540: 56>, 'kResourceType_DigitalGlitchFilter': <tResourceType.kResourceType_DigitalGlitchFilter: 57>, 'kResourceType_ADIS16448': <tResourceType.kResourceType_ADIS16448: 58>, 'kResourceType_PDP': <tResourceType.kResourceType_PDP: 59>, 'kResourceType_PCM': <tResourceType.kResourceType_PCM: 60>, 'kResourceType_PigeonIMU': <tResourceType.kResourceType_PigeonIMU: 61>, 'kResourceType_NidecBrushless': <tResourceType.kResourceType_NidecBrushless: 62>, 'kResourceType_CANifier': <tResourceType.kResourceType_CANifier: 63>, 'kResourceType_TalonFX': <tResourceType.kResourceType_TalonFX: 64>, 'kResourceType_CTRE_future1': <tResourceType.kResourceType_CTRE_future1: 65>, 'kResourceType_CTRE_future2': <tResourceType.kResourceType_CTRE_future2: 66>, 'kResourceType_CTRE_future3': <tResourceType.kResourceType_CTRE_future3: 67>, 'kResourceType_CTRE_future4': <tResourceType.kResourceType_CTRE_future4: 68>, 'kResourceType_CTRE_future5': <tResourceType.kResourceType_CTRE_future5: 69>, 'kResourceType_CTRE_future6': <tResourceType.kResourceType_CTRE_future6: 70>, 'kResourceType_LinearFilter': <tResourceType.kResourceType_LinearFilter: 71>, 'kResourceType_XboxController': <tResourceType.kResourceType_XboxController: 72>, 'kResourceType_UsbCamera': <tResourceType.kResourceType_UsbCamera: 73>, 'kResourceType_NavX': <tResourceType.kResourceType_NavX: 74>, 'kResourceType_Pixy': <tResourceType.kResourceType_Pixy: 75>, 'kResourceType_Pixy2': <tResourceType.kResourceType_Pixy2: 76>, 'kResourceType_ScanseSweep': <tResourceType.kResourceType_ScanseSweep: 77>, 'kResourceType_Shuffleboard': <tResourceType.kResourceType_Shuffleboard: 78>, 'kResourceType_CAN': <tResourceType.kResourceType_CAN: 79>, 'kResourceType_DigilentDMC60': <tResourceType.kResourceType_DigilentDMC60: 80>, 'kResourceType_PWMVictorSPX': <tResourceType.kResourceType_PWMVictorSPX: 81>, 'kResourceType_RevSparkMaxPWM': <tResourceType.kResourceType_RevSparkMaxPWM: 82>, 'kResourceType_RevSparkMaxCAN': <tResourceType.kResourceType_RevSparkMaxCAN: 83>, 'kResourceType_ADIS16470': <tResourceType.kResourceType_ADIS16470: 84>, 'kResourceType_PIDController2': <tResourceType.kResourceType_PIDController2: 85>, 'kResourceType_ProfiledPIDController': <tResourceType.kResourceType_ProfiledPIDController: 86>, 'kResourceType_Kinematics': <tResourceType.kResourceType_Kinematics: 87>, 'kResourceType_Odometry': <tResourceType.kResourceType_Odometry: 88>, 'kResourceType_Units': <tResourceType.kResourceType_Units: 89>, 'kResourceType_TrapezoidProfile': <tResourceType.kResourceType_TrapezoidProfile: 90>, 'kResourceType_DutyCycle': <tResourceType.kResourceType_DutyCycle: 91>, 'kResourceType_AddressableLEDs': <tResourceType.kResourceType_AddressableLEDs: 92>, 'kResourceType_FusionVenom': <tResourceType.kResourceType_FusionVenom: 93>, 'kResourceType_CTRE_future7': <tResourceType.kResourceType_CTRE_future7: 94>, 'kResourceType_CTRE_future8': <tResourceType.kResourceType_CTRE_future8: 95>, 'kResourceType_CTRE_future9': <tResourceType.kResourceType_CTRE_future9: 96>, 'kResourceType_CTRE_future10': <tResourceType.kResourceType_CTRE_future10: 97>, 'kResourceType_CTRE_future11': <tResourceType.kResourceType_CTRE_future11: 98>, 'kResourceType_CTRE_future12': <tResourceType.kResourceType_CTRE_future12: 99>, 'kResourceType_CTRE_future13': <tResourceType.kResourceType_CTRE_future13: 100>, 'kResourceType_CTRE_future14': <tResourceType.kResourceType_CTRE_future14: 101>, 'kResourceType_ExponentialProfile': <tResourceType.kResourceType_ExponentialProfile: 102>, 'kResourceType_PS4Controller': <tResourceType.kResourceType_PS4Controller: 103>, 'kResourceType_PhotonCamera': <tResourceType.kResourceType_PhotonCamera: 104>, 'kResourceType_PhotonPoseEstimator': <tResourceType.kResourceType_PhotonPoseEstimator: 105>, 'kResourceType_PathPlannerPath': <tResourceType.kResourceType_PathPlannerPath: 106>, 'kResourceType_PathPlannerAuto': <tResourceType.kResourceType_PathPlannerAuto: 107>, 'kResourceType_PathFindingCommand': <tResourceType.kResourceType_PathFindingCommand: 108>, 'kResourceType_Redux_future1': <tResourceType.kResourceType_Redux_future1: 109>, 'kResourceType_Redux_future2': <tResourceType.kResourceType_Redux_future2: 110>, 'kResourceType_Redux_future3': <tResourceType.kResourceType_Redux_future3: 111>, 'kResourceType_Redux_future4': <tResourceType.kResourceType_Redux_future4: 112>, 'kResourceType_Redux_future5': <tResourceType.kResourceType_Redux_future5: 113>, 'kResourceType_RevSparkFlexCAN': <tResourceType.kResourceType_RevSparkFlexCAN: 114>, 'kResourceType_RevSparkFlexPWM': <tResourceType.kResourceType_RevSparkFlexPWM: 115>, 'kResourceType_BangBangController': <tResourceType.kResourceType_BangBangController: 116>, 'kResourceType_DataLogManager': <tResourceType.kResourceType_DataLogManager: 117>, 'kResourceType_LoggingFramework': <tResourceType.kResourceType_LoggingFramework: 118>, 'kResourceType_ChoreoTrajectory': <tResourceType.kResourceType_ChoreoTrajectory: 119>, 'kResourceType_ChoreoTrigger': <tResourceType.kResourceType_ChoreoTrigger: 120>, 'kResourceType_PathWeaverTrajectory': <tResourceType.kResourceType_PathWeaverTrajectory: 121>, 'kResourceType_Koors40': <tResourceType.kResourceType_Koors40: 122>, 'kResourceType_ThriftyNova': <tResourceType.kResourceType_ThriftyNova: 123>, 'kResourceType_RevServoHub': <tResourceType.kResourceType_RevServoHub: 124>, 'kResourceType_PWFSEN36005': <tResourceType.kResourceType_PWFSEN36005: 125>, 'kResourceType_LaserShark': <tResourceType.kResourceType_LaserShark: 126>}
    kResourceType_ADIS16448: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_ADIS16448: 58>
    kResourceType_ADIS16470: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_ADIS16470: 84>
    kResourceType_ADXL345: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_ADXL345: 5>
    kResourceType_ADXL362: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_ADXL362: 53>
    kResourceType_ADXRS450: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_ADXRS450: 54>
    kResourceType_Accelerometer: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Accelerometer: 4>
    kResourceType_AddressableLEDs: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_AddressableLEDs: 92>
    kResourceType_AnalogChannel: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_AnalogChannel: 6>
    kResourceType_AnalogOutput: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_AnalogOutput: 49>
    kResourceType_AnalogTrigger: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_AnalogTrigger: 7>
    kResourceType_AnalogTriggerOutput: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_AnalogTriggerOutput: 8>
    kResourceType_AxisCamera: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_AxisCamera: 41>
    kResourceType_BangBangController: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_BangBangController: 116>
    kResourceType_Button: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Button: 39>
    kResourceType_CAN: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_CAN: 79>
    kResourceType_CANJaguar: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_CANJaguar: 9>
    kResourceType_CANPlugin: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_CANPlugin: 3>
    kResourceType_CANTalonSRX: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_CANTalonSRX: 52>
    kResourceType_CANifier: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_CANifier: 63>
    kResourceType_CTRE_future1: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_CTRE_future1: 65>
    kResourceType_CTRE_future10: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_CTRE_future10: 97>
    kResourceType_CTRE_future11: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_CTRE_future11: 98>
    kResourceType_CTRE_future12: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_CTRE_future12: 99>
    kResourceType_CTRE_future13: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_CTRE_future13: 100>
    kResourceType_CTRE_future14: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_CTRE_future14: 101>
    kResourceType_CTRE_future2: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_CTRE_future2: 66>
    kResourceType_CTRE_future3: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_CTRE_future3: 67>
    kResourceType_CTRE_future4: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_CTRE_future4: 68>
    kResourceType_CTRE_future5: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_CTRE_future5: 69>
    kResourceType_CTRE_future6: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_CTRE_future6: 70>
    kResourceType_CTRE_future7: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_CTRE_future7: 94>
    kResourceType_CTRE_future8: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_CTRE_future8: 95>
    kResourceType_CTRE_future9: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_CTRE_future9: 96>
    kResourceType_ChoreoTrajectory: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_ChoreoTrajectory: 119>
    kResourceType_ChoreoTrigger: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_ChoreoTrigger: 120>
    kResourceType_Command: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Command: 40>
    kResourceType_Compressor: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Compressor: 10>
    kResourceType_Controller: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Controller: 0>
    kResourceType_Counter: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Counter: 11>
    kResourceType_Dashboard: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Dashboard: 12>
    kResourceType_DataLogManager: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_DataLogManager: 117>
    kResourceType_DigilentDMC60: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_DigilentDMC60: 80>
    kResourceType_DigitalGlitchFilter: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_DigitalGlitchFilter: 57>
    kResourceType_DigitalInput: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_DigitalInput: 13>
    kResourceType_DigitalOutput: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_DigitalOutput: 14>
    kResourceType_DriverStationCIO: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_DriverStationCIO: 15>
    kResourceType_DriverStationEIO: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_DriverStationEIO: 16>
    kResourceType_DriverStationLCD: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_DriverStationLCD: 17>
    kResourceType_DutyCycle: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_DutyCycle: 91>
    kResourceType_Encoder: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Encoder: 18>
    kResourceType_ExponentialProfile: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_ExponentialProfile: 102>
    kResourceType_Framework: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Framework: 22>
    kResourceType_FusionVenom: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_FusionVenom: 93>
    kResourceType_GearTooth: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_GearTooth: 19>
    kResourceType_Gyro: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Gyro: 20>
    kResourceType_HiTechnicAccel: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_HiTechnicAccel: 46>
    kResourceType_HiTechnicColorSensor: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_HiTechnicColorSensor: 45>
    kResourceType_HiTechnicCompass: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_HiTechnicCompass: 47>
    kResourceType_I2C: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_I2C: 21>
    kResourceType_Jaguar: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Jaguar: 23>
    kResourceType_Joystick: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Joystick: 24>
    kResourceType_Kinect: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Kinect: 25>
    kResourceType_KinectStick: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_KinectStick: 26>
    kResourceType_Kinematics: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Kinematics: 87>
    kResourceType_Koors40: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Koors40: 122>
    kResourceType_Language: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Language: 2>
    kResourceType_LaserShark: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_LaserShark: 126>
    kResourceType_LinearFilter: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_LinearFilter: 71>
    kResourceType_LoggingFramework: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_LoggingFramework: 118>
    kResourceType_MindsensorsSD540: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_MindsensorsSD540: 56>
    kResourceType_Module: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Module: 1>
    kResourceType_NavX: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_NavX: 74>
    kResourceType_NidecBrushless: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_NidecBrushless: 62>
    kResourceType_Odometry: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Odometry: 88>
    kResourceType_PCM: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_PCM: 60>
    kResourceType_PCVideoServer: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_PCVideoServer: 42>
    kResourceType_PDP: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_PDP: 59>
    kResourceType_PIDController: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_PIDController: 27>
    kResourceType_PIDController2: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_PIDController2: 85>
    kResourceType_PS4Controller: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_PS4Controller: 103>
    kResourceType_PWFSEN36005: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_PWFSEN36005: 125>
    kResourceType_PWM: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_PWM: 29>
    kResourceType_PWMTalonSRX: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_PWMTalonSRX: 51>
    kResourceType_PWMVictorSPX: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_PWMVictorSPX: 81>
    kResourceType_PathFindingCommand: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_PathFindingCommand: 108>
    kResourceType_PathPlannerAuto: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_PathPlannerAuto: 107>
    kResourceType_PathPlannerPath: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_PathPlannerPath: 106>
    kResourceType_PathWeaverTrajectory: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_PathWeaverTrajectory: 121>
    kResourceType_PhotonCamera: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_PhotonCamera: 104>
    kResourceType_PhotonPoseEstimator: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_PhotonPoseEstimator: 105>
    kResourceType_PigeonIMU: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_PigeonIMU: 61>
    kResourceType_Pixy: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Pixy: 75>
    kResourceType_Pixy2: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Pixy2: 76>
    kResourceType_Preferences: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Preferences: 28>
    kResourceType_ProfiledPIDController: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_ProfiledPIDController: 86>
    kResourceType_Redux_future1: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Redux_future1: 109>
    kResourceType_Redux_future2: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Redux_future2: 110>
    kResourceType_Redux_future3: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Redux_future3: 111>
    kResourceType_Redux_future4: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Redux_future4: 112>
    kResourceType_Redux_future5: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Redux_future5: 113>
    kResourceType_Relay: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Relay: 30>
    kResourceType_RevSPARK: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_RevSPARK: 55>
    kResourceType_RevServoHub: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_RevServoHub: 124>
    kResourceType_RevSparkFlexCAN: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_RevSparkFlexCAN: 114>
    kResourceType_RevSparkFlexPWM: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_RevSparkFlexPWM: 115>
    kResourceType_RevSparkMaxCAN: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_RevSparkMaxCAN: 83>
    kResourceType_RevSparkMaxPWM: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_RevSparkMaxPWM: 82>
    kResourceType_RobotDrive: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_RobotDrive: 31>
    kResourceType_SPI: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_SPI: 35>
    kResourceType_SRF08: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_SRF08: 48>
    kResourceType_ScanseSweep: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_ScanseSweep: 77>
    kResourceType_SerialPort: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_SerialPort: 32>
    kResourceType_Servo: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Servo: 33>
    kResourceType_Shuffleboard: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Shuffleboard: 78>
    kResourceType_SmartDashboard: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_SmartDashboard: 43>
    kResourceType_Solenoid: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Solenoid: 34>
    kResourceType_Talon: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Talon: 44>
    kResourceType_TalonFX: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_TalonFX: 64>
    kResourceType_Task: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Task: 36>
    kResourceType_ThriftyNova: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_ThriftyNova: 123>
    kResourceType_TrapezoidProfile: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_TrapezoidProfile: 90>
    kResourceType_Ultrasonic: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Ultrasonic: 37>
    kResourceType_Units: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Units: 89>
    kResourceType_UsbCamera: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_UsbCamera: 73>
    kResourceType_Victor: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_Victor: 38>
    kResourceType_VictorSP: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_VictorSP: 50>
    kResourceType_XboxController: typing.ClassVar[tResourceType]  # value = <tResourceType.kResourceType_XboxController: 72>
    def __eq__(self, other: typing.Any) -> bool:
        ...
    def __getstate__(self) -> int:
        ...
    def __hash__(self) -> int:
        ...
    def __index__(self) -> int:
        ...
    def __init__(self, value: typing.SupportsInt) -> None:
        ...
    def __int__(self) -> int:
        ...
    def __ne__(self, other: typing.Any) -> bool:
        ...
    def __repr__(self) -> str:
        ...
    def __setstate__(self, state: typing.SupportsInt) -> None:
        ...
    def __str__(self) -> str:
        ...
    @property
    def name(self) -> str:
        ...
    @property
    def value(self) -> int:
        ...
def CAN_CloseStreamSession(sessionHandle: typing.SupportsInt) -> None:
    """
    Closes a CAN stream.
    
    :param sessionHandle: the session to close
    """
def CAN_GetCANStatus() -> tuple[float, int, int, int, int, int]:
    """
    Gets CAN status information.
    
    :param out: percentBusUtilization the bus utilization
    :param out: busOffCount           the number of bus off errors
    :param out: txFullCount           the number of tx full errors
    :param out: receiveErrorCount     the number of receive errors
    :param out: transmitErrorCount    the number of transmit errors
    :param out: status                Error status variable. 0 on success.
    """
def CAN_OpenStreamSession(messageID: typing.SupportsInt, messageIDMask: typing.SupportsInt, maxMessages: typing.SupportsInt) -> tuple[int, int]:
    """
    Opens a CAN stream.
    
    :param out: sessionHandle output for the session handle
    :param in:  messageID     the message ID to read
    :param in:  messageIDMask the message ID mask
    :param in:  maxMessages   the maximum number of messages to stream
    :param out: status        Error status variable. 0 on success.
    """
def CAN_ReceiveMessage(messageIDMask: typing.SupportsInt, data: typing_extensions.Buffer) -> tuple[int, int, int, int]:
    """
    Receives a CAN message.
    
    :param out: messageID     store for the received message ID
    :param in:  messageIDMask the message ID mask to look for
    :param out: data          data output (8 bytes)
    :param out: dataSize      data length (0-8 bytes)
    :param out: timeStamp     the packet received timestamp (based off of
                CLOCK_MONOTONIC)
    :param out: status        Error status variable. 0 on success.
    """
def CAN_SendMessage(messageID: typing.SupportsInt, data: typing_extensions.Buffer, periodMs: typing.SupportsInt) -> int:
    """
    Sends a CAN message.
    
    :param in:  messageID the CAN ID to send
    :param in:  data      the data to send (0-8 bytes)
    :param in:  dataSize  the size of the data to send (0-8 bytes)
    :param in:  periodMs  the period to repeat the packet at. Use
                HAL_CAN_SEND_PERIOD_NO_REPEAT to not repeat.
    :param out: status    Error status variable. 0 on success.
    """
def HAL_GetRadioLEDState() -> tuple[HAL_RadioLEDState, int]:
    """
    Get the state of the "Radio" LED.
    
    :param out: status the error code, or 0 for success
    
    :returns: The state of the LED.
    """
def HAL_SetRadioLEDState(state: HAL_RadioLEDState) -> int:
    """
    Set the state of the "Radio" LED.
    
    :param state: The state to set the LED to.
    :param out:   status the error code, or 0 for success
    """
def __test_senderr() -> None:
    ...
def allocateDigitalPWM() -> tuple[int, int]:
    """
    Allocates a DO PWM Generator.
    
    :param out: status Error status variable. 0 on success.
    
    :returns: the allocated digital PWM handle
    """
def calibrateAnalogGyro(handle: typing.SupportsInt) -> int:
    """
    Calibrates the analog gyro.
    
    This happens by calculating the average value of the gyro over 5 seconds, and
    setting that as the center. Note that this call blocks for 5 seconds to
    perform this.
    
    :param in:  handle the gyro handle
    :param out: status Error status variable. 0 on success.
    """
def cancelNotifierAlarm(notifierHandle: typing.SupportsInt) -> int:
    """
    Cancels the next notifier alarm.
    
    This does not cause HAL_WaitForNotifierAlarm to return.
    
    :param in:  notifierHandle the notifier handle
    :param out: status Error status variable. 0 on success.
    """
def checkAnalogInputChannel(channel: typing.SupportsInt) -> int:
    """
    Checks that the analog output channel number is valid.
    Verifies that the analog channel number is one of the legal channel numbers.
    Channel numbers are 0-based.
    
    :param in: channel The analog output channel number.
    
    :returns: Analog channel is valid
    """
def checkAnalogModule(module: typing.SupportsInt) -> int:
    """
    Checks that the analog module number is valid.
    
    :param in: module The analog module number.
    
    :returns: Analog module is valid and present
    """
def checkAnalogOutputChannel(channel: typing.SupportsInt) -> int:
    """
    Checks that the analog output channel number is valid.
    
    Verifies that the analog channel number is one of the legal channel numbers.
    Channel numbers are 0-based.
    
    :returns: Analog channel is valid
    """
def checkCTREPCMSolenoidChannel(channel: typing.SupportsInt) -> int:
    """
    Checks if a solenoid channel number is valid.
    
    :param in: channel the channel to check
    
    :returns: true if the channel is valid, otherwise false
    """
def checkDIOChannel(channel: typing.SupportsInt) -> int:
    """
    Checks if a DIO channel is valid.
    
    :param channel: the channel number to check
    
    :returns: true if the channel is valid, otherwise false
    """
def checkPWMChannel(channel: typing.SupportsInt) -> int:
    """
    Checks if a pwm channel is valid.
    
    :param channel: the channel to check
    
    :returns: true if the channel is valid, otherwise false
    """
def checkPowerDistributionChannel(handle: typing.SupportsInt, channel: typing.SupportsInt) -> int:
    """
    Checks if a PowerDistribution channel is valid.
    
    :param handle:  the module handle
    :param channel: the channel to check
    
    :returns: true if the channel is valid, otherwise false
    """
def checkPowerDistributionModule(module: typing.SupportsInt, type: PowerDistributionType) -> int:
    """
    Checks if a PowerDistribution module is valid.
    
    :param module: the module to check
    :param type:   the type of module
    
    :returns: true if the module is valid, otherwise false
    """
def checkREVPHModuleNumber(module: typing.SupportsInt) -> int:
    """
    Checks if a PH module (CAN ID) is valid.
    
    :param in: module the module to check
    
    :returns: true if the module is valid, otherwise false
    """
def checkREVPHSolenoidChannel(channel: typing.SupportsInt) -> int:
    """
    Checks if a solenoid channel number is valid.
    
    :param in: channel the channel to check
    
    :returns: true if the channel is valid, otherwise false
    """
def checkRelayChannel(channel: typing.SupportsInt) -> int:
    """
    Checks if a relay channel is valid.
    
    :param channel: the channel to check
    
    :returns: true if the channel is valid, otherwise false
    """
def cleanAnalogTrigger(analogTriggerHandle: typing.SupportsInt) -> None:
    """
    Frees an analog trigger.
    
    :param in: analogTriggerHandle the trigger handle
    """
def cleanCAN(handle: typing.SupportsInt) -> None:
    """
    Frees a CAN device
    
    :param handle: the CAN handle
    """
def cleanInterrupts(interruptHandle: typing.SupportsInt) -> None:
    """
    Frees an interrupt.
    
    :param interruptHandle: the interrupt handle
    """
def cleanNotifier(notifierHandle: typing.SupportsInt) -> None:
    """
    Cleans a notifier.
    
    Note this also stops a notifier if it is already running.
    
    :param in: notifierHandle the notifier handle
    """
def cleanPowerDistribution(handle: typing.SupportsInt) -> None:
    """
    Cleans a PowerDistribution module.
    
    :param handle: the module handle
    """
def clearAllCTREPCMStickyFaults(handle: typing.SupportsInt) -> int:
    """
    Clears all sticky faults on this device.
    
    :param in:  handle  the PCM handle
    :param out: status Error status variable. 0 on success.
    """
def clearCounterDownSource(counterHandle: typing.SupportsInt) -> int:
    """
    Disables the down counting source to the counter.
    
    :param in:  counterHandle the counter handle
    :param out: status       Error status variable. 0 on success.
    """
def clearCounterUpSource(counterHandle: typing.SupportsInt) -> int:
    """
    Disables the up counting source to the counter.
    
    :param in:  counterHandle the counter handle
    :param out: status       Error status variable. 0 on success.
    """
def clearPowerDistributionStickyFaults(handle: typing.SupportsInt) -> int:
    """
    Clears any PowerDistribution sticky faults.
    
    :param in:  handle the module handle
    :param out: status Error status variable. 0 on success.
    """
def clearREVPHStickyFaults(handle: typing.SupportsInt) -> int:
    """
    Clears the sticky faults.
    
    :param in:  handle  the PH handle
    :param out: status Error status variable. 0 on success.
    """
def clearSerial(handle: typing.SupportsInt) -> int:
    """
    Clears the receive buffer of the serial port.
    
    :param in:  handle  the serial port handle
    :param out: status the error code, or 0 for success
    """
def closeI2C(port: I2CPort) -> None:
    """
    Closes an I2C port
    
    :param port: The I2C port, 0 for the on-board, 1 for the MXP.
    """
def closeSPI(port: SPIPort) -> None:
    """
    Closes the SPI port.
    
    :param port: The number of the port to use. 0-3 for Onboard CS0-CS2, 4 for MXP
    """
def closeSerial(handle: typing.SupportsInt) -> None:
    """
    Closes a serial port.
    
    :param in: handle  the serial port handle to close
    """
def configureSPIAutoStall(port: SPIPort, csToSclkTicks: typing.SupportsInt, stallTicks: typing.SupportsInt, pow2BytesPerRead: typing.SupportsInt) -> int:
    """
    Configure the Auto SPI Stall time between reads.
    
    :param in:  port             The number of the port to use. 0-3 for Onboard
                CS0-CS2, 4 for MXP.
    :param in:  csToSclkTicks    the number of ticks to wait before asserting the
                cs pin
    :param in:  stallTicks       the number of ticks to stall for
    :param in:  pow2BytesPerRead the number of bytes to read before stalling
    :param out: status          the error code, or 0 for success
    """
def createHandle(index: typing.SupportsInt, handleType: HandleEnum, version: typing.SupportsInt) -> int:
    """
    Create a handle for a specific index, type and version.
    
    Note the version is not checked on the roboRIO.
    
    :param index:      the index
    :param handleType: the handle type
    :param version:    the handle version
    
    :returns: the created handle
    """
def createPortHandle(channel: typing.SupportsInt, module: typing.SupportsInt) -> int:
    """
    Create a port handle.
    
    :param channel: the channel
    :param module:  the module
    
    :returns: port handle for the module and channel
    """
def createPortHandleForSPI(channel: typing.SupportsInt) -> int:
    """
    Create a port handle for SPI.
    
    :param channel: the SPI channel
    
    :returns: port handle for the channel
    """
def disableSerialTermination(handle: typing.SupportsInt) -> int:
    """
    Disables a termination character for reads.
    
    :param in:  handle  the serial port handle
    :param out: status the error code, or 0 for success
    """
def enableSerialTermination(handle: typing.SupportsInt, terminator: str) -> int:
    """
    Sets the termination character that terminates a read.
    
    By default this is disabled.
    
    :param in:  handle      the serial port handle
    :param in:  terminator  the termination character to set
    :param out: status     the error code, or 0 for success
    """
def exitMain() -> None:
    """
    Causes HAL_RunMain() to exit.
    
    If HAL_SetMain() has been called, this calls the exit function provided
    to that function.
    """
def expandFPGATime(unexpandedLower: typing.SupportsInt) -> tuple[int, int]:
    """
    Given an 32 bit FPGA time, expand it to the nearest likely 64 bit FPGA time.
    
    Note: This is making the assumption that the timestamp being converted is
    always in the past.  If you call this with a future timestamp, it probably
    will make it in the past.  If you wait over 70 minutes between capturing the
    bottom 32 bits of the timestamp and expanding it, you will be off by
    multiples of 1<<32 microseconds.
    
    :param in:  unexpandedLower 32 bit FPGA time
    :param out: status the error code, or 0 for success
    
    :returns: The current time in microseconds according to the FPGA (since FPGA
              reset) as a 64 bit number.
    """
def fireCTREPCMOneShot(handle: typing.SupportsInt, index: typing.SupportsInt) -> int:
    """
    Fire a single solenoid shot.
    
    :param in:  handle  the PCM handle
    :param in:  index solenoid index
    :param out: status Error status variable. 0 on success.
    """
def fireREVPHOneShot(handle: typing.SupportsInt, index: typing.SupportsInt, durMs: typing.SupportsInt) -> int:
    """
    Fire a single solenoid shot for the specified duration.
    
    :param in:  handle  the PH handle
    :param in:  index solenoid index
    :param in:  durMs shot duration in ms
    :param out: status Error status variable. 0 on success.
    """
def flushSerial(handle: typing.SupportsInt) -> int:
    """
    Flushes the serial write buffer out to the port.
    
    :param in:  handle  the serial port handle
    :param out: status the error code, or 0 for success
    """
def forceSPIAutoRead(port: SPIPort) -> int:
    """
    Immediately forces an SPI read to happen.
    
    :param in:  port    The number of the port to use. 0-3 for Onboard CS0-CS2, 4
                for MXP.
    :param out: status the error code, or 0 for success
    """
def format_as(order: AddressableLEDColorOrder) -> int:
    ...
def freeAddressableLED(handle: typing.SupportsInt) -> None:
    """
    Free the Addressable LED Handle.
    
    :param in: handle the Addressable LED handle to free
    """
def freeAnalogGyro(handle: typing.SupportsInt) -> None:
    """
    Frees an analog gyro.
    
    :param handle: the gyro handle
    """
def freeAnalogInputPort(analogPortHandle: typing.SupportsInt) -> None:
    """
    Frees an analog input port.
    
    :param analogPortHandle: Handle to the analog port.
    """
def freeAnalogOutputPort(analogOutputHandle: typing.SupportsInt) -> None:
    """
    Frees an analog output port.
    
    :param analogOutputHandle: the analog output handle
    """
def freeCTREPCM(handle: typing.SupportsInt) -> None:
    """
    Frees a PCM handle.
    
    :param in: handle the PCMhandle
    """
def freeCounter(counterHandle: typing.SupportsInt) -> None:
    """
    Frees a counter.
    
    :param in: counterHandle the counter handle
    """
def freeDIOPort(dioPortHandle: typing.SupportsInt) -> None:
    """
    Frees a DIO port.
    
    :param dioPortHandle: the DIO channel handle
    """
def freeDigitalPWM(pwmGenerator: typing.SupportsInt) -> None:
    """
    Frees the resource associated with a DO PWM generator.
    
    :param in: pwmGenerator the digital PWM handle
    """
def freeDutyCycle(dutyCycleHandle: typing.SupportsInt) -> None:
    """
    Free a DutyCycle.
    
    :param dutyCycleHandle: the duty cycle handle
    """
def freeEncoder(encoderHandle: typing.SupportsInt) -> None:
    """
    Frees an encoder.
    
    :param in: encoderHandle the encoder handle
    """
def freePWMPort(pwmPortHandle: typing.SupportsInt) -> None:
    """
    Frees a PWM port.
    
    :param in: pwmPortHandle the pwm handle
    """
def freeREVPH(handle: typing.SupportsInt) -> None:
    """
    Frees a PH handle.
    
    :param in: handle the PH handle
    """
def freeRelayPort(relayPortHandle: typing.SupportsInt) -> None:
    """
    Frees a relay port.
    
    :param relayPortHandle: the relay handle
    """
def freeSPIAuto(port: SPIPort) -> int:
    """
    Frees an SPI automatic accumulator.
    
    :param in:  port    The number of the port to use. 0-3 for Onboard CS0-CS2, 4
                for MXP.
    :param out: status the error code, or 0 for success
    """
def getAccelerometerX() -> float:
    """
    Gets the x-axis acceleration.
    
    This is a floating point value in units of 1 g-force.
    
    :returns: the X acceleration
    """
def getAccelerometerY() -> float:
    """
    Gets the y-axis acceleration.
    
    This is a floating point value in units of 1 g-force.
    
    :returns: the Y acceleration
    """
def getAccelerometerZ() -> float:
    """
    Gets the z-axis acceleration.
    
    This is a floating point value in units of 1 g-force.
    
    :returns: the Z acceleration
    """
def getAccumulatorCount(analogPortHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Read the number of accumulated values.
    
    Read the count of the accumulated values since the accumulator was last
    Reset().
    
    :param in:  analogPortHandle Handle to the analog port.
    :param out: status Error status variable. 0 on success.
    
    :returns: The number of times samples from the channel were accumulated.
    """
def getAccumulatorOutput(analogPortHandle: typing.SupportsInt) -> tuple[int, int, int]:
    """
    Read the accumulated value and the number of accumulated values atomically.
    
    This function reads the value and count from the FPGA atomically.
    This can be used for averaging.
    
    :param in:  analogPortHandle Handle to the analog port.
    :param in:  value Pointer to the 64-bit accumulated output.
    :param in:  count Pointer to the number of accumulation cycles.
    :param out: status Error status variable. 0 on success.
    """
def getAccumulatorValue(analogPortHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Read the accumulated value.
    
    Read the value that has been accumulating on channel 1.
    The accumulator is attached after the oversample and average engine.
    
    :param in:  analogPortHandle Handle to the analog port.
    :param out: status Error status variable. 0 on success.
    
    :returns: The 64-bit value accumulated since the last Reset().
    """
def getAllJoystickData(axes: JoystickAxes, povs: JoystickPOVs, buttons: JoystickButtons) -> None:
    ...
def getAllianceStation() -> tuple[AllianceStationID, int]:
    """
    Gets the current alliance station ID.
    
    :param out: status the error code, or 0 for success
    
    :returns: the alliance station ID
    """
def getAnalogAverageBits(analogPortHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the number of averaging bits.
    
    This gets the number of averaging bits from the FPGA. The actual number of
    averaged samples is 2**bits. The averaging is done automatically in the FPGA.
    
    :param in:  analogPortHandle Handle to the analog port to use.
    :param out: status the error code, or 0 for success
    
    :returns: Bits to average.
    """
def getAnalogAverageValue(analogPortHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets a sample from the output of the oversample and average engine for the
    channel.
    
    The sample is 12-bit + the value configured in SetOversampleBits().
    The value configured in SetAverageBits() will cause this value to be averaged
    2**bits number of samples. This is not a sliding window.  The sample will not
    change until 2**(OversampleBits + AverageBits) samples have been acquired
    from the module on this channel. Use GetAverageVoltage() to get the analog
    value in calibrated units.
    
    :param in:  analogPortHandle Handle to the analog port to use.
    :param out: status the error code, or 0 for success
    
    :returns: A sample from the oversample and average engine for the channel.
    """
def getAnalogAverageVoltage(analogPortHandle: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets a scaled sample from the output of the oversample and average engine for
    the channel.
    
    The value is scaled to units of Volts using the calibrated scaling data from
    GetLSBWeight() and GetOffset(). Using oversampling will cause this value to
    be higher resolution, but it will update more slowly. Using averaging will
    cause this value to be more stable, but it will update more slowly.
    
    :param in:  analogPortHandle Handle to the analog port to use.
    :param out: status the error code, or 0 for success
    
    :returns: A scaled sample from the output of the oversample and average engine
              for the channel.
    """
def getAnalogGyroAngle(handle: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets the gyro angle in degrees.
    
    :param in:  handle the gyro handle
    :param out: status Error status variable. 0 on success.
    
    :returns: the gyro angle in degrees
    """
def getAnalogGyroCenter(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the calibrated gyro center.
    
    Can be used to not repeat a calibration but reconstruct the gyro object.
    
    :param in:  handle the gyro handle
    :param out: status Error status variable. 0 on success.
    
    :returns: the gyro center
    """
def getAnalogGyroOffset(handle: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets the calibrated gyro offset.
    
    Can be used to not repeat a calibration but reconstruct the gyro object.
    
    :param in:  handle the gyro handle
    :param out: status Error status variable. 0 on success.
    
    :returns: the gyro offset
    """
def getAnalogGyroRate(handle: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets the gyro rate in degrees/second.
    
    :param in:  handle the gyro handle
    :param out: status Error status variable. 0 on success.
    
    :returns: the gyro rate in degrees/second
    """
def getAnalogLSBWeight(analogPortHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the factory scaling least significant bit weight constant.
    The least significant bit weight constant for the channel that was calibrated
    in manufacturing and stored in an eeprom in the module.
    
    Volts = ((LSB_Weight * 1e-9) * raw) - (Offset * 1e-9)
    
    :param in:  analogPortHandle Handle to the analog port to use.
    :param out: status the error code, or 0 for success
    
    :returns: Least significant bit weight.
    """
def getAnalogOffset(analogPortHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the factory scaling offset constant.
    The offset constant for the channel that was calibrated in manufacturing and
    stored in an eeprom in the module.
    
    Volts = ((LSB_Weight * 1e-9) * raw) - (Offset * 1e-9)
    
    :param in:  analogPortHandle Handle to the analog port to use.
    :param out: status Error status variable. 0 on success.
    
    :returns: Offset constant.
    """
def getAnalogOutput(analogOutputHandle: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets the current analog output value.
    
    :param in:  analogOutputHandle the analog output handle
    :param out: status            Error status variable. 0 on success.
    
    :returns: the current output voltage (0-5v)
    """
def getAnalogOversampleBits(analogPortHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the number of oversample bits.
    
    This gets the number of oversample bits from the FPGA. The actual number of
    oversampled values is 2**bits. The oversampling is done automatically in the
    FPGA.
    
    :param in:  analogPortHandle Handle to the analog port to use.
    :param out: status          the error code, or 0 for success
    
    :returns: Bits to oversample.
    """
def getAnalogSampleRate() -> tuple[float, int]:
    """
    Gets the current sample rate.
    
    This assumes one entry in the scan list.
    This is a global setting for the Athena and effects all channels.
    
    :param out: status the error code, or 0 for success
    
    :returns: Sample rate.
    """
def getAnalogTriggerFPGAIndex(analogTriggerHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Get the FPGA index for the AnalogTrigger.
    
    :param in:  analogTriggerHandle the trigger handle
    :param out: status              Error status variable. 0 on success.
    
    :returns: the FPGA index
    """
def getAnalogTriggerInWindow(analogTriggerHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Returns the InWindow output of the analog trigger.
    
    True if the analog input is between the upper and lower limits.
    
    :param in:  analogTriggerHandle the trigger handle
    :param out: status Error status variable. 0 on success.
    
    :returns: the InWindow output of the analog trigger
    """
def getAnalogTriggerOutput(analogTriggerHandle: typing.SupportsInt, type: AnalogTriggerType) -> tuple[int, int]:
    """
    Gets the state of the analog trigger output.
    
    :param in:  analogTriggerHandle the trigger handle
    :param in:  type                the type of trigger to trigger on
    :param out: status              Error status variable. 0 on success.
    
    :returns: the state of the analog trigger output
    """
def getAnalogTriggerTriggerState(analogTriggerHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Returns the TriggerState output of the analog trigger.
    
    True if above upper limit.
    False if below lower limit.
    If in Hysteresis, maintain previous state.
    
    :param in:  analogTriggerHandle the trigger handle
    :param out: status              Error status variable. 0 on success.
    
    :returns: the TriggerState output of the analog trigger
    """
def getAnalogValue(analogPortHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets a sample straight from the channel on this module.
    
    The sample is a 12-bit value representing the 0V to 5V range of the A/D
    converter in the module. The units are in A/D converter codes.  Use
    GetVoltage() to get the analog value in calibrated units.
    
    :param in:  analogPortHandle Handle to the analog port to use.
    :param out: status the error code, or 0 for success
    
    :returns: A sample straight from the channel on this module.
    """
def getAnalogValueToVolts(analogPortHandle: typing.SupportsInt, rawValue: typing.SupportsInt) -> tuple[float, int]:
    """
    Get the analog voltage from a raw value.
    
    :param in:  analogPortHandle  Handle to the analog port the values were read
                from.
    :param in:  rawValue          The raw analog value
    :param out: status           Error status variable. 0 on success.
    
    :returns: The voltage relating to the value
    """
def getAnalogVoltage(analogPortHandle: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets a scaled sample straight from the channel on this module.
    
    The value is scaled to units of Volts using the calibrated scaling data from
    GetLSBWeight() and GetOffset().
    
    :param in:  analogPortHandle Handle to the analog port to use.
    :param out: status the error code, or 0 for success
    
    :returns: A scaled sample straight from the channel on this module.
    """
def getAnalogVoltsToValue(analogPortHandle: typing.SupportsInt, voltage: typing.SupportsFloat) -> tuple[int, int]:
    """
    Converts a voltage to a raw value for a specified channel.
    
    This process depends on the calibration of each channel, so the channel must
    be specified.
    
    @todo This assumes raw values.  Oversampling not supported as is.
    
    :param in:  analogPortHandle Handle to the analog port to use.
    :param in:  voltage The voltage to convert.
    :param out: status the error code, or 0 for success
    
    :returns: The raw value for the channel.
    """
def getBrownedOut() -> tuple[int, int]:
    """
    Gets if the system is in a browned out state.
    
    :param out: status the error code, or 0 for success
    
    :returns: true if the system is in a low voltage brown out, false otherwise
    """
def getBrownoutVoltage() -> tuple[float, int]:
    """
    Get the current brownout voltage setting.
    
    :param out: status the error code, or 0 for success
    
    :returns: The brownout voltage
    """
def getCANPacketBaseTime() -> int:
    """
    Reads the current value of the millisecond-resolution timer that the CAN API
    functions use as a time base.
    
    :returns: Current value of timer used as a base time by the CAN API in
              milliseconds.
    """
def getCPUTemp() -> tuple[float, int]:
    """
    Get the current CPU temperature in degrees Celsius
    
    :param out: status the error code, or 0 for success
    
    :returns: current CPU temperature in degrees Celsius
    """
def getCTREPCMClosedLoopControl(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Get whether the PCM closed loop control is enabled.
    
    :param in:  handle  the PCM handle
    :param out: status Error status variable. 0 on success.
    
    :returns: True if closed loop control is enabled, otherwise false.
    """
def getCTREPCMCompressor(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Get whether compressor is turned on.
    
    :param in:  handle  the PCM handle
    :param out: status Error status variable. 0 on success.
    
    :returns: true if the compressor is turned on
    """
def getCTREPCMCompressorCurrent(handle: typing.SupportsInt) -> tuple[float, int]:
    """
    Returns the current drawn by the compressor.
    
    :param in:  handle  the PCM handle
    :param out: status Error status variable. 0 on success.
    
    :returns: The current drawn by the compressor in amps.
    """
def getCTREPCMCompressorCurrentTooHighFault(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Return whether the compressor current is currently too high.
    
    :param in:  handle  the PCM handle
    :param out: status Error status variable. 0 on success.
    
    :returns: True if the compressor current is too high, otherwise false.
              @see HAL_GetCTREPCMCompressorShortedStickyFault
    """
def getCTREPCMCompressorCurrentTooHighStickyFault(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Returns whether the compressor current has been too high since sticky
    faults were last cleared. This fault is persistent and can be cleared by
    HAL_ClearAllCTREPCMStickyFaults()
    
    :param in:  handle  the PCM handle
    :param out: status Error status variable. 0 on success.
    
    :returns: True if the compressor current has been too high since sticky
              faults were last cleared.
              @see HAL_GetCTREPCMCompressorCurrentTooHighFault()
    """
def getCTREPCMCompressorNotConnectedFault(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Returns whether the compressor is currently disconnected.
    
    :param in:  handle  the PCM handle
    :param out: status Error status variable. 0 on success.
    
    :returns: True if compressor is currently disconnected, otherwise false.
              @see HAL_GetCTREPCMCompressorNotConnectedStickyFault()
    """
def getCTREPCMCompressorNotConnectedStickyFault(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Returns whether the compressor has been disconnected since sticky faults
    were last cleared. This fault is persistent and can be cleared by
    HAL_ClearAllCTREPCMStickyFaults()
    
    :param in:  handle  the PCM handle
    :param out: status Error status variable. 0 on success.
    
    :returns: True if the compressor has been disconnected since sticky faults
              were last cleared, otherwise false.
              @see HAL_GetCTREPCMCompressorShortedFault()
    """
def getCTREPCMCompressorShortedFault(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Returns whether the compressor is currently shorted.
    
    :param in:  handle  the PCM handle
    :param out: status Error status variable. 0 on success.
    
    :returns: True if the compressor is currently shorted, otherwise false.
              @see HAL_GetCTREPCMCompressorShortedStickyFault
    """
def getCTREPCMCompressorShortedStickyFault(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Returns whether the compressor has been shorted since sticky faults were
    last cleared. This fault is persistent and can be cleared by
    HAL_ClearAllCTREPCMStickyFaults()
    
    :param in:  handle  the PCM handle
    :param out: status Error status variable. 0 on success.
    
    :returns: True if the compressor has been shorted since sticky faults were
              last cleared, otherwise false.
              @see HAL_GetCTREPCMCompressorShortedFault()
    """
def getCTREPCMPressureSwitch(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Returns the state of the pressure switch.
    
    :param in:  handle  the PCM handle
    :param out: status Error status variable. 0 on success.
    
    :returns: True if pressure switch indicates that the system is full,
              otherwise false.
    """
def getCTREPCMSolenoidDisabledList(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Get a bitmask of disabled solenoids.
    
    :param in:  handle  the PCM handle
    :param out: status Error status variable. 0 on success.
    
    :returns: Bitmask indicating disabled solenoids. The LSB represents solenoid 0.
    """
def getCTREPCMSolenoidVoltageFault(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Returns whether the solenoid is currently reporting a voltage fault.
    
    :param in:  handle  the PCM handle
    :param out: status Error status variable. 0 on success.
    
    :returns: True if solenoid is reporting a fault, otherwise false.
              @see HAL_GetCTREPCMSolenoidVoltageStickyFault()
    """
def getCTREPCMSolenoidVoltageStickyFault(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Returns whether the solenoid has reported a voltage fault since sticky faults
    were last cleared. This fault is persistent and can be cleared by
    HAL_ClearAllCTREPCMStickyFaults()
    
    :param in:  handle  the PCM handle
    :param out: status Error status variable. 0 on success.
    
    :returns: True if solenoid is reporting a fault, otherwise false.
              @see HAL_GetCTREPCMSolenoidVoltageFault()
    """
def getCTREPCMSolenoids(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets a bitmask of solenoid values.
    
    :param in:  handle  the PCM handle
    :param out: status Error status variable. 0 on success.
    
    :returns: Bitmask containing the state of the solenoids. The LSB represents
              solenoid 0.
    """
def getComments() -> str:
    """
    Returns the comments from the roboRIO web interface.
    
    :param out: comments The comments string. Free with WPI_FreeString
    """
def getCommsDisableCount() -> tuple[int, int]:
    """
    Gets the number of times the system has been disabled due to communication
    errors with the Driver Station.
    
    :returns: number of disables due to communication errors.
    """
def getControlWord(controlWord: ControlWord) -> int:
    """
    Gets the current control word of the driver station.
    
    The control word contains the robot state.
    
    :param controlWord: the control word (out)
    
    :returns: the error code, or 0 for success
    """
def getCounter(counterHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Reads the current counter value.
    
    Reads the value at this instant. It may still be running, so it reflects the
    current value. Next time it is read, it might have a different value.
    
    :param in:  counterHandle the counter handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: the current counter value
    """
def getCounterDirection(counterHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the last direction the counter value changed.
    
    :param in:  counterHandle the counter handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: the last direction the counter value changed
    """
def getCounterPeriod(counterHandle: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets the Period of the most recent count.
    
    Returns the time interval of the most recent count. This can be used for
    velocity calculations to determine shaft speed.
    
    :param in:  counterHandle the counter handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: the period of the last two pulses in units of seconds
    """
def getCounterSamplesToAverage(counterHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the Samples to Average which specifies the number of samples of the
    timer to average when calculating the period. Perform averaging to account
    for mechanical imperfections or as oversampling to increase resolution.
    
    :param in:  counterHandle the counter handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: SamplesToAverage The number of samples being averaged (from 1 to 127)
    """
def getCounterStopped(counterHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Determines if the clock is stopped.
    
    Determine if the clocked input is stopped based on the MaxPeriod value set
    using the SetMaxPeriod method. If the clock exceeds the MaxPeriod, then the
    device (and counter) are assumed to be stopped and it returns true.
    
    :param in:  counterHandle the counter handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: true if the most recent counter period exceeds the MaxPeriod value
              set by SetMaxPeriod
    """
def getCurrentThreadPriority(isRealTime: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the thread priority for the current thread.
    
    :param out: isRealTime Set to true if thread is real-time, otherwise false.
    :param out: status     Error status variable. 0 on success.
    
    :returns: The current thread priority. For real-time, this is 1-99 with 99
              being highest. For non-real-time, this is 0. See "man 7 sched" for
              details.
    """
def getDIO(dioPortHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Reads a digital value from a DIO channel.
    
    :param in:  dioPortHandle the digital port handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: the state of the specified channel
    """
def getDIODirection(dioPortHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Reads the direction of a DIO channel.
    
    :param in:  dioPortHandle the digital port handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: true for input, false for output
    """
def getDutyCycleFPGAIndex(dutyCycleHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Get the FPGA index for the DutyCycle.
    
    :param in:  dutyCycleHandle the duty cycle handle
    :param out: status Error status variable. 0 on success.
    
    :returns: the FPGA index
    """
def getDutyCycleFrequency(dutyCycleHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Get the frequency of the duty cycle signal.
    
    :param in:  dutyCycleHandle the duty cycle handle
    :param out: status Error status variable. 0 on success.
    
    :returns: frequency in Hertz
    """
def getDutyCycleHighTime(dutyCycleHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Get the raw high time of the duty cycle signal.
    
    :param in:  dutyCycleHandle the duty cycle handle
    :param out: status Error status variable. 0 on success.
    
    :returns: high time of last pulse in nanoseconds
    """
def getDutyCycleOutput(dutyCycleHandle: typing.SupportsInt) -> tuple[float, int]:
    """
    Get the output ratio of the duty cycle signal.
    
    0 means always low, 1 means always high.
    
    :param in:  dutyCycleHandle the duty cycle handle
    :param out: status Error status variable. 0 on success.
    
    :returns: output ratio between 0 and 1
    """
def getDutyCycleOutputScaleFactor(dutyCycleHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Get the scale factor of the output.
    
    An output equal to this value is always high, and then linearly scales
    down to 0. Divide a raw result by this in order to get the
    percentage between 0 and 1. Used by DMA.
    
    :param in:  dutyCycleHandle the duty cycle handle
    :param out: status Error status variable. 0 on success.
    
    :returns: the output scale factor
    """
def getEncoder(encoderHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the current counts of the encoder after encoding type scaling.
    
    This is scaled by the value passed during initialization to encodingType.
    
    :param in:  encoderHandle the encoder handle
    :param out: status Error status variable. 0 on success.
    
    :returns: the current scaled count
    """
def getEncoderDecodingScaleFactor(encoderHandle: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets the decoding scale factor of the encoder.
    
    This is used to perform the scaling from raw to type scaled values.
    
    :param in:  encoderHandle the encoder handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: the scale value for the encoder
    """
def getEncoderDirection(encoderHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the last direction the encoder value changed.
    
    :param in:  encoderHandle the encoder handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: the last direction the encoder value changed
    """
def getEncoderDistance(encoderHandle: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets the current distance traveled by the encoder.
    
    This is the encoder count scaled by the distance per pulse set for the
    encoder.
    
    :param in:  encoderHandle the encoder handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: the encoder distance (units are determined by the units
              passed to HAL_SetEncoderDistancePerPulse)
    """
def getEncoderDistancePerPulse(encoderHandle: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets the user set distance per pulse of the encoder.
    
    :param in:  encoderHandle the encoder handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: the set distance per pulse
    """
def getEncoderEncodingScale(encoderHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the encoder scale value.
    
    This is set by the value passed during initialization to encodingType.
    
    :param in:  encoderHandle the encoder handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: the encoder scale value
    """
def getEncoderEncodingType(encoderHandle: typing.SupportsInt) -> tuple[EncoderEncodingType, int]:
    """
    Gets the encoding type of the encoder.
    
    :param in:  encoderHandle the encoder handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: the encoding type
    """
def getEncoderFPGAIndex(encoderHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the FPGA index of the encoder.
    
    :param in:  encoderHandle the encoder handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: the FPGA index of the encoder
    """
def getEncoderPeriod(encoderHandle: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets the Period of the most recent count.
    
    Returns the time interval of the most recent count. This can be used for
    velocity calculations to determine shaft speed.
    
    :param in:  encoderHandle the encoder handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: the period of the last two pulses in units of seconds
    """
def getEncoderRate(encoderHandle: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets the current rate of the encoder.
    
    This is the encoder period scaled by the distance per pulse set for the
    encoder.
    
    :param in:  encoderHandle the encoder handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: the encoder rate (units are determined by the units passed to
              HAL_SetEncoderDistancePerPulse, time value is seconds)
    """
def getEncoderRaw(encoderHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the raw counts of the encoder.
    
    This is not scaled by any values.
    
    :param in:  encoderHandle the encoder handle
    :param out: status Error status variable. 0 on success.
    
    :returns: the raw encoder count
    """
def getEncoderSamplesToAverage(encoderHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the current samples to average value.
    
    :param in:  encoderHandle the encoder handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: the current samples to average value
    """
def getEncoderStopped(encoderHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Determines if the clock is stopped.
    
    Determines if the clocked input is stopped based on the MaxPeriod value set
    using the SetMaxPeriod method. If the clock exceeds the MaxPeriod, then the
    device (and encoder) are assumed to be stopped and it returns true.
    
    :param in:  encoderHandle the encoder handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: true if the most recent encoder period exceeds the MaxPeriod value
              set by SetMaxPeriod
    """
def getErrorMessage(code: typing.SupportsInt) -> str:
    """
    Gets the error message for a specific status code.
    
    :param code: the status code
    
    :returns: the error message for the code. This does not need to be freed.
    """
def getFPGAButton() -> tuple[int, int]:
    """
    Gets the state of the "USER" button on the roboRIO.
    
    @warning the User Button is used to stop user programs from automatically
    loading if it is held for more then 5 seconds. Because of this, it's not
    recommended to be used by teams for any other purpose.
    
    :param out: status the error code, or 0 for success
    
    :returns: true if the button is currently pressed down
    """
def getFPGARevision() -> tuple[int, int]:
    """
    Returns the FPGA Revision number.
    
    The format of the revision is 3 numbers.
    The 12 most significant bits are the Major Revision.
    the next 8 bits are the Minor Revision.
    The 12 least significant bits are the Build Number.
    
    :param out: status the error code, or 0 for success
    
    :returns: FPGA Revision number.
    """
def getFPGATime() -> tuple[int, int]:
    """
    Reads the microsecond-resolution timer on the FPGA.
    
    :param out: status the error code, or 0 for success
    
    :returns: The current time in microseconds according to the FPGA (since FPGA
              reset).
    """
def getFPGAVersion() -> tuple[int, int]:
    """
    Returns the FPGA Version number.
    
    For now, expect this to be competition year.
    
    :param out: status the error code, or 0 for success
    
    :returns: FPGA Version number.
    """
def getFilterPeriod(filterIndex: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the filter period for the specified filter index.
    
    Gets the filter period in FPGA cycles.  Even though there are 2 different
    filter index domains (MXP vs HDR), ignore that distinction for now since it
    complicates the interface.  Set status to NiFpga_Status_SoftwareFault if the
    filter values mismatch.
    
    :param in:  filterIndex the filter index, 0 - 2
    :param out: status     Error status variable. 0 on success.
    
    :returns: The number of FPGA cycles of the filter period.
    """
def getFilterSelect(dioPortHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Reads the filter index from the FPGA.
    
    Gets the filter index used to filter out short pulses.
    
    :param in:  dioPortHandle the digital port handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: filterIndex  the filter index (Must be in the range 0 - 3, where 0
              means "none" and 1 - 3 means filter # filterIndex - 1)
    """
def getHandleIndex(handle: typing.SupportsInt) -> int:
    """
    Get the handle index from a handle.
    
    :param handle: the handle
    
    :returns: the index
    """
def getHandleType(handle: typing.SupportsInt) -> HandleEnum:
    """
    Get the handle type from a handle.
    
    :param handle: the handle
    
    :returns: the type
    """
def getHandleTypedIndex(handle: typing.SupportsInt, enumType: HandleEnum, version: typing.SupportsInt) -> int:
    """
    Get if the handle is a correct type and version.
    
    Note the version is not checked on the roboRIO.
    
    :param handle:   the handle
    :param enumType: the type to check
    :param version:  the handle version to check
    
    :returns: true if the handle is proper version and type, otherwise
              false.
    """
def getJoystickAxes(joystickNum: typing.SupportsInt, axes: JoystickAxes) -> int:
    """
    Gets the axes of a specific joystick.
    
    :param joystickNum: the joystick number
    :param axes:        the axes values (output)
    
    :returns: the error code, or 0 for success
    """
def getJoystickAxisType(joystickNum: typing.SupportsInt, axis: typing.SupportsInt) -> int:
    """
    Gets the type of a specific joystick axis.
    
    This is device specific, and different depending on what system input type
    the joystick uses.
    
    :param joystickNum: the joystick number
    :param axis:        the axis number
    
    :returns: the enumerated axis type
    """
def getJoystickButtons(joystickNum: typing.SupportsInt, buttons: JoystickButtons) -> int:
    """
    Gets the buttons of a specific joystick.
    
    :param joystickNum: the joystick number
    :param buttons:     the button values (output)
    
    :returns: the error code, or 0 for success
    """
def getJoystickDescriptor(joystickNum: typing.SupportsInt, desc: JoystickDescriptor) -> int:
    """
    Retrieves the Joystick Descriptor for particular slot.
    
    :param joystickNum: the joystick number
    :param out:         desc   descriptor (data transfer object) to fill in. desc is
                        filled in regardless of success. In other words, if
                        descriptor is not available, desc is filled in with
                        default values matching the init-values in Java and C++
                        Driver Station for when caller requests a too-large
                        joystick index.
    
    :returns: error code reported from Network Comm back-end.  Zero is good,
              nonzero is bad.
    """
def getJoystickIsXbox(joystickNum: typing.SupportsInt) -> int:
    """
    Gets whether a specific joystick is considered to be an XBox controller.
    
    :param joystickNum: the joystick number
    
    :returns: true if xbox, false otherwise
    """
def getJoystickName(joystickNum: typing.SupportsInt) -> str:
    """
    Gets the name of a joystick.
    
    The returned string must be freed with WPI_FreeString
    
    :param name:        the joystick name string
    :param joystickNum: the joystick number
    """
def getJoystickPOVs(joystickNum: typing.SupportsInt, povs: JoystickPOVs) -> int:
    """
    Gets the POVs of a specific joystick.
    
    :param joystickNum: the joystick number
    :param povs:        the POV values (output)
    
    :returns: the error code, or 0 for success
    """
def getJoystickType(joystickNum: typing.SupportsInt) -> int:
    """
    Gets the type of joystick connected.
    
    This is device specific, and different depending on what system input type
    the joystick uses.
    
    :param joystickNum: the joystick number
    
    :returns: the enumerated joystick type
    """
def getLastError() -> tuple[str, int]:
    """
    Gets the last error set on this thread, or the message for the status code.
    
    If passed HAL_USE_LAST_ERROR, the last error set on the thread will be
    returned.
    
    :param out: status the status code, set to the error status code if input is
                HAL_USE_LAST_ERROR
    
    :returns: the error message for the code. This does not need to be freed,
              but can be overwritten by another hal call on the same thread.
    """
def getMatchInfo(info: MatchInfo) -> int:
    """
    Gets info about a specific match.
    
    :param in: info the match info (output)
    
    :returns: the error code, or 0 for success
    """
def getMatchTime() -> tuple[float, int]:
    """
    Return the approximate match time. The FMS does not send an official match
    time to the robots, but does send an approximate match time. The value will
    count down the time remaining in the current period (auto or teleop).
    Warning: This is not an official time (so it cannot be used to dispute ref
    calls or guarantee that a function will trigger before the match ends).
    
    When connected to the real field, this number only changes in full integer
    increments, and always counts down.
    
    When the DS is in practice mode, this number is a floating point number,
    and counts down.
    
    When the DS is in teleop or autonomous mode, this number is a floating
    point number, and counts up.
    
    Simulation matches DS behavior without an FMS connected.
    
    :param out: status the error code, or 0 for success
    
    :returns: Time remaining in current match period (auto or teleop) in seconds
    """
def getNumAccumulators() -> int:
    """
    Gets the number of analog accumulators in the current system.
    
    :returns: the number of analog accumulators
    """
def getNumAddressableLEDs() -> int:
    """
    Gets the number of addressable LED generators in the current system.
    
    :returns: the number of Addressable LED generators
    """
def getNumAnalogInputs() -> int:
    """
    Gets the number of analog inputs in the current system.
    
    :returns: the number of analog inputs
    """
def getNumAnalogOutputs() -> int:
    """
    Gets the number of analog outputs in the current system.
    
    :returns: the number of analog outputs
    """
def getNumAnalogTriggers() -> int:
    """
    Gets the number of analog triggers in the current system.
    
    :returns: the number of analog triggers
    """
def getNumCTREPCMModules() -> int:
    """
    Gets the number of PCM modules in the current system.
    
    :returns: the number of PCM modules
    """
def getNumCTREPDPChannels() -> int:
    """
    Gets the number of PDP channels in the current system.
    
    :returns: the number of PDP channels
    """
def getNumCTREPDPModules() -> int:
    """
    Gets the number of PDP modules in the current system.
    
    :returns: the number of PDP modules
    """
def getNumCTRESolenoidChannels() -> int:
    """
    Gets the number of solenoid channels in the current system.
    
    :returns: the number of solenoid channels
    """
def getNumCounters() -> int:
    """
    Gets the number of counters in the current system.
    
    :returns: the number of counters
    """
def getNumDigitalChannels() -> int:
    """
    Gets the number of digital channels in the current system.
    
    :returns: the number of digital channels
    """
def getNumDigitalHeaders() -> int:
    """
    Gets the number of digital headers in the current system.
    
    :returns: the number of digital headers
    """
def getNumDigitalPWMOutputs() -> int:
    """
    Gets the number of digital IO PWM outputs in the current system.
    
    :returns: the number of digital IO PWM outputs
    """
def getNumDutyCycles() -> int:
    """
    Gets the number of duty cycle inputs in the current system.
    
    :returns: the number of Duty Cycle inputs
    """
def getNumEncoders() -> int:
    """
    Gets the number of quadrature encoders in the current system.
    
    :returns: the number of quadrature encoders
    """
def getNumInterrupts() -> int:
    """
    Gets the number of interrupts in the current system.
    
    :returns: the number of interrupts
    """
def getNumPWMChannels() -> int:
    """
    Gets the number of PWM channels in the current system.
    
    :returns: the number of PWM channels
    """
def getNumPWMHeaders() -> int:
    """
    Gets the number of PWM headers in the current system.
    
    :returns: the number of PWM headers
    """
def getNumREVPDHChannels() -> int:
    """
    Gets the number of PDH channels in the current system.
    
    :returns: the number of PDH channels
    """
def getNumREVPDHModules() -> int:
    """
    Gets the number of PDH modules in the current system.
    
    :returns: the number of PDH modules
    """
def getNumREVPHChannels() -> int:
    """
    Gets the number of PH channels in the current system.
    
    :returns: the number of PH channels
    """
def getNumREVPHModules() -> int:
    """
    Gets the number of PH modules in the current system.
    
    :returns: the number of PH modules
    """
def getNumRelayChannels() -> int:
    """
    Gets the number of relay channels in the current system.
    
    :returns: the number of relay channels
    """
def getNumRelayHeaders() -> int:
    """
    Gets the number of relay headers in the current system.
    
    :returns: the number of relay headers
    """
def getOutputsEnabled() -> int:
    """
    Gets if outputs are enabled by the control system.
    
    :returns: true if outputs are enabled
    """
def getPWMConfigMicroseconds(pwmPortHandle: typing.SupportsInt) -> tuple[int, int, int, int, int, int]:
    """
    Gets the pwm configuration settings for the PWM channel.
    
    Values are in microseconds.
    
    :param in:  pwmPortHandle  the PWM handle
    :param in:  maxPwm         the maximum PWM value
    :param in:  deadbandMaxPwm the high range of the center deadband
    :param in:  centerPwm      the center PWM value
    :param in:  deadbandMinPwm the low range of the center deadband
    :param in:  minPwm         the minimum PWM value
    :param out: status        Error status variable. 0 on success.
    """
def getPWMCycleStartTime() -> tuple[int, int]:
    """
    Gets the pwm starting cycle time.
    
    This time is relative to the FPGA time.
    
    :param out: status Error status variable. 0 on success.
    
    :returns: the pwm cycle start time
    """
def getPWMEliminateDeadband(pwmPortHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the current eliminate deadband value.
    
    :param in:  pwmPortHandle the PWM handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: true if set, otherwise false
    """
def getPWMLoopTiming() -> tuple[int, int]:
    """
    Gets the loop timing of the PWM system.
    
    :param out: status Error status variable. 0 on success.
    
    :returns: the loop time in clock ticks
    """
def getPWMPosition(pwmPortHandle: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets a position value from a PWM channel.
    
    The values range from 0 to 1.
    
    :param in:  pwmPortHandle the PWM handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: the current positional PWM value
    """
def getPWMPulseTimeMicroseconds(pwmPortHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the current microsecond pulse time from a PWM channel.
    
    :param in:  pwmPortHandle the PWM handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: the current PWM microsecond pulse time
    """
def getPWMSpeed(pwmPortHandle: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets a scaled value from a PWM channel.
    
    The values range from -1 to 1.
    
    :param in:  pwmPortHandle the PWM handle
    :param out: status       Error status variable. 0 on success.
    
    :returns: the current speed PWM value
    """
def getPort(channel: typing.SupportsInt) -> int:
    """
    Gets a port handle for a specific channel.
    
    The created handle does not need to be freed.
    
    :param channel: the channel number
    
    :returns: the created port
    """
def getPortHandleChannel(handle: typing.SupportsInt) -> int:
    """
    Gets the port channel of a port handle.
    
    :param handle: the port handle
    
    :returns: the port channel
    """
def getPortHandleModule(handle: typing.SupportsInt) -> int:
    """
    Gets the port module of a port handle.
    
    :param handle: the port handle
    
    :returns: the port module
    """
def getPortHandleSPIEnable(handle: typing.SupportsInt) -> int:
    """
    Gets the SPI channel of a port handle.
    
    :param handle: the port handle
    
    :returns: the port SPI channel
    """
def getPortWithModule(module: typing.SupportsInt, channel: typing.SupportsInt) -> int:
    """
    Gets a port handle for a specific channel and module.
    
    This is expected to be used for PCMs, as the roboRIO does not work with
    modules anymore.
    
    The created handle does not need to be freed.
    
    :param module:  the module number
    :param channel: the channel number
    
    :returns: the created port
    """
def getPowerDistributionAllChannelCurrents(handle: typing.SupportsInt, currentsLength: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets the current of all channels on the PowerDistribution.
    
    The array must be large enough to hold all channels.
    
    :param in:  handle         the module handle
    :param out: currents      the currents
    :param in:  currentsLength the length of the currents array
    :param out: status        Error status variable. 0 on success.
    """
def getPowerDistributionChannelCurrent(handle: typing.SupportsInt, channel: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets the current of a specific PowerDistribution channel.
    
    :param in:  handle   the module handle
    :param in:  channel  the channel
    :param out: status  Error status variable. 0 on success.
    
    :returns: the channel current (amps)
    """
def getPowerDistributionFaults(handle: typing.SupportsInt, faults: PowerDistributionFaults) -> int:
    """
    Get the current faults of the PowerDistribution.
    
    On a CTRE PDP, this will return an object with no faults active.
    
    :param in:  handle the module handle
    :param out: faults the HAL_PowerDistributionFaults to populate
    :param out: status Error status variable. 0 on success.
    """
def getPowerDistributionModuleNumber(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the module number for a specific handle.
    
    :param in:  handle the module handle
    :param out: status Error status variable. 0 on success.
    
    :returns: the module number
    """
def getPowerDistributionNumChannels(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the number of channels for this handle.
    
    :param in:  handle the handle
    :param out: status Error status variable. 0 on success.
    
    :returns: number of channels
    """
def getPowerDistributionStickyFaults(handle: typing.SupportsInt, stickyFaults: PowerDistributionStickyFaults) -> int:
    """
    Gets the sticky faults of the PowerDistribution.
    
    On a CTRE PDP, this will return an object with no faults active.
    
    :param in:  handle the module handle
    :param out: stickyFaults the HAL_PowerDistributionStickyFaults to populate
    :param out: status Error status variable. 0 on success.
    """
def getPowerDistributionSwitchableChannel(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Returns true if switchable channel is powered on.
    
    This is a REV PDH-specific function. This function will no-op on CTRE PDP.
    
    :param in:  handle the module handle
    :param out: status Error status variable. 0 on success.
    
    :returns: the state of the switchable channel
    """
def getPowerDistributionTemperature(handle: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets the temperature of the Power Distribution Panel.
    
    Not supported on the Rev PDH and returns 0.
    
    :param in:  handle the module handle
    :param out: status Error status variable. 0 on success.
    
    :returns: the module temperature (celsius)
    """
def getPowerDistributionTotalCurrent(handle: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets the total current of the PowerDistribution.
    
    :param in:  handle the module handle
    :param out: status Error status variable. 0 on success.
    
    :returns: the total current (amps)
    """
def getPowerDistributionTotalEnergy(handle: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets the total energy of the Power Distribution Panel.
    
    Not supported on the Rev PDH and returns 0.
    
    :param in:  handle the module handle
    :param out: status Error status variable. 0 on success.
    
    :returns: the total energy (joules)
    """
def getPowerDistributionTotalPower(handle: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets the total power of the Power Distribution Panel.
    
    Not supported on the Rev PDH and returns 0.
    
    :param in:  handle the module handle
    :param out: status Error status variable. 0 on success.
    
    :returns: the total power (watts)
    """
def getPowerDistributionType(handle: typing.SupportsInt) -> tuple[PowerDistributionType, int]:
    """
    Gets the type of PowerDistribution module.
    
    :param in:  handle the module handle
    :param out: status Error status variable. 0 on success.
    
    :returns: the type of module
    """
def getPowerDistributionVersion(handle: typing.SupportsInt, version: PowerDistributionVersion) -> int:
    """
    Get the version of the PowerDistribution.
    
    :param in:  handle the module handle
    :param out: version the HAL_PowerDistributionVersion to populate
    :param out: status Error status variable. 0 on success.
    """
def getPowerDistributionVoltage(handle: typing.SupportsInt) -> tuple[float, int]:
    """
    Gets the PowerDistribution input voltage.
    
    :param in:  handle the module handle
    :param out: status Error status variable. 0 on success.
    
    :returns: the input voltage (volts)
    """
def getREVPH5VVoltage(handle: typing.SupportsInt) -> tuple[float, int]:
    """
    Returns the current voltage of the regulated 5v supply.
    
    :param in:  handle  the PH handle
    :param out: status Error status variable. 0 on success.
    
    :returns: The current voltage of the 5v supply in volts.
    """
def getREVPHAnalogVoltage(handle: typing.SupportsInt, channel: typing.SupportsInt) -> tuple[float, int]:
    """
    Returns the raw voltage of the specified analog
    input channel.
    
    :param in:  handle  the PH handle
    :param in:  channel The analog input channel to read voltage from.
    :param out: status Error status variable. 0 on success.
    
    :returns: The voltage of the specified analog input channel in volts.
    """
def getREVPHCompressor(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Get whether compressor is turned on.
    
    :param in:  handle  the PH handle
    :param out: status Error status variable. 0 on success.
    
    :returns: true if the compressor is turned on
    """
def getREVPHCompressorConfig(handle: typing.SupportsInt) -> tuple[REVPHCompressorConfigType, int]:
    """
    Get compressor configuration from the PH.
    
    :param in:  handle  the PH handle
    :param out: status Error status variable. 0 on success.
    
    :returns: compressor configuration
    """
def getREVPHCompressorCurrent(handle: typing.SupportsInt) -> tuple[float, int]:
    """
    Returns the current drawn by the compressor.
    
    :param in:  handle  the PH handle
    :param out: status Error status variable. 0 on success.
    
    :returns: The current drawn by the compressor in amps.
    """
def getREVPHFaults(handle: typing.SupportsInt, faults: REVPHFaults) -> int:
    """
    Returns the faults currently active on the PH.
    
    :param in:  handle  the PH handle
    :param out: faults The faults.
    :param out: status Error status variable. 0 on success.
    """
def getREVPHPressureSwitch(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Returns the state of the digital pressure switch.
    
    :param in:  handle  the PH handle
    :param out: status Error status variable. 0 on success.
    
    :returns: True if pressure switch indicates that the system is full,
              otherwise false.
    """
def getREVPHSolenoidCurrent(handle: typing.SupportsInt) -> tuple[float, int]:
    """
    Returns the total current drawn by all solenoids.
    
    :param in:  handle  the PH handle
    :param out: status Error status variable. 0 on success.
    
    :returns: Total current drawn by all solenoids in amps.
    """
def getREVPHSolenoidDisabledList(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Get a bitmask of disabled solenoids.
    
    :param in:  handle  the PH handle
    :param out: status Error status variable. 0 on success.
    
    :returns: Bitmask indicating disabled solenoids. The LSB represents solenoid 0.
    """
def getREVPHSolenoidVoltage(handle: typing.SupportsInt) -> tuple[float, int]:
    """
    Returns the current voltage of the solenoid power supply.
    
    :param in:  handle  the PH handle
    :param out: status Error status variable. 0 on success.
    
    :returns: The current voltage of the solenoid power supply in volts.
    """
def getREVPHSolenoids(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets a bitmask of solenoid values.
    
    :param in:  handle  the PH handle
    :param out: status Error status variable. 0 on success.
    
    :returns: Bitmask containing the state of the solenoids. The LSB represents
              solenoid 0.
    """
def getREVPHStickyFaults(handle: typing.SupportsInt, stickyFaults: REVPHStickyFaults) -> int:
    """
    Returns the sticky faults currently active on this device.
    
    :param in:  handle  the PH handle
    :param out: stickyFaults The sticky faults.
    :param out: status Error status variable. 0 on success.
    """
def getREVPHVersion(handle: typing.SupportsInt, version: REVPHVersion) -> int:
    """
    Returns the hardware and firmware versions of the PH.
    
    :param in:  handle  the PH handle
    :param out: version The hardware and firmware versions.
    :param out: status Error status variable. 0 on success.
    """
def getREVPHVoltage(handle: typing.SupportsInt) -> tuple[float, int]:
    """
    Returns the current input voltage for the PH.
    
    :param in:  handle  the PH handle
    :param out: status Error status variable. 0 on success.
    
    :returns: The input voltage in volts.
    """
def getRSLState() -> tuple[int, int]:
    """
    Gets the current state of the Robot Signal Light (RSL).
    
    :param out: status the error code, or 0 for success
    
    :returns: The current state of the RSL- true if on, false if off
    """
def getRelay(relayPortHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the current state of the relay channel.
    
    :param in:  relayPortHandle the relay handle
    :param out: status         Error status variable. 0 on success.
    
    :returns: true for on, false for off
    """
def getRuntimeType() -> RuntimeType:
    """
    Returns the runtime type of the HAL.
    
    :returns: HAL Runtime Type
    """
def getSPIAutoDroppedCount(port: SPIPort) -> tuple[int, int]:
    """
    Gets the count of how many SPI accumulations have been missed.
    
    :param in:  port    The number of the port to use. 0-3 for Onboard CS0-CS2, 4
                for MXP.
    :param out: status the error code, or 0 for success
    
    :returns: The number of missed accumulations.
    """
def getSPIHandle(port: SPIPort) -> int:
    """
    Gets the stored handle for a SPI port.
    
    :param port: The number of the port to use. 0-3 for Onboard CS0-CS2, 4 for MXP
    
    :returns: The stored handle for the SPI port. 0 represents no stored
              handle.
    """
def getSPIMode(port: SPIPort) -> SPIMode:
    """
    Gets the SPI Mode.
    
    :param port: The number of the port to use. 0-3 for Onboard CS0-CS2, 4 for
                 MXP
    
    :returns: The SPI mode currently set
    """
def getSerialBytesReceived(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the number of bytes currently in the read buffer.
    
    :param in:  handle  the serial port handle
    :param out: status the error code, or 0 for success
    
    :returns: the number of bytes in the read buffer
    """
def getSerialFD(handle: typing.SupportsInt) -> tuple[int, int]:
    """
    Gets the raw serial port file descriptor from a handle.
    
    :param in:  handle the serial port handle
    :param out: status the error code, or 0 for success
    
    :returns: the raw port descriptor
    """
def getSerialNumber() -> str:
    """
    Returns the roboRIO serial number.
    
    :param out: serialNumber The roboRIO serial number. Free with WPI_FreeString
    """
def getSystemActive() -> tuple[int, int]:
    """
    Gets if the system outputs are currently active.
    
    :param out: status the error code, or 0 for success
    
    :returns: true if the system outputs are active, false if disabled
    """
def getSystemClockTicksPerMicrosecond() -> int:
    """
    Gets the number of FPGA system clock ticks per microsecond.
    
    :returns: the number of clock ticks per microsecond
    """
def getSystemTimeValid() -> tuple[int, int]:
    """
    Gets if the system time is valid.
    
    :param out: status the error code, or 0 for success
    
    :returns: True if the system time is valid, false otherwise
    """
def getTeamNumber() -> int:
    """
    Returns the team number configured for the robot controller.
    
    :returns: team number, or 0 if not found.
    """
def getUserActive3V3() -> tuple[int, int]:
    """
    Gets the active state of the 3V3 rail.
    
    :param out: status the error code, or 0 for success
    
    :returns: true if the rail is active, otherwise false
    """
def getUserActive5V() -> tuple[int, int]:
    """
    Gets the active state of the 5V rail.
    
    :param out: status the error code, or 0 for success
    
    :returns: true if the rail is active, otherwise false
    """
def getUserActive6V() -> tuple[int, int]:
    """
    Gets the active state of the 6V rail.
    
    :param out: status the error code, or 0 for success
    
    :returns: true if the rail is active, otherwise false
    """
def getUserCurrent3V3() -> tuple[float, int]:
    """
    Gets the 3V3 rail current.
    
    :param out: status the error code, or 0 for success
    
    :returns: the 3V3 rail current (amps)
    """
def getUserCurrent5V() -> tuple[float, int]:
    """
    Gets the 5V rail current.
    
    :param out: status the error code, or 0 for success
    
    :returns: the 5V rail current (amps)
    """
def getUserCurrent6V() -> tuple[float, int]:
    """
    Gets the 6V rail current.
    
    :param out: status the error code, or 0 for success
    
    :returns: the 6V rail current (amps)
    """
def getUserCurrentFaults3V3() -> tuple[int, int]:
    """
    Gets the fault count for the 3V3 rail. Capped at 255.
    
    :param out: status the error code, or 0 for success
    
    :returns: the number of 3V3 fault counts
    """
def getUserCurrentFaults5V() -> tuple[int, int]:
    """
    Gets the fault count for the 5V rail. Capped at 255.
    
    :param out: status the error code, or 0 for success
    
    :returns: the number of 5V fault counts
    """
def getUserCurrentFaults6V() -> tuple[int, int]:
    """
    Gets the fault count for the 6V rail. Capped at 255.
    
    :param out: status the error code, or 0 for success
    
    :returns: the number of 6V fault counts
    """
def getUserVoltage3V3() -> tuple[float, int]:
    """
    Gets the 3V3 rail voltage.
    
    :param out: status the error code, or 0 for success
    
    :returns: the 3V3 rail voltage (volts)
    """
def getUserVoltage5V() -> tuple[float, int]:
    """
    Gets the 5V rail voltage.
    
    :param out: status the error code, or 0 for success
    
    :returns: the 5V rail voltage (volts)
    """
def getUserVoltage6V() -> tuple[float, int]:
    """
    Gets the 6V rail voltage.
    
    :param out: status the error code, or 0 for success
    
    :returns: the 6V rail voltage (volts)
    """
def getVinCurrent() -> tuple[float, int]:
    """
    Gets the roboRIO input current.
    
    :param out: status the error code, or 0 for success
    
    :returns: the input current (amps)
    """
def getVinVoltage() -> tuple[float, int]:
    """
    Gets the roboRIO input voltage.
    
    :param out: status the error code, or 0 for success
    
    :returns: the input voltage (volts)
    """
def hasMain() -> int:
    """
    Returns true if HAL_SetMain() has been called.
    
    :returns: True if HAL_SetMain() has been called, false otherwise.
    """
def initAccumulator(analogPortHandle: typing.SupportsInt) -> int:
    """
    Initialize the accumulator.
    
    :param in:  analogPortHandle Handle to the analog port.
    :param out: status Error status variable. 0 on success.
    """
def initSPIAuto(port: SPIPort, bufferSize: typing.SupportsInt) -> int:
    """
    Initializes the SPI automatic accumulator.
    
    :param in:  port       The number of the port to use. 0-3 for Onboard CS0-CS2,
                4 for MXP.
    :param in:  bufferSize The accumulator buffer size.
    :param out: status    the error code, or 0 for success
    """
def initialize(timeout: typing.SupportsInt, mode: typing.SupportsInt) -> int:
    """
    Call this to start up HAL. This is required for robot programs.
    
    This must be called before any other HAL functions. Failure to do so will
    result in undefined behavior, and likely segmentation faults. This means that
    any statically initialized variables in a program MUST call this function in
    their constructors if they want to use other HAL calls.
    
    The common parameters are 500 for timeout and 0 for mode.
    
    This function is safe to call from any thread, and as many times as you wish.
    It internally guards from any reentrancy.
    
    The applicable modes are:
    0: Try to kill an existing HAL from another program, if not successful,
    error.
    1: Force kill a HAL from another program.
    2: Just warn if another hal exists and cannot be killed. Will likely result
    in undefined behavior.
    
    :param timeout: the initialization timeout (ms)
    :param mode:    the initialization mode (see remarks)
    
    :returns: true if initialization was successful, otherwise false.
    """
def initializeAddressableLED(outputPort: typing.SupportsInt) -> tuple[int, int]:
    """
    Initialize Addressable LED using a PWM Digital handle.
    
    :param in:  outputPort handle of the digital port for PWM
    :param out: status the error code, or 0 for success
    
    :returns: Addressable LED handle
    """
def initializeAnalogGyro(handle: typing.SupportsInt, allocationLocation: str) -> tuple[int, int]:
    """
    Initializes an analog gyro.
    
    :param in:  handle handle to the analog input port
    :param in:  allocationLocation the location where the allocation is occurring
                (can be null)
    :param out: status the error code, or 0 for success
    
    :returns: the initialized gyro handle
    """
def initializeAnalogInputPort(portHandle: typing.SupportsInt, allocationLocation: str) -> tuple[int, int]:
    """
    Initializes the analog input port using the given port object.
    
    :param in:  portHandle Handle to the port to initialize.
    :param in:  allocationLocation the location where the allocation is occurring
                (can be null)
    :param out: status the error code, or 0 for success
    
    :returns: the created analog input handle
    """
def initializeAnalogOutputPort(portHandle: typing.SupportsInt, allocationLocation: str) -> tuple[int, int]:
    """
    Initializes the analog output port using the given port object.
    
    :param in:  portHandle handle to the port
    :param in:  allocationLocation the location where the allocation is occurring
                (can be null)
    :param out: status Error status variable. 0 on success.
    
    :returns: the created analog output handle
    """
def initializeAnalogTrigger(portHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Initializes an analog trigger.
    
    :param in:  portHandle the analog input to use for triggering
    :param out: status     Error status variable. 0 on success.
    
    :returns: the created analog trigger handle
    """
def initializeAnalogTriggerDutyCycle(dutyCycleHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Initializes an analog trigger with a Duty Cycle input
    
    :param in:  dutyCycleHandle the analog input to use for duty cycle
    :param out: status          Error status variable. 0 on success.
    
    :returns: tbe created analog trigger handle
    """
def initializeCAN(manufacturer: CANManufacturer, deviceId: typing.SupportsInt, deviceType: CANDeviceType) -> tuple[int, int]:
    """
    Initializes a CAN device.
    
    These follow the FIRST standard CAN layout.
    https://docs.wpilib.org/en/stable/docs/software/can-devices/can-addressing.html
    
    :param in:  manufacturer the can manufacturer
    :param in:  deviceId     the device ID (0-63)
    :param in:  deviceType   the device type
    :param out: status      Error status variable. 0 on success.
    
    :returns: the created CAN handle
    """
def initializeCTREPCM(module: typing.SupportsInt, allocationLocation: str) -> tuple[int, int]:
    """
    Initializes a PCM.
    
    :param in:  module             the CAN ID to initialize
    :param in:  allocationLocation the location where the allocation is occurring
                (can be null)
    :param out: status            Error status variable. 0 on success.
    
    :returns: the created PH handle
    """
def initializeCounter(mode: CounterMode) -> tuple[int, int, int]:
    """
    Initializes a counter.
    
    :param in:  mode    the counter mode
    :param in:  index   the compressor index (output)
    :param out: status Error status variable. 0 on success.
    
    :returns: the created handle
    """
def initializeDIOPort(portHandle: typing.SupportsInt, input: typing.SupportsInt, allocationLocation: str) -> tuple[int, int]:
    """
    Creates a new instance of a digital port.
    
    :param in:  portHandle         the port handle to create from
    :param in:  input              true for input, false for output
    :param in:  allocationLocation the location where the allocation is occurring
                (can be null)
    :param out: status            Error status variable. 0 on success.
    
    :returns: the created digital handle
    """
def initializeDutyCycle(digitalSourceHandle: typing.SupportsInt, triggerType: AnalogTriggerType) -> tuple[int, int]:
    """
    Initialize a DutyCycle input.
    
    :param in:  digitalSourceHandle the digital source to use (either a
                HAL_DigitalHandle or a
                HAL_AnalogTriggerHandle)
    :param in:  triggerType the analog trigger type of the source if it is
                an analog trigger
    :param out: status Error status variable. 0 on success.
    
    :returns: the created duty cycle handle
    """
def initializeEncoder(digitalSourceHandleA: typing.SupportsInt, analogTriggerTypeA: AnalogTriggerType, digitalSourceHandleB: typing.SupportsInt, analogTriggerTypeB: AnalogTriggerType, reverseDirection: typing.SupportsInt, encodingType: EncoderEncodingType) -> tuple[int, int]:
    """
    Initializes an encoder.
    
    :param in:  digitalSourceHandleA the A source (either a HAL_DigitalHandle or a
                HAL_AnalogTriggerHandle)
    :param in:  analogTriggerTypeA   the analog trigger type of the A source if it
                is an analog trigger
    :param in:  digitalSourceHandleB the B source (either a HAL_DigitalHandle or a
                HAL_AnalogTriggerHandle)
    :param in:  analogTriggerTypeB   the analog trigger type of the B source if it
                is an analog trigger
    :param in:  reverseDirection     true to reverse the counting direction from
                standard, otherwise false
    :param in:  encodingType         the encoding type
    :param out: status              Error status variable. 0 on success.
    
    :returns: the created encoder handle
    """
def initializeI2C(port: I2CPort) -> int:
    """
    Initializes the I2C port.
    
    Opens the port if necessary and saves the handle.
    If opening the MXP port, also sets up the channel functions appropriately.
    
    :param in:  port    The port to open, 0 for the on-board, 1 for the MXP.
    :param out: status Error status variable. 0 on success.
    """
def initializeInterrupts() -> tuple[int, int]:
    """
    Initializes an interrupt.
    
    :param out: status Error status variable. 0 on success.
    
    :returns: the created interrupt handle
    """
def initializeNotifier() -> tuple[int, int]:
    """
    Initializes a notifier.
    
    A notifier is an FPGA controller timer that triggers at requested intervals
    based on the FPGA time. This can be used to make precise control loops.
    
    :param out: status Error status variable. 0 on success.
    
    :returns: the created notifier
    """
def initializePWMPort(portHandle: typing.SupportsInt, allocationLocation: str) -> tuple[int, int]:
    """
    Initializes a PWM port.
    
    :param in:  portHandle the port to initialize
    :param in:  allocationLocation  the location where the allocation is occurring
                (can be null)
    :param out: status             Error status variable. 0 on success.
    
    :returns: the created pwm handle
    """
def initializePowerDistribution(moduleNumber: typing.SupportsInt, type: PowerDistributionType, allocationLocation: str) -> tuple[int, int]:
    """
    Initializes a Power Distribution Panel.
    
    :param in:  moduleNumber       the module number to initialize
    :param in:  type               the type of module to initialize
    :param in:  allocationLocation the location where the allocation is occurring
    :param out: status            Error status variable. 0 on success.
    
    :returns: the created PowerDistribution handle
    """
def initializeREVPH(module: typing.SupportsInt, allocationLocation: str) -> tuple[int, int]:
    """
    Initializes a PH.
    
    :param in:  module             the CAN ID to initialize
    :param in:  allocationLocation the location where the allocation is occurring
                (can be null)
    :param out: status            Error status variable. 0 on success.
    
    :returns: the created PH handle
    """
def initializeRelayPort(portHandle: typing.SupportsInt, fwd: typing.SupportsInt, allocationLocation: str) -> tuple[int, int]:
    """
    Initializes a relay.
    
    Note this call will only initialize either the forward or reverse port of the
    relay. If you need both, you will need to initialize 2 relays.
    
    :param in:  portHandle         the port handle to initialize
    :param in:  fwd                true for the forward port, false for the
                reverse port
    :param in:  allocationLocation the location where the allocation is occurring
                (can be null)
    :param out: status            Error status variable. 0 on success.
    
    :returns: the created relay handle
    """
def initializeSPI(port: SPIPort) -> int:
    """
    Initializes the SPI port. Opens the port if necessary and saves the handle.
    
    If opening the MXP port, also sets up the channel functions appropriately.
    
    :param in:  port    The number of the port to use. 0-3 for Onboard CS0-CS3, 4
                for MXP
    :param out: status the error code, or 0 for success
    """
def initializeSerialPort(port: SerialPort) -> tuple[int, int]:
    """
    Initializes a serial port.
    
    The channels are either the onboard RS232, the MXP UART, or 2 USB ports. The
    top port is USB1, the bottom port is USB2.
    
    :param in:  port the serial port to initialize
    :param out: status the error code, or 0 for success
    
    :returns: Serial Port Handle
    """
def initializeSerialPortDirect(port: SerialPort, portName: str) -> tuple[int, int]:
    """
    Initializes a serial port with a direct name.
    
    This name is the /dev name for a specific port.
    Note these are not always consistent between roboRIO reboots.
    
    :param in:  port     the serial port to initialize
    :param in:  portName the dev port name
    :param out: status  the error code, or 0 for success
    
    :returns: Serial Port Handle
    """
def isAccumulatorChannel(analogPortHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Is the channel attached to an accumulator.
    
    :param in:  analogPortHandle Handle to the analog port.
    :param out: status Error status variable. 0 on success.
    
    :returns: The analog channel is attached to an accumulator.
    """
def isAnyPulsing() -> tuple[int, int]:
    """
    Checks if any DIO line is currently generating a pulse.
    
    :param out: status Error status variable. 0 on success.
    
    :returns: true if a pulse on some line is in progress
    """
def isHandleCorrectVersion(handle: typing.SupportsInt, version: typing.SupportsInt) -> bool:
    """
    Get if the version of the handle is correct.
    
    Do not use on the roboRIO, used specifically for the sim to handle resets.
    
    :param handle:  the handle
    :param version: the handle version to check
    
    :returns: true if the handle is the right version, otherwise false
    """
def isHandleType(handle: typing.SupportsInt, handleType: HandleEnum) -> bool:
    """
    Get if the handle is a specific type.
    
    :param handle:     the handle
    :param handleType: the type to check
    
    :returns: true if the type is correct, otherwise false
    """
def isPulsing(dioPortHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Checks a DIO line to see if it is currently generating a pulse.
    
    :param in:  dioPortHandle the digital port handle
    :param out: status Error status variable. 0 on success.
    
    :returns: true if a pulse is in progress, otherwise false
    """
def latchPWMZero(pwmPortHandle: typing.SupportsInt) -> int:
    """
    Forces a PWM signal to go to 0 temporarily.
    
    :param in:  pwmPortHandle the PWM handle.
    :param out: status       Error status variable. 0 on success.
    """
def loadExtensions() -> int:
    """
    Loads any extra halsim libraries provided in the HALSIM_EXTENSIONS
    environment variable.
    
    :returns: the success state of the initialization
    """
def loadOneExtension(library: str) -> int:
    """
    Loads a single extension from a direct path.
    
    Expected to be called internally, not by users.
    
    :param library: the library path
    
    :returns: the success state of the initialization
    """
def observeUserProgramAutonomous() -> None:
    """
    Sets the autonomous enabled flag in the DS.
    
    This is used for the DS to ensure the robot is properly responding to its
    state request. Ensure this gets called about every 50ms, or the robot will be
    disabled by the DS.
    """
def observeUserProgramDisabled() -> None:
    """
    Sets the disabled flag in the DS.
    
    This is used for the DS to ensure the robot is properly responding to its
    state request. Ensure this gets called about every 50ms, or the robot will be
    disabled by the DS.
    """
def observeUserProgramStarting() -> None:
    """
    Sets the program starting flag in the DS.
    
    This is what changes the DS to showing robot code ready.
    """
def observeUserProgramTeleop() -> None:
    """
    Sets the teleoperated enabled flag in the DS.
    
    This is used for the DS to ensure the robot is properly responding to its
    state request. Ensure this gets called about every 50ms, or the robot will be
    disabled by the DS.
    """
def observeUserProgramTest() -> None:
    """
    Sets the test mode flag in the DS.
    
    This is used for the DS to ensure the robot is properly responding to its
    state request. Ensure this gets called about every 50ms, or the robot will be
    disabled by the DS.
    """
def provideNewDataEventHandle(handle: typing.SupportsInt) -> None:
    """
    Adds an event handle to be signalled when new data arrives.
    
    :param handle: the event handle to be signalled
    """
def pulse(dioPortHandle: typing.SupportsInt, pulseLengthSeconds: typing.SupportsFloat) -> int:
    """
    Generates a single digital pulse.
    
    Write a pulse to the specified digital output channel. There can only be a
    single pulse going at any time.
    
    :param in:  dioPortHandle the digital port handle
    :param in:  pulseLengthSeconds   the active length of the pulse (in seconds)
    :param out: status       Error status variable. 0 on success.
    """
def pulseMultiple(channelMask: typing.SupportsInt, pulseLengthSeconds: typing.SupportsFloat) -> int:
    """
    Generates a single digital pulse on multiple channels.
    
    Write a pulse to the channels enabled by the mask. There can only be a
    single pulse going at any time.
    
    :param in:  channelMask the channel mask
    :param in:  pulseLengthSeconds   the active length of the pulse (in seconds)
    :param out: status       Error status variable. 0 on success.
    """
def readCANPacketLatest(handle: typing.SupportsInt, apiId: typing.SupportsInt, data: typing_extensions.Buffer) -> tuple[int, int, int]:
    """
    Reads a CAN packet. The will continuously return the last packet received,
    without accounting for packet age.
    
    :param in:  handle             the CAN handle
    :param in:  apiId              the ID to read (0-1023)
    :param out: data              the packet data (8 bytes)
    :param out: length            the received length (0-8 bytes)
    :param out: receivedTimestamp the packet received timestamp in ms (based off
                of CLOCK_MONOTONIC)
    :param out: status            Error status variable. 0 on success.
    """
def readCANPacketNew(handle: typing.SupportsInt, apiId: typing.SupportsInt, data: typing_extensions.Buffer) -> tuple[int, int, int]:
    """
    Reads a new CAN packet.
    
    This will only return properly once per packet received. Multiple calls
    without receiving another packet will return an error code.
    
    :param in:  handle             the CAN handle
    :param in:  apiId              the ID to read (0-1023)
    :param out: data              the packet data (8 bytes)
    :param out: length            the received length (0-8 bytes)
    :param out: receivedTimestamp the packet received timestamp in ms (based off
                of CLOCK_MONOTONIC)
    :param out: status            Error status variable. 0 on success.
    """
def readCANPacketTimeout(handle: typing.SupportsInt, apiId: typing.SupportsInt, data: typing_extensions.Buffer, timeoutMs: typing.SupportsInt) -> tuple[int, int, int]:
    """
    Reads a CAN packet. The will return the last packet received until the
    packet is older then the requested timeout. Then it will return an error
    code.
    
    :param in:  handle             the CAN handle
    :param in:  apiId              the ID to read (0-1023)
    :param out: data              the packet data (8 bytes)
    :param out: length            the received length (0-8 bytes)
    :param out: receivedTimestamp the packet received timestamp in ms (based off
                of CLOCK_MONOTONIC)
    :param out: timeoutMs         the timeout time for the packet
    :param out: status            Error status variable. 0 on success.
    """
def readI2C(port: I2CPort, deviceAddress: typing.SupportsInt, buffer: typing_extensions.Buffer) -> int:
    """
    Executes a read transaction with the device.
    
    Reads bytes from a device.
    Most I2C devices will auto-increment the register pointer internally allowing
    you to read consecutive registers on a device in a single transaction.
    
    :param port:          The I2C port, 0 for the on-board, 1 for the MXP.
    :param deviceAddress: The register to read first in the transaction.
    :param count:         The number of bytes to read in the transaction.
    :param buffer:        A pointer to the array of bytes to store the data read from the
                          device.
    
    :returns: 0 on success or -1 on transfer abort.
    """
def readInterruptFallingTimestamp(interruptHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Returns the timestamp for the falling interrupt that occurred most recently.
    
    This is in the same time domain as HAL_GetFPGATime().  It only contains the
    bottom 32 bits of the timestamp.  If your robot has been running for over 1
    hour, you will need to fill in the upper 32 bits yourself.
    
    :param in:  interruptHandle the interrupt handle
    :param out: status         Error status variable. 0 on success.
    
    :returns: timestamp in microseconds since FPGA Initialization
    """
def readInterruptRisingTimestamp(interruptHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Returns the timestamp for the rising interrupt that occurred most recently.
    
    This is in the same time domain as HAL_GetFPGATime().  It only contains the
    bottom 32 bits of the timestamp.  If your robot has been running for over 1
    hour, you will need to fill in the upper 32 bits yourself.
    
    :param in:  interruptHandle the interrupt handle
    :param out: status         Error status variable. 0 on success.
    
    :returns: timestamp in microseconds since FPGA Initialization
    """
def readSPI(port: SPIPort, buffer: typing_extensions.Buffer) -> int:
    """
    Executes a read from the device.
    
    This method does not write any data out to the device.
    
    Most spi devices will require a register address to be written before they
    begin returning data.
    
    :param port:   The number of the port to use. 0-3 for Onboard CS0-CS2, 4 for
                   MXP
    :param buffer: A pointer to the array of bytes to store the data read from the
                   device.
    :param count:  The number of bytes to read in the transaction. [1..7]
    
    :returns: Number of bytes read. -1 for error.
    """
def readSPIAutoReceivedData(port: SPIPort, buffer: typing_extensions.Buffer, timeout: typing.SupportsFloat) -> tuple[int, int]:
    """
    Reads data received by the SPI accumulator.  Each received data sequence
    consists of a timestamp followed by the received data bytes, one byte per
    word (in the least significant byte).  The length of each received data
    sequence is the same as the combined dataSize + zeroSize set in
    HAL_SetSPIAutoTransmitData.
    
    :param in:  port      The number of the port to use. 0-3 for Onboard CS0-CS2,
                4 for MXP.
    :param out: buffer   The buffer to store the data into.
    :param in:  numToRead The number of words to read.
    :param in:  timeout   The read timeout (in seconds).
    :param out: status   the error code, or 0 for success
    
    :returns: The number of words actually read.
    """
def readSerial(handle: typing.SupportsInt, buffer: typing_extensions.Buffer) -> tuple[int, int]:
    """
    Reads data from the serial port.
    
    Will wait for either timeout (if set), the termination char (if set), or the
    count to be full. Whichever one comes first.
    
    :param in:  handle  the serial port handle
    :param out: buffer the buffer in which to store bytes read
    :param in:  count   the number of bytes maximum to read
    :param out: status the error code, or 0 for success
    
    :returns: the number of bytes actually read
    """
def refreshDSData() -> int:
    """
    Refresh the DS control word.
    
    :returns: true if updated
    """
def releaseWaitingInterrupt(interruptHandle: typing.SupportsInt) -> int:
    """
    Releases a waiting interrupt.
    
    This will release both rising and falling waiters.
    
    :param in:  interruptHandle the interrupt handle to release
    :param out: status         Error status variable. 0 on success.
    """
def removeNewDataEventHandle(handle: typing.SupportsInt) -> None:
    """
    Removes the event handle from being signalled when new data arrives.
    
    :param handle: the event handle to remove
    """
def report(resource: typing.SupportsInt, instanceNumber: typing.SupportsInt, context: typing.SupportsInt = 0, feature: str = None) -> int:
    """
    Reports a hardware usage to the HAL.
    
    :param resource:       the used resource
    :param instanceNumber: the instance of the resource
    :param context:        a user specified context index
    :param feature:        a user specified feature string
    
    :returns: the index of the added value in NetComm
    """
def requestInterrupts(interruptHandle: typing.SupportsInt, digitalSourceHandle: typing.SupportsInt, analogTriggerType: AnalogTriggerType) -> int:
    """
    Requests interrupts on a specific digital source.
    
    :param in:  interruptHandle     the interrupt handle
    :param in:  digitalSourceHandle the digital source handle (either a
                HAL_AnalogTriggerHandle or a
                HAL_DigitalHandle)
    :param in:  analogTriggerType   the trigger type if the source is an
                AnalogTrigger
    :param out: status             Error status variable. 0 on success.
    """
def resetAccumulator(analogPortHandle: typing.SupportsInt) -> int:
    """
    Resets the accumulator to the initial value.
    
    :param in:  analogPortHandle Handle to the analog port.
    :param out: status Error status variable. 0 on success.
    """
def resetAnalogGyro(handle: typing.SupportsInt) -> int:
    """
    Resets the analog gyro value to 0.
    
    :param in:  handle the gyro handle
    :param out: status the error code, or 0 for success
    """
def resetCounter(counterHandle: typing.SupportsInt) -> int:
    """
    Resets the Counter to zero.
    
    Sets the counter value to zero. This does not effect the running state of the
    counter, just sets the current value to zero.
    
    :param in:  counterHandle the counter handle
    :param out: status       Error status variable. 0 on success.
    """
def resetEncoder(encoderHandle: typing.SupportsInt) -> int:
    """
    Reads the current encoder value.
    
    Read the value at this instant. It may still be running, so it reflects the
    current value. Next time it is read, it might have a different value.
    
    :param in:  encoderHandle the encoder handle
    :param out: status       Error status variable. 0 on success.
    """
def resetPowerDistributionTotalEnergy(handle: typing.SupportsInt) -> int:
    """
    Resets the PowerDistribution accumulated energy.
    
    Not supported on the Rev PDH and does nothing.
    
    :param in:  handle the module handle
    :param out: status Error status variable. 0 on success.
    """
def resetUserCurrentFaults() -> int:
    """
    Resets the overcurrent fault counters for all user rails to 0.
    
    :param out: status the error code, or 0 for success
    """
def runMain() -> None:
    """
    Runs the main function provided to HAL_SetMain().
    
    If HAL_SetMain() has not been called, simply sleeps until HAL_ExitMain()
    is called.
    """
def sendConsoleLine(line: str) -> int:
    """
    Sends a line to the driver station console.
    
    :param line: the line to send (null terminated)
    
    :returns: the error code, or 0 for success
    """
def sendError(isError: typing.SupportsInt, errorCode: typing.SupportsInt, isLVCode: typing.SupportsInt, details: str, location: str, callStack: str, printMsg: typing.SupportsInt) -> int:
    """
    Sends an error to the driver station.
    
    :param isError:   true for error, false for warning
    :param errorCode: the error code
    :param isLVCode:  true for a LV error code, false for a standard error code
    :param details:   the details of the error
    :param location:  the file location of the error
    :param callStack: the callstack of the error
    :param printMsg:  true to print the error message to stdout as well as to the
                      DS
    
    :returns: the error code, or 0 for success
    """
def setAccelerometerActive(active: typing.SupportsInt) -> None:
    """
    Sets the accelerometer to active or standby mode.
    
    It must be in standby mode to change any configuration.
    
    :param active: true to set to active, false for standby
    """
def setAccelerometerRange(range: AccelerometerRange) -> None:
    """
    Sets the range of values that can be measured (either 2, 4, or 8 g-forces).
    
    The accelerometer should be in standby mode when this is called.
    
    :param range: the accelerometer range
    """
def setAccumulatorCenter(analogPortHandle: typing.SupportsInt, center: typing.SupportsInt) -> int:
    """
    Set the center value of the accumulator.
    
    The center value is subtracted from each A/D value before it is added to the
    accumulator. This is used for the center value of devices like gyros and
    accelerometers to make integration work and to take the device offset into
    account when integrating.
    
    This center value is based on the output of the oversampled and averaged
    source from channel 1. Because of this, any non-zero oversample bits will
    affect the size of the value for this field.
    
    :param in:  analogPortHandle Handle to the analog port.
    :param in:  center The center value of the accumulator.
    :param out: status Error status variable. 0 on success.
    """
def setAccumulatorDeadband(analogPortHandle: typing.SupportsInt, deadband: typing.SupportsInt) -> int:
    """
    Set the accumulator's deadband.
    
    :param in:  analogPortHandle Handle to the analog port.
    :param in:  deadband The deadband of the accumulator.
    :param out: status Error status variable. 0 on success.
    """
def setAddressableLEDBitTiming(handle: typing.SupportsInt, highTime0NanoSeconds: typing.SupportsInt, lowTime0NanoSeconds: typing.SupportsInt, highTime1NanoSeconds: typing.SupportsInt, lowTime1NanoSeconds: typing.SupportsInt) -> int:
    """
    Sets the bit timing.
    
    By default, the driver is set up to drive WS2812B and WS2815, so nothing
    needs to be set for those.
    
    :param in:  handle the Addressable LED handle
    :param in:  highTime0NanoSeconds high time for 0 bit (default 400ns)
    :param in:  lowTime0NanoSeconds low time for 0 bit (default 900ns)
    :param in:  highTime1NanoSeconds high time for 1 bit (default 900ns)
    :param in:  lowTime1NanoSeconds low time for 1 bit (default 600ns)
    :param out: status the error code, or 0 for success
    """
def setAddressableLEDColorOrder(handle: typing.SupportsInt, colorOrder: AddressableLEDColorOrder) -> int:
    """
    Sets the color order for the addressable LED output. The default order is
    GRB. This will take effect on the next call to HAL_WriteAddressableLEDData().
    
    :param in:  handle the Addressable LED handle
    :param in:  colorOrder the color order
    :param out: status the error code, or 0 for success
    """
def setAddressableLEDLength(handle: typing.SupportsInt, length: typing.SupportsInt) -> int:
    """
    Sets the length of the LED strip.
    
    The max length is 5460 LEDs.
    
    :param in:  handle the Addressable LED handle
    :param in:  length the strip length
    :param out: status the error code, or 0 for success
    """
def setAddressableLEDOutputPort(handle: typing.SupportsInt, outputPort: typing.SupportsInt) -> int:
    """
    Set the Addressable LED PWM Digital port.
    
    :param in:  handle the Addressable LED handle
    :param in:  outputPort The digital handle of the PWM port
    :param out: status the error code, or 0 for success
    """
def setAddressableLEDSyncTime(handle: typing.SupportsInt, syncTimeMicroSeconds: typing.SupportsInt) -> int:
    """
    Sets the sync time.
    
    The sync time is the time to hold output so LEDs enable. Default set for
    WS2812B and WS2815.
    
    :param in:  handle the Addressable LED handle
    :param in:  syncTimeMicroSeconds the sync time (default 280us)
    :param out: status the error code, or 0 for success
    """
def setAnalogAverageBits(analogPortHandle: typing.SupportsInt, bits: typing.SupportsInt) -> int:
    """
    Sets the number of averaging bits.
    
    This sets the number of averaging bits. The actual number of averaged samples
    is 2**bits. Use averaging to improve the stability of your measurement at the
    expense of sampling rate. The averaging is done automatically in the FPGA.
    
    :param in:  analogPortHandle Handle to the analog port to configure.
    :param in:  bits Number of bits to average.
    :param out: status the error code, or 0 for success
    """
def setAnalogGyroDeadband(handle: typing.SupportsInt, volts: typing.SupportsFloat) -> int:
    """
    Sets the deadband of the analog gyro.
    
    :param in:  handle the gyro handle
    :param in:  volts  the voltage deadband
    :param out: status Error status variable. 0 on success.
    """
def setAnalogGyroParameters(handle: typing.SupportsInt, voltsPerDegreePerSecond: typing.SupportsFloat, offset: typing.SupportsFloat, center: typing.SupportsInt) -> int:
    """
    Sets the analog gyro parameters to the specified values.
    
    This is meant to be used if you want to reuse the values from a previous
    calibration.
    
    :param in:  handle                  the gyro handle
    :param in:  voltsPerDegreePerSecond the gyro volts scaling
    :param in:  offset                  the gyro offset
    :param in:  center                  the gyro center
    :param out: status                  the error code, or 0 for success
    """
def setAnalogGyroVoltsPerDegreePerSecond(handle: typing.SupportsInt, voltsPerDegreePerSecond: typing.SupportsFloat) -> int:
    """
    Sets the analog gyro volts per degrees per second scaling.
    
    :param in:  handle                  the gyro handle
    :param in:  voltsPerDegreePerSecond the gyro volts scaling
    :param out: status                  the error code, or 0 for success
    """
def setAnalogInputSimDevice(handle: typing.SupportsInt, device: typing.SupportsInt) -> None:
    """
    Indicates the analog input is used by a simulated device.
    
    :param handle: the analog input handle
    :param device: simulated device handle
    """
def setAnalogOutput(analogOutputHandle: typing.SupportsInt, voltage: typing.SupportsFloat) -> int:
    """
    Sets an analog output value.
    
    :param in:  analogOutputHandle the analog output handle
    :param in:  voltage            the voltage (0-5v) to output
    :param out: status            Error status variable. 0 on success.
    """
def setAnalogOversampleBits(analogPortHandle: typing.SupportsInt, bits: typing.SupportsInt) -> int:
    """
    Sets the number of oversample bits.
    
    This sets the number of oversample bits. The actual number of oversampled
    values is 2**bits. Use oversampling to improve the resolution of your
    measurements at the expense of sampling rate. The oversampling is done
    automatically in the FPGA.
    
    :param in:  analogPortHandle Handle to the analog port to use.
    :param in:  bits Number of bits to oversample.
    :param out: status the error code, or 0 for success
    """
def setAnalogSampleRate(samplesPerSecond: typing.SupportsFloat) -> int:
    """
    Sets the sample rate.
    
    This is a global setting for the Athena and effects all channels.
    
    :param in:  samplesPerSecond The number of samples per channel per second.
    :param out: status          the error code, or 0 for success
    """
def setAnalogTriggerAveraged(analogTriggerHandle: typing.SupportsInt, useAveragedValue: typing.SupportsInt) -> int:
    """
    Configures the analog trigger to use the averaged vs. raw values.
    
    If the value is true, then the averaged value is selected for the analog
    trigger, otherwise the immediate value is used.
    
    This is not allowed to be used if filtered mode is set.
    This is not allowed to be used with Duty Cycle based inputs.
    
    :param in:  analogTriggerHandle the trigger handle
    :param in:  useAveragedValue    true to use averaged values, false for raw
    :param out: status              Error status variable. 0 on success.
    """
def setAnalogTriggerFiltered(analogTriggerHandle: typing.SupportsInt, useFilteredValue: typing.SupportsInt) -> int:
    """
    Configures the analog trigger to use a filtered value.
    
    The analog trigger will operate with a 3 point average rejection filter. This
    is designed to help with 360 degree pot applications for the period where the
    pot crosses through zero.
    
    This is not allowed to be used if averaged mode is set.
    
    :param in:  analogTriggerHandle the trigger handle
    :param in:  useFilteredValue    true to use filtered values, false for average
                or raw
    :param out: status             Error status variable. 0 on success.
    """
def setAnalogTriggerLimitsDutyCycle(analogTriggerHandle: typing.SupportsInt, lower: typing.SupportsFloat, upper: typing.SupportsFloat) -> int:
    """
    Sets the upper and lower limits of the analog trigger.
    
    The limits are given as floating point duty cycle values.
    
    :param in:  analogTriggerHandle the trigger handle
    :param in:  lower               the lower duty cycle value
    :param in:  upper               the upper duty cycle value
    :param out: status              Error status variable. 0 on success.
    """
def setAnalogTriggerLimitsRaw(analogTriggerHandle: typing.SupportsInt, lower: typing.SupportsInt, upper: typing.SupportsInt) -> int:
    """
    Sets the raw ADC upper and lower limits of the analog trigger.
    
    HAL_SetAnalogTriggerLimitsVoltage or HAL_SetAnalogTriggerLimitsDutyCycle
    is likely better in most cases.
    
    :param in:  analogTriggerHandle the trigger handle
    :param in:  lower               the lower ADC value
    :param in:  upper               the upper ADC value
    :param out: status              Error status variable. 0 on success.
    """
def setAnalogTriggerLimitsVoltage(analogTriggerHandle: typing.SupportsInt, lower: typing.SupportsFloat, upper: typing.SupportsFloat) -> int:
    """
    Sets the upper and lower limits of the analog trigger.
    
    The limits are given as floating point voltage values.
    
    :param in:  analogTriggerHandle the trigger handle
    :param in:  lower               the lower voltage value
    :param in:  upper               the upper voltage value
    :param out: status              Error status variable. 0 on success.
    """
def setBrownoutVoltage(voltage: typing.SupportsFloat) -> int:
    """
    Set the voltage the roboRIO will brownout and disable all outputs.
    
    Note that this only does anything on the roboRIO 2.
    On the roboRIO it is a no-op.
    
    :param in:  voltage The brownout voltage
    :param out: status the error code, or 0 for success
    """
def setCTREPCMClosedLoopControl(handle: typing.SupportsInt, enabled: typing.SupportsInt) -> int:
    """
    Enables the compressor closed loop control using the digital pressure switch.
    The compressor will turn on when the pressure switch indicates that the
    system is not full, and will turn off when the pressure switch indicates that
    the system is full.
    
    :param in:  handle  the PCM handle
    :param in:  enabled true to enable closed loop control
    :param out: status Error status variable. 0 on success.
    """
def setCTREPCMOneShotDuration(handle: typing.SupportsInt, index: typing.SupportsInt, durMs: typing.SupportsInt) -> int:
    """
    Set the duration for a single solenoid shot.
    
    :param in:  handle  the PCM handle
    :param in:  index solenoid index
    :param in:  durMs shot duration in ms
    :param out: status Error status variable. 0 on success.
    """
def setCTREPCMSolenoids(handle: typing.SupportsInt, mask: typing.SupportsInt, values: typing.SupportsInt) -> int:
    """
    Sets solenoids on a pneumatics module.
    
    :param in:  handle  the PCM handle
    :param in:  mask Bitmask indicating which solenoids to set. The LSB represents
                solenoid 0.
    :param in:  values Bitmask indicating the desired states of the solenoids. The
                LSB represents solenoid 0.
    :param out: status Error status variable. 0 on success.
    """
def setCounterAverageSize(counterHandle: typing.SupportsInt, size: typing.SupportsInt) -> int:
    """
    Sets the average sample size of a counter.
    
    :param in:  counterHandle  the counter handle
    :param in:  size           the size of samples to average
    :param out: status        Error status variable. 0 on success.
    """
def setCounterDownSource(counterHandle: typing.SupportsInt, digitalSourceHandle: typing.SupportsInt, analogTriggerType: AnalogTriggerType) -> int:
    """
    Sets the source object that causes the counter to count down.
    
    :param in:  counterHandle       the counter handle
    :param in:  digitalSourceHandle the digital source handle (either a
                HAL_AnalogTriggerHandle or a
                HAL_DigitalHandle)
    :param in:  analogTriggerType   the analog trigger type if the source is an
                analog trigger
    :param out: status             Error status variable. 0 on success.
    """
def setCounterDownSourceEdge(counterHandle: typing.SupportsInt, risingEdge: typing.SupportsInt, fallingEdge: typing.SupportsInt) -> int:
    """
    Sets the down source to either detect rising edges or falling edges.
    Note that both are allowed to be set true at the same time without issues.
    
    :param in:  counterHandle  the counter handle
    :param in:  risingEdge     true to trigger on rising
    :param in:  fallingEdge    true to trigger on falling
    :param out: status        Error status variable. 0 on success.
    """
def setCounterExternalDirectionMode(counterHandle: typing.SupportsInt) -> int:
    """
    Sets directional counting mode on this counter.
    
    The direction is determined by the B input, with counting happening with the
    A input.
    
    :param in:  counterHandle the counter handle
    :param out: status       Error status variable. 0 on success.
    """
def setCounterMaxPeriod(counterHandle: typing.SupportsInt, maxPeriod: typing.SupportsFloat) -> int:
    """
    Sets the maximum period where the device is still considered "moving".
    
    Sets the maximum period where the device is considered moving. This value is
    used to determine the "stopped" state of the counter using the
    HAL_GetCounterStopped method.
    
    :param in:  counterHandle the counter handle
    :param in:  maxPeriod     the maximum period where the counted device is
                considered moving in seconds
    :param out: status       Error status variable. 0 on success.
    """
def setCounterPulseLengthMode(counterHandle: typing.SupportsInt, threshold: typing.SupportsFloat) -> int:
    """
    Configures the counter to count in up or down based on the length of the
    input pulse.
    
    This mode is most useful for direction sensitive gear tooth sensors.
    
    :param in:  counterHandle the counter handle
    :param in:  threshold     The pulse length beyond which the counter counts the
                opposite direction (seconds)
    :param out: status       Error status variable. 0 on success.
    """
def setCounterReverseDirection(counterHandle: typing.SupportsInt, reverseDirection: typing.SupportsInt) -> int:
    """
    Sets the Counter to return reversed sensing on the direction.
    
    This allows counters to change the direction they are counting in the case of
    1X and 2X quadrature encoding only. Any other counter mode isn't supported.
    
    :param in:  counterHandle    the counter handle
    :param in:  reverseDirection true if the value counted should be negated.
    :param out: status          Error status variable. 0 on success.
    """
def setCounterSamplesToAverage(counterHandle: typing.SupportsInt, samplesToAverage: typing.SupportsInt) -> int:
    """
    Sets the Samples to Average which specifies the number of samples of the
    timer to average when calculating the period. Perform averaging to account
    for mechanical imperfections or as oversampling to increase resolution.
    
    :param in:  counterHandle    the counter handle
    :param in:  samplesToAverage The number of samples to average from 1 to 127
    :param out: status          Error status variable. 0 on success.
    """
def setCounterSemiPeriodMode(counterHandle: typing.SupportsInt, highSemiPeriod: typing.SupportsInt) -> int:
    """
    Sets Semi-period mode on this counter.
    
    The counter counts up based on the time the input is triggered. High or Low
    depends on the highSemiPeriod parameter.
    
    :param in:  counterHandle  the counter handle
    :param in:  highSemiPeriod true for counting when the input is high, false for
                low
    :param out: status        Error status variable. 0 on success.
    """
def setCounterUpDownMode(counterHandle: typing.SupportsInt) -> int:
    """
    Sets standard up / down counting mode on this counter.
    
    Up and down counts are sourced independently from two inputs.
    
    :param in:  counterHandle the counter handle
    :param out: status       Error status variable. 0 on success.
    """
def setCounterUpSource(counterHandle: typing.SupportsInt, digitalSourceHandle: typing.SupportsInt, analogTriggerType: AnalogTriggerType) -> int:
    """
    Sets the source object that causes the counter to count up.
    
    :param in:  counterHandle       the counter handle
    :param in:  digitalSourceHandle the digital source handle (either a
                HAL_AnalogTriggerHandle or a
                HAL_DigitalHandle)
    :param in:  analogTriggerType   the analog trigger type if the source is an
                analog trigger
    :param out: status             Error status variable. 0 on success.
    """
def setCounterUpSourceEdge(counterHandle: typing.SupportsInt, risingEdge: typing.SupportsInt, fallingEdge: typing.SupportsInt) -> int:
    """
    Sets the up source to either detect rising edges or falling edges.
    
    Note that both are allowed to be set true at the same time without issues.
    
    :param in:  counterHandle  the counter handle
    :param in:  risingEdge     true to trigger on rising
    :param in:  fallingEdge    true to trigger on falling
    :param out: status        Error status variable. 0 on success.
    """
def setCounterUpdateWhenEmpty(counterHandle: typing.SupportsInt, enabled: typing.SupportsInt) -> int:
    """
    Selects whether you want to continue updating the event timer output when
    there are no samples captured.
    
    The output of the event timer has a buffer of periods that are averaged and
    posted to a register on the FPGA.  When the timer detects that the event
    source has stopped (based on the MaxPeriod) the buffer of samples to be
    averaged is emptied.
    
    If you enable the update when empty, you will be
    notified of the stopped source and the event time will report 0 samples.
    
    If you disable update when empty, the most recent average will remain on the
    output until a new sample is acquired.
    
    You will never see 0 samples output (except when there have been no events
    since an FPGA reset) and you will likely not see the stopped bit become true
    (since it is updated at the end of an average and there are no samples to
    average).
    
    :param in:  counterHandle the counter handle
    :param in:  enabled       true to enable counter updating with no samples
    :param out: status       Error status variable. 0 on success.
    """
def setCurrentThreadPriority(realTime: typing.SupportsInt, priority: typing.SupportsInt) -> tuple[int, int]:
    """
    Sets the thread priority for the current thread.
    
    :param in:  realTime Set to true to set a real-time priority, false for
                standard priority.
    :param in:  priority Priority to set the thread to. For real-time, this is
                1-99 with 99 being highest. For non-real-time, this is
                forced to 0. See "man 7 sched" for more details.
    :param out: status  Error status variable. 0 on success.
    
    :returns: True on success.
    """
def setDIO(dioPortHandle: typing.SupportsInt, value: typing.SupportsInt) -> int:
    """
    Writes a digital value to a DIO channel.
    
    :param in:  dioPortHandle the digital port handle
    :param in:  value         the state to set the digital channel (if it is
                configured as an output)
    :param out: status       Error status variable. 0 on success.
    """
def setDIODirection(dioPortHandle: typing.SupportsInt, input: typing.SupportsInt) -> int:
    """
    Sets the direction of a DIO channel.
    
    :param in:  dioPortHandle the digital port handle
    :param in:  input         true to set input, false for output
    :param out: status       Error status variable. 0 on success.
    """
def setDIOSimDevice(handle: typing.SupportsInt, device: typing.SupportsInt) -> None:
    """
    Indicates the DIO channel is used by a simulated device.
    
    :param handle: the DIO channel handle
    :param device: simulated device handle
    """
def setDigitalPWMDutyCycle(pwmGenerator: typing.SupportsInt, dutyCycle: typing.SupportsFloat) -> int:
    """
    Configures the duty-cycle of the PWM generator.
    
    :param in:  pwmGenerator the digital PWM handle
    :param in:  dutyCycle    the percent duty cycle to output [0..1]
    :param out: status      Error status variable. 0 on success.
    """
def setDigitalPWMOutputChannel(pwmGenerator: typing.SupportsInt, channel: typing.SupportsInt) -> int:
    """
    Configures which DO channel the PWM signal is output on.
    
    :param in:  pwmGenerator the digital PWM handle
    :param in:  channel      the channel to output on
    :param out: status      Error status variable. 0 on success.
    """
def setDigitalPWMPPS(pwmGenerator: typing.SupportsInt, dutyCycle: typing.SupportsFloat) -> int:
    """
    Configures the digital PWM to be a PPS signal with specified duty cycle.
    
    :param in:  pwmGenerator the digital PWM handle
    :param in:  dutyCycle    the percent duty cycle to output [0..1]
    :param out: status      Error status variable. 0 on success.
    """
def setDigitalPWMRate(rate: typing.SupportsFloat) -> int:
    """
    Changes the frequency of the DO PWM generator.
    
    The valid range is from 0.6 Hz to 19 kHz.
    
    The frequency resolution is logarithmic.
    
    :param in:  rate the frequency to output all digital output PWM signals
    :param out: status Error status variable. 0 on success.
    """
def setDutyCycleSimDevice(handle: typing.SupportsInt, device: typing.SupportsInt) -> None:
    """
    Indicates the duty cycle is used by a simulated device.
    
    :param handle: the duty cycle handle
    :param device: simulated device handle
    """
def setEncoderDistancePerPulse(encoderHandle: typing.SupportsInt, distancePerPulse: typing.SupportsFloat) -> int:
    """
    Sets the distance traveled per encoder pulse. This is used as a scaling
    factor for the rate and distance calls.
    
    :param in:  encoderHandle    the encoder handle
    :param in:  distancePerPulse the distance traveled per encoder pulse (units
                user defined)
    :param out: status          Error status variable. 0 on success.
    """
def setEncoderIndexSource(encoderHandle: typing.SupportsInt, digitalSourceHandle: typing.SupportsInt, analogTriggerType: AnalogTriggerType, type: EncoderIndexingType) -> int:
    """
    Sets the source for an index pulse on the encoder.
    
    The index pulse can be used to cause an encoder to reset based on an external
    input.
    
    :param in:  encoderHandle       the encoder handle
    :param in:  digitalSourceHandle the index source handle (either a
                HAL_AnalogTriggerHandle or a
                HAL_DigitalHandle)
    :param in:  analogTriggerType   the analog trigger type if the source is an
                analog trigger
    :param in:  type                the index triggering type
    :param out: status             Error status variable. 0 on success.
    """
def setEncoderMaxPeriod(encoderHandle: typing.SupportsInt, maxPeriod: typing.SupportsFloat) -> int:
    """
    Sets the maximum period where the device is still considered "moving".
    
    Sets the maximum period where the device is considered moving. This value is
    used to determine the "stopped" state of the encoder using the
    HAL_GetEncoderStopped method.
    
    :param in:  encoderHandle the encoder handle
    :param in:  maxPeriod     the maximum period where the counted device is
                considered moving in seconds
    :param out: status       Error status variable. 0 on success.
    """
def setEncoderMinRate(encoderHandle: typing.SupportsInt, minRate: typing.SupportsFloat) -> int:
    """
    Sets the minimum rate to be considered moving by the encoder.
    
    Units need to match what is set by HAL_SetEncoderDistancePerPulse, with time
    as seconds.
    
    :param in:  encoderHandle the encoder handle
    :param in:  minRate       the minimum rate to be considered moving (units are
                determined by the units passed to
                HAL_SetEncoderDistancePerPulse, time value is
                seconds)
    :param out: status       Error status variable. 0 on success.
    """
def setEncoderReverseDirection(encoderHandle: typing.SupportsInt, reverseDirection: typing.SupportsInt) -> int:
    """
    Sets if to reverse the direction of the encoder.
    
    Note that this is not a toggle. It is an absolute set.
    
    :param in:  encoderHandle    the encoder handle
    :param in:  reverseDirection true to reverse the direction, false to not.
    :param out: status          Error status variable. 0 on success.
    """
def setEncoderSamplesToAverage(encoderHandle: typing.SupportsInt, samplesToAverage: typing.SupportsInt) -> int:
    """
    Sets the number of encoder samples to average when calculating encoder rate.
    
    :param in:  encoderHandle    the encoder handle
    :param in:  samplesToAverage the number of samples to average
    :param out: status          Error status variable. 0 on success.
    """
def setEncoderSimDevice(handle: typing.SupportsInt, device: typing.SupportsInt) -> None:
    """
    Indicates the encoder is used by a simulated device.
    
    :param handle: the encoder handle
    :param device: simulated device handle
    """
def setFilterPeriod(filterIndex: typing.SupportsInt, value: typing.SupportsInt) -> int:
    """
    Sets the filter period for the specified filter index.
    
    Sets the filter period in FPGA cycles.  Even though there are 2 different
    filter index domains (MXP vs HDR), ignore that distinction for now since it
    complicates the interface.  That can be changed later.
    
    :param in:  filterIndex the filter index, 0 - 2
    :param in:  value       the number of cycles that the signal must not
                transition to be counted as a transition.
    :param out: status     Error status variable. 0 on success.
    """
def setFilterSelect(dioPortHandle: typing.SupportsInt, filterIndex: typing.SupportsInt) -> int:
    """
    Writes the filter index from the FPGA.
    
    Set the filter index used to filter out short pulses.
    
    :param in:  dioPortHandle the digital port handle
    :param in:  filterIndex   the filter index (Must be in the range 0 - 3, where
                0 means "none" and 1 - 3 means filter # filterIndex
                - 1)
    :param out: status       Error status variable. 0 on success.
    """
def setInterruptUpSourceEdge(interruptHandle: typing.SupportsInt, risingEdge: typing.SupportsInt, fallingEdge: typing.SupportsInt) -> int:
    """
    Sets the edges to trigger the interrupt on.
    
    Note that both edges triggered is a valid configuration.
    
    :param in:  interruptHandle the interrupt handle
    :param in:  risingEdge      true for triggering on rising edge
    :param in:  fallingEdge     true for triggering on falling edge
    :param out: status         Error status variable. 0 on success.
    """
def setJoystickOutputs(joystickNum: typing.SupportsInt, outputs: typing.SupportsInt, leftRumble: typing.SupportsInt, rightRumble: typing.SupportsInt) -> int:
    """
    Set joystick outputs.
    
    :param joystickNum: the joystick number
    :param outputs:     bitmask of outputs, 1 for on 0 for off
    :param leftRumble:  the left rumble value (0-FFFF)
    :param rightRumble: the right rumble value (0-FFFF)
    
    :returns: the error code, or 0 for success
    """
def setNotifierName(notifierHandle: typing.SupportsInt, name: str) -> int:
    """
    Sets the name of a notifier.
    
    :param in:  notifierHandle the notifier handle
    :param in:  name name
    :param out: status Error status variable. 0 on success.
    """
def setNotifierThreadPriority(realTime: typing.SupportsInt, priority: typing.SupportsInt) -> tuple[int, int]:
    """
    Sets the HAL notifier thread priority.
    
    The HAL notifier thread is responsible for managing the FPGA's notifier
    interrupt and waking up user's Notifiers when it's their time to run.
    Giving the HAL notifier thread real-time priority helps ensure the user's
    real-time Notifiers, if any, are notified to run in a timely manner.
    
    :param in:  realTime Set to true to set a real-time priority, false for
                standard priority.
    :param in:  priority Priority to set the thread to. For real-time, this is
                1-99 with 99 being highest. For non-real-time, this is
                forced to 0. See "man 7 sched" for more details.
    :param out: status  Error status variable. 0 on success.
    
    :returns: True on success.
    """
def setPWMAlwaysHighMode(pwmPortHandle: typing.SupportsInt) -> int:
    """
    Sets the PWM output to be a continuous high signal while enabled.
    
    :param in:  pwmPortHandle the PWM handle.
    :param out: status       Error status variable. 0 on success.
    """
def setPWMConfigMicroseconds(pwmPortHandle: typing.SupportsInt, maxPwm: typing.SupportsInt, deadbandMaxPwm: typing.SupportsInt, centerPwm: typing.SupportsInt, deadbandMinPwm: typing.SupportsInt, minPwm: typing.SupportsInt) -> int:
    """
    Sets the configuration settings for the PWM channel.
    
    All values are in microseconds.
    
    :param in:  pwmPortHandle  the PWM handle
    :param in:  maxPwm         the maximum PWM value
    :param in:  deadbandMaxPwm the high range of the center deadband
    :param in:  centerPwm      the center PWM value
    :param in:  deadbandMinPwm the low range of the center deadband
    :param in:  minPwm         the minimum PWM value
    :param out: status        Error status variable. 0 on success.
    """
def setPWMDisabled(pwmPortHandle: typing.SupportsInt) -> int:
    """
    Sets a PWM channel to be disabled.
    
    The channel is disabled until the next time it is set. Note this is different
    from just setting a 0 speed, as this will actively stop all signaling on the
    channel.
    
    :param in:  pwmPortHandle the PWM handle.
    :param out: status       Error status variable. 0 on success.
    """
def setPWMEliminateDeadband(pwmPortHandle: typing.SupportsInt, eliminateDeadband: typing.SupportsInt) -> int:
    """
    Sets if the FPGA should output the center value if the input value is within
    the deadband.
    
    :param in:  pwmPortHandle     the PWM handle
    :param in:  eliminateDeadband true to eliminate deadband, otherwise false
    :param out: status           Error status variable. 0 on success.
    """
def setPWMPeriodScale(pwmPortHandle: typing.SupportsInt, squelchMask: typing.SupportsInt) -> int:
    """
    Sets how how often the PWM signal is squelched, thus scaling the period.
    
    :param in:  pwmPortHandle the PWM handle.
    :param in:  squelchMask   the 2-bit mask of outputs to squelch
    :param out: status       Error status variable. 0 on success.
    """
def setPWMPosition(pwmPortHandle: typing.SupportsInt, position: typing.SupportsFloat) -> int:
    """
    Sets a PWM channel to the desired position value.
    
    The values range from 0 to 1 and the period is controlled by the PWM Period
    and MinHigh registers.
    
    :param in:  pwmPortHandle the PWM handle
    :param in:  position      the positional PWM value to set
    :param out: status       Error status variable. 0 on success.
    """
def setPWMPulseTimeMicroseconds(pwmPortHandle: typing.SupportsInt, microsecondPulseTime: typing.SupportsInt) -> int:
    """
    Sets a PWM channel to the desired pulse width in microseconds.
    
    :param in:  pwmPortHandle the PWM handle
    :param in:  microsecondPulseTime  the PWM value to set
    :param out: status       Error status variable. 0 on success.
    """
def setPWMSpeed(pwmPortHandle: typing.SupportsInt, speed: typing.SupportsFloat) -> int:
    """
    Sets a PWM channel to the desired scaled value.
    
    The values range from -1 to 1 and the period is controlled by the PWM Period
    and MinHigh registers.
    
    :param in:  pwmPortHandle the PWM handle
    :param in:  speed         the scaled PWM value to set
    :param out: status       Error status variable. 0 on success.
    """
def setPowerDistributionSwitchableChannel(handle: typing.SupportsInt, enabled: typing.SupportsInt) -> int:
    """
    Power on/off switchable channel.
    
    This is a REV PDH-specific function. This function will no-op on CTRE PDP.
    
    :param in:  handle the module handle
    :param in:  enabled true to turn on switchable channel
    :param out: status Error status variable. 0 on success.
    """
def setREVPHClosedLoopControlAnalog(handle: typing.SupportsInt, minAnalogVoltage: typing.SupportsFloat, maxAnalogVoltage: typing.SupportsFloat) -> int:
    """
    Enables the compressor in analog mode. This mode uses an analog
    pressure sensor connected to analog channel 0 to cycle the compressor. The
    compressor will turn on when the pressure drops below minAnalogVoltage and
    will turn off when the pressure reaches maxAnalogVoltage. This mode is only
    supported by the REV PH with the REV Analog Pressure Sensor connected to
    analog channel 0.
    
    :param in:  handle  the PH handle
    :param in:  minAnalogVoltage The compressor will turn on when the analog
                pressure sensor voltage drops below this value
    :param in:  maxAnalogVoltage The compressor will turn off when the analog
                pressure sensor reaches this value.
    :param out: status Error status variable. 0 on success.
    """
def setREVPHClosedLoopControlDigital(handle: typing.SupportsInt) -> int:
    """
    Enables the compressor in digital mode using the digital pressure switch. The
    compressor will turn on when the pressure switch indicates that the system is
    not full, and will turn off when the pressure switch indicates that the
    system is full.
    
    :param in:  handle  the PH handle
    :param out: status Error status variable. 0 on success.
    """
def setREVPHClosedLoopControlDisabled(handle: typing.SupportsInt) -> int:
    """
    Disable Compressor.
    
    :param in:  handle  the PH handle
    :param out: status Error status variable. 0 on success.
    """
def setREVPHClosedLoopControlHybrid(handle: typing.SupportsInt, minAnalogVoltage: typing.SupportsFloat, maxAnalogVoltage: typing.SupportsFloat) -> int:
    """
    Enables the compressor in hybrid mode. This mode uses both a digital
    pressure switch and an analog pressure sensor connected to analog channel 0
    to cycle the compressor.
    
    The compressor will turn on when \\a both:
    
    - The digital pressure switch indicates the system is not full AND
    - The analog pressure sensor indicates that the pressure in the system is
    below the specified minimum pressure.
    
    The compressor will turn off when \\a either:
    
    - The digital pressure switch is disconnected or indicates that the system
    is full OR
    - The pressure detected by the analog sensor is greater than the specified
    maximum pressure.
    
    :param in:  handle  the PH handle
    :param in:  minAnalogVoltage The compressor will turn on when the analog
                pressure sensor voltage drops below this value and the pressure switch
                indicates that the system is not full.
    :param in:  maxAnalogVoltage The compressor will turn off when the analog
                pressure sensor reaches this value or the pressure switch is disconnected or
                indicates that the system is full.
    :param out: status Error status variable. 0 on success.
    """
def setREVPHCompressorConfig(handle: typing.SupportsInt, config: REVPHCompressorConfig) -> int:
    """
    Send compressor configuration to the PH.
    
    :param in:  handle  the PH handle
    :param in:  config  compressor configuration
    :param out: status Error status variable. 0 on success.
    """
def setREVPHSolenoids(handle: typing.SupportsInt, mask: typing.SupportsInt, values: typing.SupportsInt) -> int:
    """
    Sets solenoids on a PH.
    
    :param in:  handle  the PH handle
    :param in:  mask Bitmask indicating which solenoids to set. The LSB represents
                solenoid 0.
    :param in:  values Bitmask indicating the desired states of the solenoids. The
                LSB represents solenoid 0.
    :param out: status Error status variable. 0 on success.
    """
def setRelay(relayPortHandle: typing.SupportsInt, on: typing.SupportsInt) -> int:
    """
    Sets the state of a relay output.
    
    :param in:  relayPortHandle the relay handle
    :param in:  on              true for on, false for off
    :param out: status         Error status variable. 0 on success.
    """
def setSPIAutoTransmitData(port: SPIPort, dataToSend: typing_extensions.Buffer, zeroSize: typing.SupportsInt) -> int:
    """
    Sets the data to be transmitted to the device to initiate a read.
    
    :param in:  port       The number of the port to use. 0-3 for Onboard CS0-CS2,
                4 for MXP.
    :param in:  dataToSend Pointer to the data to send (Gets copied for continue
                use, so no need to keep alive).
    :param in:  dataSize   The length of the data to send.
    :param in:  zeroSize   The number of zeros to send after the data.
    :param out: status    the error code, or 0 for success
    """
def setSPIChipSelectActiveHigh(port: SPIPort) -> int:
    """
    Sets the CS Active high for a SPI port.
    
    :param in:  port The number of the port to use. 0-3 for Onboard CS0-CS2, 4 for
                MXP
    :param out: status the error code, or 0 for success
    """
def setSPIChipSelectActiveLow(port: SPIPort) -> int:
    """
    Sets the CS Active low for a SPI port.
    
    :param in:  port    The number of the port to use. 0-3 for Onboard CS0-CS2, 4
                for MXP
    :param out: status the error code, or 0 for success
    """
def setSPIHandle(port: SPIPort, handle: typing.SupportsInt) -> None:
    """
    Sets the stored handle for a SPI port.
    
    :param port:   The number of the port to use. 0-3 for Onboard CS0-CS2, 4 for
                   MXP.
    :param handle: The value of the handle for the port.
    """
def setSPIMode(port: SPIPort, mode: SPIMode) -> None:
    """
    Sets the SPI Mode.
    
    :param port: The number of the port to use. 0-3 for Onboard CS0-CS2, 4 for
                 MXP
    :param mode: The SPI mode to use
    """
def setSPISpeed(port: SPIPort, speed: typing.SupportsInt) -> None:
    """
    Sets the clock speed for the SPI bus.
    
    :param port:  The number of the port to use. 0-3 for Onboard CS0-CS2, 4 for
                  MXP
    :param speed: The speed in Hz (500KHz-10MHz)
    """
def setSerialBaudRate(handle: typing.SupportsInt, baud: typing.SupportsInt) -> int:
    """
    Sets the baud rate of a serial port.
    
    Any value between 0 and 0xFFFFFFFF may be used. Default is 9600.
    
    :param in:  handle  the serial port handle
    :param in:  baud    the baud rate to set
    :param out: status the error code, or 0 for success
    """
def setSerialDataBits(handle: typing.SupportsInt, bits: typing.SupportsInt) -> int:
    """
    Sets the number of data bits on a serial port.
    
    Defaults to 8.
    
    :param in:  handle  the serial port handle
    :param in:  bits    the number of data bits (5-8)
    :param out: status the error code, or 0 for success
    """
def setSerialFlowControl(handle: typing.SupportsInt, flow: typing.SupportsInt) -> int:
    """
    Sets the flow control mode of a serial port.
    
    Valid values are:
    0: None (default)
    1: XON-XOFF
    2: RTS-CTS
    3: DTR-DSR
    
    :param in:  handle  the serial port handle
    :param in:  flow    the mode to set (see remarks for valid values)
    :param out: status the error code, or 0 for success
    """
def setSerialParity(handle: typing.SupportsInt, parity: typing.SupportsInt) -> int:
    """
    Sets the number of parity bits on a serial port.
    
    Valid values are:
    0: None (default)
    1: Odd
    2: Even
    3: Mark - Means exists and always 1
    4: Space - Means exists and always 0
    
    :param in:  handle  the serial port handle
    :param in:  parity  the parity bit mode (see remarks for valid values)
    :param out: status the error code, or 0 for success
    """
def setSerialReadBufferSize(handle: typing.SupportsInt, size: typing.SupportsInt) -> int:
    """
    Sets the size of the read buffer.
    
    :param in:  handle  the serial port handle
    :param in:  size    the read buffer size
    :param out: status the error code, or 0 for success
    """
def setSerialStopBits(handle: typing.SupportsInt, stopBits: typing.SupportsInt) -> int:
    """
    Sets the number of stop bits on a serial port.
    
    Valid values are:
    10: One stop bit (default)
    15: One and a half stop bits
    20: Two stop bits
    
    :param in:  handle    the serial port handle
    :param in:  stopBits  the stop bit value (see remarks for valid values)
    :param out: status   the error code, or 0 for success
    """
def setSerialTimeout(handle: typing.SupportsInt, timeout: typing.SupportsFloat) -> int:
    """
    Sets the minimum serial read timeout of a port.
    
    :param in:  handle   the serial port handle
    :param in:  timeout  the timeout in milliseconds
    :param out: status  the error code, or 0 for success
    """
def setSerialWriteBufferSize(handle: typing.SupportsInt, size: typing.SupportsInt) -> int:
    """
    Sets the size of the write buffer.
    
    :param in:  handle  the serial port handle
    :param in:  size    the write buffer size
    :param out: status the error code, or 0 for success
    """
def setSerialWriteMode(handle: typing.SupportsInt, mode: typing.SupportsInt) -> int:
    """
    Sets the write mode on a serial port.
    
    Valid values are:
    1: Flush on access
    2: Flush when full (default)
    
    :param in:  handle  the serial port handle
    :param in:  mode    the mode to set (see remarks for valid values)
    :param out: status the error code, or 0 for success
    """
def setShowExtensionsNotFoundMessages(showMessage: typing.SupportsInt) -> None:
    """
    Enables or disables the message saying no HAL extensions were found.
    
    Some apps don't care, and the message create clutter. For general team code,
    we want it.
    
    This must be called before HAL_Initialize is called.
    
    This defaults to true.
    
    :param showMessage: true to show message, false to not.
    """
def setUserRailEnabled3V3(enabled: typing.SupportsInt) -> int:
    """
    Enables or disables the 3V3 rail.
    
    :param enabled: whether the rail should be enabled
    :param out:     status the error code, or 0 for success
    """
def setUserRailEnabled5V(enabled: typing.SupportsInt) -> int:
    """
    Enables or disables the 5V rail.
    
    :param enabled: whether the rail should be enabled
    :param out:     status the error code, or 0 for success
    """
def setUserRailEnabled6V(enabled: typing.SupportsInt) -> int:
    """
    Enables or disables the 6V rail.
    
    :param enabled: whether the rail should be enabled
    :param out:     status the error code, or 0 for success
    """
def setupAnalogGyro(handle: typing.SupportsInt) -> int:
    """
    Sets up an analog gyro with the proper offsets and settings for the KOP
    analog gyro.
    
    :param in:  handle the gyro handle
    :param out: status the error code, or 0 for success
    """
def shutdown() -> None:
    """
    Call this to shut down HAL.
    
    This must be called at termination of the robot program to avoid potential
    segmentation faults with simulation extensions at exit.
    """
def simPeriodicAfter() -> None:
    """
    Calls registered SimPeriodic "after" callbacks (only in simulation mode).
    This should be called after user code periodic simulation functions.
    """
def simPeriodicBefore() -> None:
    """
    Calls registered SimPeriodic "before" callbacks (only in simulation mode).
    This should be called prior to user code periodic simulation functions.
    """
def startAddressableLEDOutput(handle: typing.SupportsInt) -> int:
    """
    Starts the output.
    
    The output writes continuously.
    
    :param in:  handle the Addressable LED handle
    :param out: status the error code, or 0 for success
    """
def startSPIAutoRate(port: SPIPort, period: typing.SupportsFloat) -> int:
    """
    Sets the period for automatic SPI accumulation.
    
    :param in:  port    The number of the port to use. 0-3 for Onboard CS0-CS2, 4
                for MXP.
    :param in:  period  The accumulation period (seconds).
    :param out: status the error code, or 0 for success
    """
def startSPIAutoTrigger(port: SPIPort, digitalSourceHandle: typing.SupportsInt, analogTriggerType: AnalogTriggerType, triggerRising: typing.SupportsInt, triggerFalling: typing.SupportsInt) -> int:
    """
    Starts the auto SPI accumulator on a specific trigger.
    
    Note that triggering on both rising and falling edges is a valid
    configuration.
    
    :param in:  port                The number of the port to use. 0-3 for Onboard
                CS0-CS2, 4 for MXP.
    :param in:  digitalSourceHandle The trigger source to use (Either
                HAL_AnalogTriggerHandle or HAL_DigitalHandle).
    :param in:  analogTriggerType   The analog trigger type, if the source is an
                analog trigger.
    :param in:  triggerRising       Trigger on the rising edge if true.
    :param in:  triggerFalling      Trigger on the falling edge if true.
    :param out: status             the error code, or 0 for success
    """
def stopAddressableLEDOutput(handle: typing.SupportsInt) -> int:
    """
    Stops the output.
    
    :param in:  handle the Addressable LED handle
    :param out: status the error code, or 0 for success
    """
def stopCANPacketRepeating(handle: typing.SupportsInt, apiId: typing.SupportsInt) -> int:
    """
    Stops a repeating packet with a specific ID.
    
    This ID is 10 bits.
    
    :param in:  handle  the CAN handle
    :param in:  apiId   the ID to stop repeating (0-1023)
    :param out: status Error status variable. 0 on success.
    """
def stopNotifier(notifierHandle: typing.SupportsInt) -> int:
    """
    Stops a notifier from running.
    
    This will cause any call into HAL_WaitForNotifierAlarm to return with time =
    0.
    
    :param in:  notifierHandle the notifier handle
    :param out: status Error status variable. 0 on success.
    """
def stopSPIAuto(port: SPIPort) -> int:
    """
    Stops an automatic SPI accumulation.
    
    :param in:  port    The number of the port to use. 0-3 for Onboard CS0-CS2, 4
                for MXP.
    :param out: status the error code, or 0 for success
    """
def transactionI2C(port: I2CPort, deviceAddress: typing.SupportsInt, dataToSend: typing_extensions.Buffer, dataReceived: typing_extensions.Buffer) -> int:
    """
    Generic I2C read/write transaction.
    
    This is a lower-level interface to the I2C hardware giving you more control
    over each transaction.
    
    :param port:          The I2C port, 0 for the on-board, 1 for the MXP.
    :param deviceAddress: The address of the register on the device to be
                          read/written.
    :param dataToSend:    Buffer of data to send as part of the transaction.
    :param sendSize:      Number of bytes to send as part of the transaction.
    :param dataReceived:  Buffer to read data into.
    :param receiveSize:   Number of bytes to read from the device.
    
    :returns: 0 on success or -1 on transfer abort.
    """
def transactionSPI(port: SPIPort, dataToSend: typing_extensions.Buffer, dataReceived: typing_extensions.Buffer) -> int:
    """
    Performs an SPI send/receive transaction.
    
    This is a lower-level interface to the spi hardware giving you more control
    over each transaction.
    
    :param port:         The number of the port to use. 0-3 for Onboard CS0-CS2, 4
                         for MXP
    :param dataToSend:   Buffer of data to send as part of the transaction.
    :param dataReceived: Buffer to read data into.
    :param size:         Number of bytes to transfer. [0..7]
    
    :returns: Number of bytes transferred, -1 for error
    """
def updateNotifierAlarm(notifierHandle: typing.SupportsInt, triggerTime: typing.SupportsInt) -> int:
    """
    Updates the trigger time for a notifier.
    
    Note that this time is an absolute time relative to HAL_GetFPGATime()
    
    :param in:  notifierHandle the notifier handle
    :param in:  triggerTime    the updated trigger time
    :param out: status        Error status variable. 0 on success.
    """
def waitForInterrupt(interruptHandle: typing.SupportsInt, timeout: typing.SupportsFloat, ignorePrevious: typing.SupportsInt) -> tuple[int, int]:
    """
    Waits for the defined interrupt to occur.
    
    :param in:  interruptHandle the interrupt handle
    :param in:  timeout         timeout in seconds
    :param in:  ignorePrevious  if true, ignore interrupts that happened before
                waitForInterrupt was called
    :param out: status         Error status variable. 0 on success.
    
    :returns: the mask of interrupts that fired
    """
def waitForMultipleInterrupts(interruptHandle: typing.SupportsInt, mask: typing.SupportsInt, timeout: typing.SupportsFloat, ignorePrevious: typing.SupportsInt) -> tuple[int, int]:
    """
    Waits for any interrupt covered by the mask to occur.
    
    :param in:  interruptHandle the interrupt handle to use for the context
    :param in:  mask            the mask of interrupts to wait for
    :param in:  timeout         timeout in seconds
    :param in:  ignorePrevious  if true, ignore interrupts that happened before
                waitForInterrupt was called
    :param out: status         Error status variable. 0 on success.
    
    :returns: the mask of interrupts that fired
    """
def waitForNotifierAlarm(notifierHandle: typing.SupportsInt) -> tuple[int, int]:
    """
    Waits for the next alarm for the specific notifier.
    
    This is a blocking call until either the time elapses or HAL_StopNotifier
    gets called. If the latter occurs, this function will return zero and any
    loops using this function should exit. Failing to do so can lead to
    use-after-frees.
    
    :param in:  notifierHandle the notifier handle
    :param out: status        Error status variable. 0 on success.
    
    :returns: the FPGA time the notifier returned
    """
def writeAddressableLEDData(handle: typing.SupportsInt, data: AddressableLEDData, length: typing.SupportsInt) -> int:
    """
    Sets the led output data.
    
    If the output is enabled, this will start writing the next data cycle.
    It is safe to call, even while output is enabled.
    
    :param in:  handle the Addressable LED handle
    :param in:  data the buffer to write
    :param in:  length the strip length
    :param out: status the error code, or 0 for success
    """
def writeCANPacket(handle: typing.SupportsInt, data: typing_extensions.Buffer, apiId: typing.SupportsInt) -> int:
    """
    Writes a packet to the CAN device with a specific ID.
    
    This ID is 10 bits.
    
    :param in:  handle  the CAN handle
    :param in:  data    the data to write (0-8 bytes)
    :param in:  length  the length of data (0-8)
    :param in:  apiId   the ID to write (0-1023 bits)
    :param out: status Error status variable. 0 on success.
    """
def writeCANPacketRepeating(handle: typing.SupportsInt, data: typing_extensions.Buffer, apiId: typing.SupportsInt, repeatMs: typing.SupportsInt) -> int:
    """
    Writes a repeating packet to the CAN device with a specific ID.
    
    This ID is 10 bits.
    
    The RoboRIO will automatically repeat the packet at the specified interval
    
    :param in:  handle   the CAN handle
    :param in:  data     the data to write (0-8 bytes)
    :param in:  length   the length of data (0-8)
    :param in:  apiId    the ID to write (0-1023)
    :param in:  repeatMs the period to repeat in ms
    :param out: status  Error status variable. 0 on success.
    """
def writeCANRTRFrame(handle: typing.SupportsInt, length: typing.SupportsInt, apiId: typing.SupportsInt) -> int:
    """
    Writes an RTR frame of the specified length to the CAN device with the
    specific ID.
    
    By spec, the length must be equal to the length sent by the other device,
    otherwise behavior is unspecified.
    
    :param in:  handle   the CAN handle
    :param in:  length   the length of data to request (0-8)
    :param in:  apiId    the ID to write (0-1023)
    :param out: status  Error status variable. 0 on success.
    """
def writeI2C(port: I2CPort, deviceAddress: typing.SupportsInt, dataToSend: typing_extensions.Buffer) -> int:
    """
    Executes a write transaction with the device.
    
    Writes a single byte to a register on a device and wait until the
    transaction is complete.
    
    :param port:          The I2C port, 0 for the on-board, 1 for the MXP.
    :param deviceAddress: The address of the register on the device to be
                          written.
    :param dataToSend:    The byte to write to the register on the device.
    :param sendSize:      Number of bytes to send.
    
    :returns: 0 on success or -1 on transfer abort.
    """
def writeSPI(port: SPIPort, dataToSend: typing_extensions.Buffer) -> int:
    """
    Executes a write transaction with the device.
    
    Writes to a device and wait until the transaction is complete.
    
    :param port:       The number of the port to use. 0-3 for Onboard CS0-CS2, 4
                       for MXP
    :param dataToSend: The data to write to the register on the device.
    :param sendSize:   The number of bytes to be written
    
    :returns: The number of bytes written. -1 for an error
    """
def writeSerial(handle: typing.SupportsInt, buffer: typing_extensions.Buffer) -> tuple[int, int]:
    """
    Writes data to the serial port.
    
    :param in:  handle  the serial port handle
    :param in:  buffer  the buffer to write
    :param in:  count   the number of bytes to write from the buffer
    :param out: status the error code, or 0 for success
    
    :returns: the number of bytes actually written
    """
__hal_simulation__: bool = True
__halplatform__: str = 'sim'
_cleanup: typing.Any  # value = <capsule object>
